<?php

/**
 * Description of daoPersistRelationItem
 *
 * @author gustavo
 */
class daoPersistRelationItem {

    private $propertyName;
    private $autoInstantiate;
    private $byResultSet;
    private $joinMode;
    private $entityName;
    private $foreignKey;
    private $relKey;
    private $className;
    private $object;
    private $modeInDeepInstance;
    private $table;

    function __construct($relation) {
        
        $this->propertyName = $relation->propertyName;
        $this->autoInstantiate = $relation->autoInstantiate;
        $this->foreignKey = $relation->foreignKey;
        $this->relKey = $relation->relKey;
        $this->entityName = $relation->entityName;
        $this->className = $relation->className;
        $this->byResultSet = $relation->byResultSet;
        $this->joinMode = $relation->joinMode;
        $this->table = $relation->table;
        
        if(property_exists($relation,'modeInDeepInstance'))
            $this->modeInDeepInstance = $relation->modeInDeepInstance;
    }

    function getObject() {
        return $this->object;
    }

    function setObjectForDeepInstance($parentObj){
        $__className = $this->className;
        $obj = new $__className;
        $method = "get" . ucfirst($this->foreignKey);
        $keyValue = $parentObj->$method();

        // TODO verificar que $keyValue no sea nulo
        if ($keyValue) {

            switch ($this->modeInDeepInstance){
                case daoPersist::MODE_PLAIN:
                    $_ret = $obj->getPlainInstance($keyValue);
                    break;
                case daoPersist::MODE_DEEP:
                    $_ret = $obj->getDeepInstance($keyValue);
                    break;
                case daoPersist::MODE_AUTO:
                default:
                    $_ret = $obj->getInstance($keyValue);
                    break;
            }

            if ($_ret->getStatusResponse()->isOk()) {
                $this->object = $_ret;
            } else {
                throw msgTable::getExceptionFromTableMsgCode(msgTable::EXCEPTION_DATABASE_DAOPERSISTRELATIONS_NOTFOUND, "$__className#$keyValue");
            }
        }
    }

    function setObject($parentData, $resultSet=false) {
        
        $__className = $this->className;
        $obj = new $__className;
        
        if ($this->byResultSet) {
            if ($resultSet){
                $_ret = $obj->instantiateFromResultset($resultSet);
                $this->object = $_ret;
            } else {
                throw msgTable::getExceptionFromTableMsgCode(msgTable::EXCEPTION_DATABASE_DAOPERSISTRELATIONS_CANTINSTANTIATERESULTSET, $__className);
            }
            
        } else {
            $method = "get" . ucfirst($this->foreignKey);
            $keyValue = $parentData->$method();

            // TODO verificar que $keyValue no sea nulo y que sea mandatorio
            if ($keyValue) {
                $_ret = $obj->getInstance($keyValue);
                if ($_ret->getStatusResponse()->isOk() or $_ret->getStatusResponse()->isNotFound()) {
                    $this->object = $_ret;
                } else {            
                                        
                    $msg =  "$__className#$keyValue/$method/" . $_ret->getStatusResponse()->getStatusDetail();                
                    FB::info($msg, "daoPersistRelationItem error:");
                    throw msgTable::getExceptionFromTableMsgCode(msgTable::EXCEPTION_DATABASE_DAOPERSISTRELATIONS_NOTFOUND, $msg);
                }
            } else {
                
            }
        }
    }

    function setPropertyInParentObject($parentObject) {

        $propertyName = $this->getPropertyName();
        $method = "set" . ucfirst($propertyName);
        // existe el metodo para asignar el objeto
        if (method_exists($parentObject, $method)) {
            $_obj = $this->getObject();

            
            // el objeto existe
            if (is_object($_obj)) {
                $parentObject->$method($_obj);

            } // TODO que hacer en caso de no instanciar objeto o caso de error
        }
    }

    public function getPropertyName() { return $this->propertyName; }
    public function getAutoInstantiate() { return $this->autoInstantiate; }
    public function getEntityName() { return $this->entityName; }
    public function getForeignKey() { return $this->foreignKey; }
    public function getRelKey() { return $this->relKey; }
    public function getClassName() { return $this->className; }
    public function setPropertyName($propertyName) { $this->propertyName = $propertyName; }
    public function setAutoInstantiate($autoInstantiate) { $this->autoInstantiate = $autoInstantiate; }
    public function setEntityName($entityName) { $this->entityName = $entityName; }
    public function setForeignKey($foreignKey) { $this->foreignKey = $foreignKey; }
    public function setRelKey($relKey) { $this->relKey = $relKey; }
    public function setClassName($className) { $this->className = $className; }
    
     function getByResultSet() {
         return $this->byResultSet;
     }

     function setByResultSet($byResultSet) {
         $this->byResultSet = $byResultSet;
     }

     function getJoinMode() {
         return $this->joinMode;
     }

     function setJoinMode($joinMode) {
         $this->joinMode = $joinMode;
     }

     function isInnerJoinMode(){
         return ($this->joinMode === "innerJoin");
     }

     function isLeftJoinMode(){
         return ($this->joinMode === "leftJoin");
     }

     function getTable() {
         return $this->table;
     }

     function setTable($table) {
         $this->table = $table;
     }



}
