<?php

/**
 * Class LoginCtrl
 */
class LoginCtrl {

    const action_validateLogin = 'validateLogin';
    const action_getUserLoggedIn = 'getUserLoggedIn';
    const action_logout = 'logout';

    static public function requestAsyncAction($action) {

        switch ($action) {
            case self::action_validateLogin:
                $_ret = self::validateLoginFromPost();
                $_ret = $_ret->getJsonEncoded();
                break;

            case self::action_getUserLoggedIn:
                $_ret = statusResponse::getInstanceFromTableMsgCode(msgTable::MESSAGE_LOGIN_USUARIO_NOTLOGGED);
                if (self::isLoggedIn())
                    $_ret = statusResponse::getInstanceOk();
                $_ret = $_ret->getJsonEncoded();
                break;
                break;

            case self::action_logout:
                Sessionvars::clear();
                $_ret = statusResponse::getInstanceOk()->getJsonEncoded();
                break;

            default:
                $_ret = statusResponse::getInstanceFromTableMsgCode(msgTable::ERROR_DISPATCHER_ENTITY_NOTFOUND);
                $_ret = $_ret->getJsonEncoded();
                break;
        }
        print $_ret;
    }


    /**
     *
     * @return statusResponse
     */
    static public function validateLoginFromPost() {
        $_postvars = Secure_PostGet_Vars::get_JsonObject_Post();

        $loginName = $_postvars->frm_login_input;
        $password = $_postvars->frm_password_input;

        $_ret = self::validateCredentials($loginName, $password);

        if ($_ret->isOk()) {
                self::setUserIdPersistent(1);
        }

        return $_ret;
    }

    static public function isLoggedIn() {
        if (SessionVars::getUserId() > 0)
            return true;
        return false;
    }

    static public function setUserIdPersistent($usid) {
        SessionVars::setUserId($usid);
    }

    static public function validateCredentials($loginName, $password){
        $_loginName = appConfig::LOGIN_NAME;
        $_password = appConfig::PASSWORD;

        $loginName = strtolower($loginName);

        if($loginName === $_loginName && $password === $_password) {
            $_ret = statusResponse::getInstanceOk();
        } else {
            $_ret = statusResponse::getInstanceFromTableMsgCode(msgTable::MESSAGE_USUARIO_VALIDATECREDENTIALS_CONTRASENAINCORRECTA);
        }

        return $_ret;
    }

}