<?php

require_once 'lib/database/DAO.class.php';

class googleChart extends DAO {

    
    static protected $db;
    private $query;
    
    private $options;
    private $cols = array();
    private $rows = array();
    
    public function __construct($title) {
    	$this->options = new googleChartOptions($title);    	
    }
    
    public function addColumn($id, $label, $type, $dbField) {
    	$this->cols[$dbField] = new googleChartCol($id, $label, $type);
    }
    
    function setQuery($query) {
    	$this->query = $query;
    }
    
    
    private function executeThisQuery() {
    	$_ret = DAO::getResultsFromQuery($this->query);
    
    	if ($_ret >= 0) {
    		$this->cursor = DAO::getCursor();
    	} else {
    		echo "Error";
    	}
    }    
    
    
    /*
    $scope.chartObject.data = {"cols": [
    {id: "t", label: "Topping", type: "string"},
    {id: "s", label: "Slices", type: "number"}
    ], "rows": [
    {c: [
    {v: "Mushrooms"},
    {v: 3},
    ]},
    {c: $scope.onions},
    {c: [
    {v: "Olives"},
    {v: 31}
    ]},
    {c: [
    {v: "Zucchini"},
    {v: 1},
    */
    
    private function getCalculatedData() {
    
    	$this->calculatedData = true;
    	$this->executeThisQuery();
    
    	$_row = DAO::getNextRow();
    	$_ret = array();
    
    	while ($_row) {
    		
    		
    		
    		$_values = array();
    		foreach ($this->cols  as $field=>$column) {
				    			
    			$_values[] = new googleChartRow($_row[$field], $column->getType());    			 
    		}
    			
    		$_ret[] = array("c"=>$_values);
    			    
    		$_row = DAO::getNextRow();
    	}
    	
    	return $_ret;
    	 
    }
    
    function getCols() {
    	$_ret = array();
    	foreach ($this->cols as $field=>$col){
    		$_ret[]=$col->toArray();
    	}
    	return $_ret;
    }
    
    function getOptions() {
    	return $this->options;
    }
    
    function getData() {
    		
    		$_ret = array ("cols"=>$this->getCols(),"rows"=> $this->getCalculatedData(), "options"=>$this->getOptions());
    		return $_ret;
    }
    
    
    
    
}

class googleChartCol {
	
	private $id;
	private $label;
	private $type;
	
	public function __construct($id, $label, $type="string") {
		$this->id =$id;
		$this->label = $label;
		$this->type = $type;
	}
	
	public function toArray() {
		return array("id"=>$this->id, "label"=>$this->label, "type"=>$this->type);
	}
	
	public function getType() {
		return $this->type;
	}
}

class googleChartRow {

 	var $v;
	
	public function __construct($v, $type) {
		if ($type=="number")
			$this->v = floatval($v);
		else
			$this->v = $v;		
	}


}

class googleChartOptions {

	private $title;
	


	public function __construct($title) {
		$this->title =$title;		
	}

	public function toArray() {
		return array("title"=>$this->title);
	}

}


    
?>