<?php

require_once 'lib/customlib/customMessage/msgTableJson.php';

/**
 * Description of msgTable
 *
 * @author gustavo
 */
class msgTable {
    
    const ERROR_DATABASE_CONNECTION_NOTCONNECTED = "ERROR.DATABASE.CONNECTION.NOTCONNECTED";
    const ERROR_DATABASE_CONNECTION_NOTCONNECTED_USER_PW_INCORRECT = "ERROR.DATABASE.CONNECTION.NOTCONNECTED_USER_PW_INCORRECT";
    const ERROR_DATABASE_DAOPERSIST_NOTFOUND = "ERROR.DATABASE.DAOPERSIST.NOTFOUND";
    const ERROR_DATABASE_DAOPERSIST_NOTINSERT = "ERROR.DATABASE.DAOPERSIST.NOTINSERT";
    const ERROR_DATABASE_DAOPERSIST_NOTUPDATE = "ERROR.DATABASE.DAOPERSIST.NOTUPDATE";
    const ERROR_DATABASE_DAOPERSIST_NOTDELETE = "ERROR.DATABASE.DAOPERSIST.NOTDELETE";
    const ERROR_DATABASE_DAOPERSIST_NOTPERSIST = "ERROR.DATABASE.DAOPERSIST.NOTPERSIST";
    const ERROR_DATABASE_DAOPERSIST_NODATASTRUCURE4ENTITY = "ERROR.DATABASE.DAOPERSIST.NODATASTRUCTURE4ENTITY";
    const ERROR_DATABASE_DAOPERSIST_NOTUNIQUERESULT = "ERROR.DATABASE.DAOPERSIST.NOT_UNIQUE_RESULT";
    const ERROR_DATABASE_DAOPERSIST_NORESULT = "ERROR.DATABASE.DAOPERSIST.NO_RESULT";

    const ERROR_DISPATCHER_ENTITY_NOTFOUND = "ERROR.DISPATCHER.ENTITY.NOTFOUND";

    const ERROR_ENTITY_PERSIST_FAIL = "ERROR.ENTITY.PERSIST.NOTSAVE";
    const ERROR_ENTITY_UPDATE_FAIL = "ERROR.ENTITY.UPDATE.NOTSAVE";
    const ERROR_ENTITY_DELETE_FAIL = "ERROR.ENTITY.DELETE.NOTSAVE";
    const ERROR_ENTITY_ID_NOTFOUND = "ERROR.ENTITY.ID.NOTFOUND";
    const ERROR_ENTITY_INSTANTIATE_NOTFOUND = "ERROR.ENTITY.INSTANTIATE.NOTFOUND";
    const ERROR_ENTITY_AUTOCOMPLETE_FAIL = "ERROR.ENTITY.AUTOCOMPLETE.FAIL";
    const ERROR_ENTITY_SETRELATION_FAIL = "ERROR.ENTITY.SET_RELATION.FAIL";

    const EXCEPTION_CLASSLOADER_CLASSNOTFOUND = "EXCEPTION.CLASS_LOADER.CLASS_NOT_FOUND";
    const EXCEPTION_CLASSLOADER_NOENTRYFORCLASS = "EXCEPTION.CLASS_LOADER.NO_ENTRY_FOR_CLASS";
    const EXCEPTION_DATABASE_DAOPERSISTRELATIONS_NOTFOUND = "EXCEPTION.DATABASE.DAOPERSIST_RELATIONS.NOTFOUND";
    const EXCEPTION_DATABASE_DAOPERSISTRELATIONS_CANTINSTANTIATERESULTSET = "EXCEPTION.DATABASE.DAOPERSIST_RELATIONS.CANT_INSTANTIATE_RESULTSET";
    const EXCEPTION_DATABASE_DAO2_CONNECTIONFAIL = "EXCEPTION.DATABASE.DAO2.CONNECTION_FAIL";
    const EXCEPTION_DATABASE_DAO2_TRANSACTIONNOTSUPORTED = "EXCEPTION.DATABASE.DAO2.TRANSACTION_NOT_SUPORTED";
    
    /************** CUSTOM MESSAGES/ERROR **************/

    const MESSAGE_LOGIN_USUARIO_SINACCESSO = "MESSAGE.LOGIN.USUARIO.SIN_ACCESSO";
    const MESSAGE_LOGIN_USUARIO_NOTLOGGED = "MESSAGE.LOGIN.USUARIO.NOT_LOGGED";
    const MESSAGE_USUARIO_VALIDATECREDENTIALS_CONTRASENAINCORRECTA = "MESSAGE.USUARIO.VALIDATE_CREDENTIALS.CONTRASENA_INCORRECTA";

    protected static $table = 'lib';
    protected static $msg_table;

    static public function getMsgItem($code) {
        if (self::$msg_table === null or self::$table !== 'lib')
            self::getMsgTable();
        return self::getMsgFromCode($code);
    }
    
    static protected function getMsgFromCode($code){
        $code = strtolower($code);
        $path = split("\.", $code);
        $ret = self::$msg_table;

        foreach ($path as $key) {
            if (!$key) break;
            $ret = $ret->$key;
        }

        $ret->segment = $code;
        return $ret;
    }
    
    static private function getMsgTable() {
        self::$table = 'lib';
        self::$msg_table = msgTableJson::getMsgTable();
        if (!self::$msg_table) throw new Exception("No se encontro la tabla de mensajes");
    }
    

    /**
     * Retorna un excepcion intanciado con el mensaje obtenido a partir del codigo
     *
     * @param $code
     * @param $data
     * @return Exception
     */
    static public function getExceptionFromTableMsgCode($code, $data=null) {
        $_msg = self::getMsgItem($code);
        $_detail = $_msg->detail;
        if($data)
             $_detail .= $data;
        $_ret = new Exception($_detail, $_msg->code);
        return $_ret;
    }


}
    

