<?php

    /*
     * To change this license header, choose License Headers in Project Properties.
     * To change this template file, choose Tools | Templates
     * and open the template in the editor.
     */

require_once 'lib/customlib/customMessage/statusResponse.php';
require_once 'lib/customlib/autoloader/Autoloader.php';
require_once 'ActionDispatcherJson.php';
require_once 'classes/business/login/LoginCtrl.php';
require_once 'classes/business/modal_administrable/ModalAdministrable.php';
require_once 'classes/business/modal_administrable/ModalAdministrableCtrl.php';


    /**
     * Description of DispatcheAction
     *
     * @author pc1
     */
class ActionDispatcher {

    const entity_action_list = "list";
    const entity_action_getInstance = "instantiate";
    const entity_action_update = "update";
    const entity_action_delete = "delete";

    static private $dispatchData;
    
    private $action;
    private $params;
        

    public function __construct($dispatcher = "", $action = "", $params = false) {
        $this->action = $action;
        $this->params = $params;

        self::$dispatchData = ActionDispatcherJson::getDispatcherDataFor($dispatcher);
    }

    public function performAction() {

        $ctrl = null;
                
        try {
            $_className = self::$dispatchData->getClassName();

            if ($_className) {

                Autoloader::AutoloadRegister();

                $ctrl = new $_className();

                if (is_object($ctrl))
                    $ctrl->requestAsyncAction($this->action, $this->params);
            } else {

                $_ret = statusResponse::getInstanceFromTableMsgCode(msgTable::ERROR_DISPATCHER_ENTITY_NOTFOUND);
                print $_ret->getJsonEncoded();
            }
        } catch (Exception $e) {

            $_ret = statusResponse::getInstanceFromException($e); 
            print $_ret->getJsonEncoded();
            
        } //finally {

          //  Autoloader::AutoloadUnregister();
        //}
    }

}
