<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of ImageProccess
 *
 * @author guillermo
 */
class CustomImage {

    private $width = 0;
    private $height = 0;
    private $name = "";
    private $backgroundColor = "white";
    private $path = "";

    public function CustomImage() {
        
    }

    public function setWhidth($width) {
        $this->width = $width;
    }

    public function setHeight($height) {
        $this->height = $height;
    }

    public function setName($name) {
        $this->name = $name;
    }

    public function setBackgroundColor($color) {
        $this->backgroundColor = $color;
    }

    public function setPath($path) {
        $this->path = $path;
    }

    public function getWhidth() {
        return $this->width;
    }

    public function getHeight() {
        return $this->height;
    }

    public function getName() {
        return $this->name;
    }

    public function getBackgroundColor() {
        return $this->backgroundColor;
    }

    public function getPath() {
        return $this->path;
    }

    /**
     * Instancia un CustomImage a partir de una imagen existente en $imgOriPath
     * @param string $imgOriPath
     * @param boll $fromUrl
     * @return CustomImage
     */
    static public function setByImg($imgOriPath, $fromUrl = false) {
        $_img = new CustomImage();
        if ($fromUrl) {
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_POST, 0);
            curl_setopt($ch, CURLOPT_URL, str_replace(" ", "%20", $imgOriPath));
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 30);
            curl_setopt($ch, CURLOPT_TIMEOUT, 30);
            $result = curl_exec($ch);
            curl_close($ch);
            $_name = basename($imgOriPath);
            $_name = str_replace("-", "", $_name);
            if (strpos($_name, "?")) {
                $_name = substr($_name, 0, strpos($_name, "?"));
            }
            $fp = fopen("/tmp/" . $_name, "w");
            fputs($fp, $result);
            fclose($fp);
            $datos = getimagesize("/tmp/" . $_name);
            $path = "/tmp/";
        } else {
            $_path_arr = explode("/", $imgOriPath);
            $_filename = explode(".", $_path_arr[count($_path_arr) - 1]);
            $_extension = $_filename[1];

            switch (strtolower($_extension)) {
                case "jpg":
                    $_img->data = imagecreatefromjpeg($imgOriPath);
                    break;
                case "png":
                    $_img->data = imagecreatefrompng($imgOriPath);
                    break;
                case "gif":
                    $_img->data = imagecreatefromgif($imgOriPath);
                    break;
                default :
                    return false;
            }

            $datos = getimagesize($imgOriPath);
            $path = pathinfo($imgOriPath);
            $path = $path["dirname"] . "/";
            $_name = basename($imgOriPath);
        }

        $_img->path = $path;
        $_img->height = $datos[1];
        $_img->width = $datos[0];
        $_img->name = $_name;
        return $_img;
    }

    public function writeImg($destPath) {

        $_img = imagecreatetruecolor($this->width, $this->height);
        imagecopyresampled($_img, $this->data, 0, 0, 0, 0, $this->width, $this->height, $this->width, $this->height);
        imagejpeg($_img, $destPath . $this->name, 300);
    }

    /**
     * Crea una imagen nueva a partir de una ya instanciada, en caso de exito devuelve la imagen, sino devuelve false
     * @param CustomImage $imgDest
     * @return CustomImage
     */
    public function generateResizeImg(CustomImage $imgDest) {
        //Si esta disponible la extension magickwand uso esa, sino utilizo la libreria GD2
        if (function_exists("NewMagickWand")) {
            $resource = NewMagickWand();
            $dwand = NewDrawingWand();
            $pwand = NewPixelWand();
            $mw1 = NewMagickWand();
            $bgw1 = NewPixelWand($this->backgroundColor);
            //Genero el fondo de la imágen
            MagickNewImage($mw1, $imgDest->getWhidth(), $imgDest->getHeight(), $bgw1);
            if (MagickReadImage($resource, $this->getPath() . $this->getName())) {

                MagickSetImageCompressionQuality($resource, 100);

                $_dest_size = $imgDest->getWhidth() . "x" . $imgDest->getHeight();

                //Achico la imágen
                $resource = MagickTransformImage($resource, '0x0', $_dest_size);
                $width = MagickGetImageWidth($resource);
                $height = MagickGetImageHeight($resource);

                if ($width > $height) {
                    $_init_copy = ($imgDest->getHeight() / 2) - ($height / 2);
                    MagickCompositeImage($mw1, $resource, MW_OverCompositeOp, 0, $_init_copy);
                } else {
                    $_init_copy = ($imgDest->getWhidth() / 2) - ($width / 2);
                    MagickCompositeImage($mw1, $resource, MW_OverCompositeOp, $_init_copy, 0);
                }
                //Resalto la imágen
                MagickSharpenImage($mw1, 1, 20);
                MagickSetImageFormat($mw1, 'JPEG');

                if (MagickWriteImage($mw1, websiteDomain::getPathBase() . $imgDest->getPath() . $imgDest->getName())) {
                    return $imgDest->getName();
                } else {
                    return false;
                }
            } else {
                return false;
            }
        } else {
            $_filename = explode(".", $this->getName());
            $_extension = $_filename[1];

            switch (strtolower($_extension)) {
                case "jpg":
                    $img = imagecreatefromjpeg($this->getPath() . $this->getName());
                    break;
                case "png":
                    $img = imagecreatefrompng($this->getPath() . $this->getName());
                    break;
                case "gif":
                    $img = imagecreatefromgif($this->getPath() . $this->getName());
                    break;
                default :
                    return false;
            }

            if ($img === false) {
                return false;
            }
            if ($this->height > $imgDest->getHeight()) {
                if ($this->width > $this->height) {
                    $ratio = ($this->width / $imgDest->getWhidth());
                } else {
                    $ratio = ($this->height / $imgDest->getHeight());
                }
            } elseif ($this->width > $imgDest->getWhidth()) {
                $ratio = ($this->width / $imgDest->getWhidth());
            } else {
                $ratio = 1;
            }


            $thumb = imagecreatetruecolor($imgDest->getWhidth(), $imgDest->getHeight());
            $bgArray = explode(" ", $imgDest->getBackgroundColor());
            $bg = imagecolorallocate($thumb, $bgArray[0], $bgArray[1], $bgArray[2]);
            imagefill($thumb, 0, 0, $bg);

            // echo "original:".$this->getWhidth()."x".$this->getHeight();
            // echo "destino:".$imgDest->getWhidth()."x".$imgDest->getHeight();
            //    echo $ratio;
            if ($imgDest->getHeight() > $this->getHeight() && $imgDest->getWhidth() > $this->getWhidth()) {

                $inicioW = ($imgDest->getWhidth() / 2) - ($this->getWhidth() / 2);
                $inicioH = ($imgDest->getHeight() / 2) - ($this->getHeight() / 2);
                $height = $this->getHeight();
                $width = $this->getWhidth();
            } elseif ($imgDest->getHeight() < $this->getHeight() || $imgDest->getWhidth() < $this->getWhidth()) {
                $inicioW = ($imgDest->getWhidth() / 2) - ($this->getWhidth() / $ratio / 2);
                $inicioH = ($imgDest->getHeight() / 2) - ($this->getHeight() / $ratio / 2);
                $height = $this->getHeight() / $ratio;
                $width = $this->getWhidth() / $ratio;
            } else {

                $inicioW = 0;
                $inicioH = 0;
                $height = $this->getHeight();
                $width = $this->getWhidth();
            }
            // con esta función la reescalamos
            imagecopyresampled($thumb, $img, $inicioW, $inicioH, 0, 0, $width, $height, $this->getWhidth(), $this->getHeight());

            // La salvamos con el nombre y en el lugar que nos interesa.
            // imagefilter($thumb, IMG_FILTER_PIXELATE,2,true);
            $_ret = imagejpeg($thumb, websiteDomain::getPathBase() . $imgDest->getPath() . $imgDest->getName(), 300);
            if ($_ret === false) {
                return false;
            } else {
                return $imgDest->getName();
            }
        }
    }

}

?>
