<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of Secure_PostGet_Vars
 *
 * @author gustavo
 */
abstract class Secure_PostGet_Vars {
    // static private $regexp = "|[a-z A-Z 0-9 \|+\| \|_\|,\|.\|:\|@\|?[-]]{0,}|";

    const GET_VAR_ACTION = "action";
    const GET_VAR_VIEW = "view";

    static private $regexp = "|[a-z A-Z 0-9 \|+\|\n\|\t\|\|_\|,\|/\|.\|:\|#\|@\|?\|*\|\d{2}%\|\|\p{L}.$[-]]{0,}|";
    

    static public function get_Post($variable) {

        $value = $_POST[$variable];
        preg_match_all(Secure_PostGet_Vars::$regexp, $value, $salida, PREG_PATTERN_ORDER);

        foreach ($salida[0] as $val) {
            $res .= $val;
        }
        return $res;
    }

    static public function get_Get($variable) {

        $value = $_GET[$variable];        
        preg_match_all(Secure_PostGet_Vars::$regexp, $value, $salida, PREG_PATTERN_ORDER);

        foreach ($salida[0] as $val) {
            $res .= $val;
        }
        return $res;
    }
    
    
    static public function get_JsonObject_Post() {
    	$postdata = file_get_contents("php://input");
    	$request = json_decode($postdata);
    	return $request;
    }
    

   

    /**
     * getAction, retorna valor de $_GET del action
     * @return String, value of action $_GET var
     */
    static public function getAction() {
        return Secure_PostGet_Vars::get_Post(Secure_PostGet_Vars::GET_VAR_ACTION);
    }

    /**
     * getAction, retorna valor de $_GET del view
     * @return String, value of action $_GET var
     */
    static public function getView() {
        return Secure_PostGet_Vars::get_Get(Secure_PostGet_Vars::GET_VAR_VIEW);
    }
    
    /**
     * Devuelve un objeto con los caracteres filtrados
     * @param Object|Array $obj
     * @return stdClass 
     */
    static private function getSecureObject($obj){
        $ret = NULL;
        
        if(gettype($obj) == 'array' || gettype($obj) == 'object'){
            $ret = new stdClass();
            foreach ($obj as $key => $value ){
                $key_safe = NULL; 
                $value_safe = NULL;
                
                preg_match_all(Secure_PostGet_Vars::$regexp, $key, $salida, PREG_PATTERN_ORDER);
                foreach ($salida[0] as $val) {$key_safe .= $val;}
                
                if(gettype($value) == 'string'){
                    preg_match_all(Secure_PostGet_Vars::$regexp, $value, $salida, PREG_PATTERN_ORDER);
                    foreach ($salida[0] as $val) {$value_safe .= $val;}
                }else
                    $value_safe = self::getSecureObject ($value);
                
                $ret->$key_safe = $value_safe;
            }
        }
        return $ret;
    }
    
}

?>
