/*!
 * 
 * Angle - Bootstrap Admin App + AngularJS
 * 
 * Version: 3.0.0
 * Author: @themicon_co
 * Website: http://themicon.co
 * License: https://wrapbootstrap.com/help/licenses
 * 
 */

// APP START
// ----------------------------------- 

(function() {
    'use strict';

    angular
        .module('angle', [
            'app.core',
            'app.routes',
            'app.sidebar',
            //'app.navsearch',
            //'app.preloader',
            //'app.loadingbar',
            'app.translate',
            'app.settings',
            'app.utils'
        ]);
})();


(function() {
    'use strict';

    angular
        .module('app.colors', []);
})();
(function() {
    'use strict';

    angular
        .module('app.core', [
            'ngRoute',
            'ngAnimate',
            'ngStorage',
            'ngCookies',
            'pascalprecht.translate',
            'ui.bootstrap',
            'ui.router',
            'oc.lazyLoad',
            'cfp.loadingBar',
            'ngSanitize',
            'ngResource',
            'ui.utils'
        ]);
})();
(function() {
    'use strict';

    angular
        .module('app.lazyload', []);
})();
(function() {
    'use strict';

    angular
        .module('app.loadingbar', []);
})();
(function() {
    'use strict';

    angular
        .module('app.navsearch', []);
})();
(function() {
    'use strict';

    angular
        .module('app.pages', ["ngRoute"]);
})();

(function() {
    'use strict';

    angular
        .module('app.preloader', []);
})();


(function() {
    'use strict';

    angular
        .module('app.routes', [
            'app.lazyload'
        ]);
})();
(function() {
    'use strict';

    angular
        .module('app.settings', []);
})();
(function() {
    'use strict';

    angular
        .module('app.sidebar', []);
})();
(function() {
    'use strict';

    angular
        .module('app.translate', []);
})();
(function() {
    'use strict';

    angular
        .module('app.utils', [
          'app.colors'
          ]);
})();

(function() {
    'use strict';

    angular
        .module('app.colors')
        .constant('APP_COLORS', {
          'primary':                '#5d9cec',
          'success':                '#27c24c',
          'info':                   '#23b7e5',
          'warning':                '#ff902b',
          'danger':                 '#f05050',
          'inverse':                '#131e26',
          'green':                  '#37bc9b',
          'pink':                   '#f532e5',
          'purple':                 '#7266ba',
          'dark':                   '#3a3f51',
          'yellow':                 '#fad732',
          'gray-darker':            '#232735',
          'gray-dark':              '#3a3f51',
          'gray':                   '#dde6e9',
          'gray-light':             '#e4eaec',
          'gray-lighter':           '#edf1f2'
        })
        ;
})();
/**=========================================================
 * Module: colors.js
 * Services to retrieve global colors
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.colors')
        .service('Colors', Colors);

    Colors.$inject = ['APP_COLORS'];
    function Colors(APP_COLORS) {
        this.byName = byName;

        ////////////////

        function byName(name) {
          return (APP_COLORS[name] || '#fff');
        }
    }

})();

(function() {
    'use strict';

    angular
        .module('app.core')
        .config(coreConfig);

    coreConfig.$inject = ['$controllerProvider', '$compileProvider', '$filterProvider', '$provide'];
    function coreConfig($controllerProvider, $compileProvider, $filterProvider, $provide){
      
      var core = angular.module('app.core');
      // registering components after bootstrap
      core.controller = $controllerProvider.register;
      core.directive  = $compileProvider.directive;
      core.filter     = $filterProvider.register;
      core.factory    = $provide.factory;
      core.service    = $provide.service;
      core.constant   = $provide.constant;
      core.value      = $provide.value;

    }

})();
/**=========================================================
 * Module: constants.js
 * Define constants to inject across the application
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.core')
        .constant('APP_MEDIAQUERY', {
          'desktopLG':             1200,
          'desktop':                992,
          'tablet':                 768,
          'mobile':                 480
        })
      ;

})();
(function() {
    'use strict';

    angular
        .module('app.core')
        .run(appRun);

    appRun.$inject = ['$rootScope', '$state', '$stateParams',  '$window', '$templateCache', 'Colors'];
    
    function appRun($rootScope, $state, $stateParams, $window, $templateCache, Colors) {
      
      // Set reference to access them from any scope
      $rootScope.$state = $state;
      $rootScope.$stateParams = $stateParams;
      $rootScope.$storage = $window.localStorage;

      // Uncomment this to disable template cache
      /*$rootScope.$on('$stateChangeStart', function(event, toState, toParams, fromState, fromParams) {
          if (typeof(toState) !== 'undefined'){
            $templateCache.remove(toState.templateUrl);
          }
      });*/

      // Allows to use branding color with interpolation
      // {{ colorByName('primary') }}
      $rootScope.colorByName = Colors.byName;

      // cancel click event easily
      $rootScope.cancel = function($event) {
        $event.stopPropagation();
      };

      // Hooks Example
      // ----------------------------------- 

      // Hook not found
      $rootScope.$on('$stateNotFound',
        function(event, unfoundState/*, fromState, fromParams*/) {
            console.log(unfoundState.to); // "lazy.state"
            console.log(unfoundState.toParams); // {a:1, b:2}
            console.log(unfoundState.options); // {inherit:false} + default options
        });
      // Hook error
      $rootScope.$on('$stateChangeError',
        function(event, toState, toParams, fromState, fromParams, error){
          console.log('stateChangeError',error);
        if (! status.authenticated) {
            $state.go('page.login');
        }
        });
      // Hook success
      $rootScope.$on('$stateChangeSuccess',
        function(/*event, toState, toParams, fromState, fromParams*/) {
          // display new view from top
          $window.scrollTo(0, 0);
          // Save the route title
          $rootScope.currTitle = $state.current.title;
        });

      // Load a title dynamically
      $rootScope.currTitle = $state.current.title;
      $rootScope.pageTitle = function() {
        var title = $rootScope.app.name + ' - ' + ($rootScope.currTitle || $rootScope.app.description);
        document.title = title;
        return title;
      };      

    }

})();


(function() {
    'use strict';

    angular
        .module('app.lazyload')
        .config(lazyloadConfig);

    lazyloadConfig.$inject = ['$ocLazyLoadProvider', 'APP_REQUIRES'];
    function lazyloadConfig($ocLazyLoadProvider, APP_REQUIRES){

      // Lazy Load modules configuration
      $ocLazyLoadProvider.config({
        debug: false,
        events: true,
        modules: APP_REQUIRES.modules
      });

    }
})();
(function() {
    'use strict';

    angular
        .module('app.lazyload')
        .constant('APP_REQUIRES', {
          // jQuery based and standalone scripts
          scripts: {
            'modernizr':          ['vendor/modernizr/modernizr.js'],
            'icons':              ['vendor/fontawesome/css/font-awesome.min.css',
                                   'vendor/simple-line-icons/css/simple-line-icons.css'],
          'loaders.css':          ['vendor/loaders.css/loaders.css'],
          'spinkit':              ['vendor/spinkit/css/spinkit.css']
          },

          // Angular based script (use the right module name)
          modules: [
              {name: 'toaster', files: ['vendor/angularjs-toaster/toaster.js', 'vendor/angularjs-toaster/toaster.css']},
              {   name: 'ui.grid', files: ['vendor/angular-ui-grid/ui-grid.min.css', 'vendor/angular-ui-grid/ui-grid.js']
              },
              {   name: 'oitozero.ngSweetAlert', files: ['vendor/sweetalert/dist/sweetalert.css',
                      'vendor/sweetalert/dist/sweetalert.min.js',
                      'vendor/angular-sweetalert/SweetAlert.js']
              }

          ]
        })
        ;

})();

(function() {
    'use strict';

    angular
        .module('app.loadingbar')
        .config(loadingbarConfig)
        ;
    loadingbarConfig.$inject = ['cfpLoadingBarProvider'];
    function loadingbarConfig(cfpLoadingBarProvider){
      cfpLoadingBarProvider.includeBar = true;
      cfpLoadingBarProvider.includeSpinner = false;
      cfpLoadingBarProvider.latencyThreshold = 500;
      cfpLoadingBarProvider.parentSelector = '.wrapper > section';
    }
})();
(function() {
    'use strict';

    angular
        .module('app.loadingbar')
        .run(loadingbarRun)
        ;
    loadingbarRun.$inject = ['$rootScope', '$timeout', 'cfpLoadingBar'];
    function loadingbarRun($rootScope, $timeout, cfpLoadingBar){

      // Loading bar transition
      // ----------------------------------- 
      var thBar;
      $rootScope.$on('$stateChangeStart', function() {
          if($('.wrapper > section').length) // check if bar container exists
            thBar = $timeout(function() {
              cfpLoadingBar.start();
            }, 0); // sets a latency Threshold
      });
      $rootScope.$on('$stateChangeSuccess', function(event) {
          event.targetScope.$watch('$viewContentLoaded', function () {
            $timeout.cancel(thBar);
            cfpLoadingBar.complete();
          });
      });

    }

})();
/**=========================================================
 * Module: navbar-search.js
 * Navbar search toggler * Auto dismiss on ESC key
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.navsearch')
        .directive('searchOpen', searchOpen)
        .directive('searchDismiss', searchDismiss);

    //
    // directives definition
    // 
    
    function searchOpen () {
        var directive = {
            controller: searchOpenController,
            restrict: 'A'
        };
        return directive;

    }

    function searchDismiss () {
        var directive = {
            controller: searchDismissController,
            restrict: 'A'
        };
        return directive;
        
    }

    //
    // Contrller definition
    // 
    
    searchOpenController.$inject = ['$scope', '$element', 'NavSearch'];
    function searchOpenController ($scope, $element, NavSearch) {
      $element
        .on('click', function (e) { e.stopPropagation(); })
        .on('click', NavSearch.toggle);
    }

    searchDismissController.$inject = ['$scope', '$element', 'NavSearch'];
    function searchDismissController ($scope, $element, NavSearch) {
      
      var inputSelector = '.navbar-form input[type="text"]';

      $(inputSelector)
        .on('click', function (e) { e.stopPropagation(); })
        .on('keyup', function(e) {
          if (e.keyCode === 27) // ESC
            NavSearch.dismiss();
        });
        
      // click anywhere closes the search
      $(document).on('click', NavSearch.dismiss);
      // dismissable options
      $element
        .on('click', function (e) { e.stopPropagation(); })
        .on('click', NavSearch.dismiss);
    }

})();


/**=========================================================
 * Module: nav-search.js
 * Services to share navbar search functions
 =========================================================*/
 
(function() {
    'use strict';

    angular
        .module('app.navsearch')
        .service('NavSearch', NavSearch);

    function NavSearch() {
        this.toggle = toggle;
        this.dismiss = dismiss;

        ////////////////

        var navbarFormSelector = 'form.navbar-form';

        function toggle() {
          var navbarForm = $(navbarFormSelector);

          navbarForm.toggleClass('open');
          
          var isOpen = navbarForm.hasClass('open');
          
          navbarForm.find('input')[isOpen ? 'focus' : 'blur']();
        }

        function dismiss() {
          $(navbarFormSelector)
            .removeClass('open') // Close control
            .find('input[type="text"]').blur() // remove focus
            .val('') // Empty input
            ;
        }        
    }
})();

/**=========================================================
 * Module: access-login.js
 * Demo for login api
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.pages')
        .controller('LoginFormController', LoginFormController)
        .controller('LogoutFormController', LogoutFormController);

    LoginFormController.$inject = ['$state','authenticationSvc'];
    function LoginFormController($state, authenticationSvc) {        
        
        var vm = this;
        
        activate();

        ////////////////

        function activate() {
          // bind here all data from the form
          vm.account = {};
          // place the message if something goes wrong
          vm.authMsg = '';

          vm.login = function() {
            vm.authMsg = '';
            
            var params = {};
            params.frm_login_input= vm.account.email;
            params.frm_password_input = vm.account.password;

            if(vm.loginForm.$valid) {            	            
            	authenticationSvc.login(vm.account.email, vm.account.password)
                .then(function(response) {
                			if ( response.statusCode === 200 ) {
                				$state.go('app.singleview');
                			} else {
                				vm.authMsg = response.statusMsg + "(" + response.statusCode + ")";
                			}
                		}, function(error) {
                			vm.authMsg = 'Server Request Error';
                            });
            } else {
              // set as dirty if the user click directly to login so we show the validation messages
              /*jshint -W106*/
              vm.loginForm.account_email.$dirty = true;
              vm.loginForm.account_password.$dirty = true;
            }
          };
        }
    }
    
    LogoutFormController.$inject = ['$state','authenticationSvc'];
    function LogoutFormController($state, authenticationSvc) {
        
    	var vm = this;
    	
    	activate();
    	
    	function activate() {
            authenticationSvc.logout();            
            $state.go('page.login');    		
    	}
    	
    }
    
    
})();

/**=========================================================
 * Module: access-recover.js
 * Demo for register account api
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.pages')
        .controller('RecoverFormController', RecoverFormController)
        .controller('ChangePasswordFormController', ChangePasswordFormController);    
        
    RecoverFormController.$inject = ['$state','XhrEntity'];
    function RecoverFormController($state ,XhrEntity) {
        var vm = this;
        
        activate();

        ////////////////

        function activate() {
          // bind here all data from the form
          vm.recover = {};
          // place the message if something goes wrong
          vm.authMsg = '';
            
          vm.resetPassword = function() {
            vm.authMsg = '';

            if(vm.recoverForm.$valid) {
                vm.recover.vigencia = moment().add(1,'days').format("DD/MM/YYYY HH:mm");                
                XhrEntity.setEntity('RecuperoPassword');
                XhrEntity.postAction('recuperarPassword', vm.recover, function(err, response){
                    alert("Te enviamos un email con las indicaciones. Por favor, revisa tu casilla de correo.");
                    $state.go('page.login');
                });
            }else {
              // set as dirty if the user click directly to login so we show the validation messages
              /*jshint -W106*/
              vm.recoverForm.email.$dirty = true;
              vm.recoverForm.email.$invalid = true;
            }
          };
        }
    };
    
    ChangePasswordFormController.$inject = ['$state','XhrEntity'];
    function ChangePasswordFormController($state, XhrEntity) {
        var vm = this;
        // bind here all data from the form
        vm.recover = {};
        // place the message if something goes wrong
        vm.authMsg = '';
        
        vm.changePassword = function() {
            vm.authMsg = '';
            
            if(vm.recoverForm.$valid) {
                vm.recover.token = vm.token;                              
                XhrEntity.setEntity('RecuperoPassword');
                XhrEntity.postActionPromise('cambiarPassword', vm.recover)
                .then(function(response){
                    console.log(response);
                    if(response.statusCode === 200){
                        alert("Se ha efectuado el cambio de contraseña.");
                        $state.go('page.login');
                    }else if(response.statusCode === 505){
                        vm.recover.password = "";
                        vm.recover.repassword = "";
                    }else{
                        alert("No de ha podido efectuar el cambio de contraseña.");
                        $state.go('page.login');    
                    }
                },function(){
                    alert("No de ha podido efectuar el cambio de contraseña.");
                    $state.go('page.login');
                });
            }
            else {
                // set as dirty if the user click directly to login so we show the validation messages
                /*jshint -W106*/
                vm.recoverForm.password.$dirty = true;
                vm.recoverForm.repassword.$dirty = true;
            }
        };
        
        activate();
        
        ////////////////

        function activate() {
            vm.token = $state.params.token;
            XhrEntity.setEntity('RecuperoPassword');
            XhrEntity.getActionPromise("getTokenAccess&token="+vm.token)
            .then(function(response){
                if (response.statusCode === 200)
                    if(!response.statusDetail){
                        alert(response.customMessage);
                        $state.go('page.login');
                    }
            },function(){
                alert("Error al procesar la consulta.")
                $state.go('page.login');
            })
         
        }
    };
    
})();

/**=========================================================
 * Module: access-register.js
 * Demo for register account api
 =========================================================*/

(function () {
    'use strict';

    angular
            .module('app.pages')
            .controller('RegisterFormController', RegisterFormController)
            .directive('loginnameUniqueValidation', loginnameUniqueValidation);

    RegisterFormController.$inject = ['$http', '$state', 'XhrEntity', '$scope'];
    function RegisterFormController($http, $state, XhrEntity, $scope) {
        var vm = this;

        activate();
        vm.account = {};
        vm.registerForm = {};

        function activate() {
            // bind here all data from the form
            // place the message if something goes wrong
            vm.authMsg = '';

            vm.register = function () {
                vm.authMsg = '';
                vm.authMsgSuccess = '';



                if (vm.registerForm.$valid) {

                    XhrEntity.setEntity('Usuario');
                    XhrEntity.postAction('registracionUsuario', {"account": vm.account}, function (err, response) {
                        if (response.statusCode == 200) {
                            $scope.reg.authMsgSuccess = response.statusMsg;
                        } else {

                        }
                    })
                }
                else {
                    // set as dirty if the user click directly to login so we show the validation messages
                    /*jshint -W106*/
                    vm.registerForm.account_nombre.$dirty = true;
                    vm.registerForm.account_email.$dirty = true;
                    vm.registerForm.account_password.$dirty = true;
                    vm.registerForm.account_agreed.$dirty = true;

                }
            };
        }
    }
    
    var timer;
    var delay=1200;

    loginnameUniqueValidation.$inject = ['$q', '$timeout', 'XhrEntity'];
    function loginnameUniqueValidation($q, $timeout, XhrEntity) {
        return {
            require: 'ngModel',
            link: function (scope, elm, attrs, ngModel) {

                ngModel.$asyncValidators.loginnameUniqueValidation =
                        function (modelValue, viewValue) {
                            
                            ngModel.$error.msg = "";
                            ngModel.$error.async = false;
                            var defer = $q.defer();

                            if (ngModel.$isEmpty(modelValue)) {
                                return $q.when();
                            }

                            $timeout.cancel(timer);
                            timer = $timeout(function () {

                                XhrEntity.setEntity('Usuario');
                                XhrEntity.postActionPromise('emailExistente', {"email": modelValue})
                                        .then(function (response) {
                                            if (response.statusCode === 200) {
                                                defer.resolve();
                                            } else {
                                                ngModel.$error.msg = response.statusDetail;
                                                ngModel.$error.async = true;
                                                defer.reject();
                                            }
                                            console.log(ngModel);
                                        }, function (err) {
                                            defer.reject(err);
                                        });
                                return defer.promise;

                            }, delay);
                            
                            return $q.when();
                        };
            }
        }
    }
})();

(function() {
    'use strict';

    angular
        .module('app.preloader')
        .directive('preloader', preloader);

    preloader.$inject = ['$animate', '$timeout', '$q'];
    function preloader ($animate, $timeout, $q) {

        var directive = {
            restrict: 'EAC',
            template: 
              '<div class="preloader-progress">' +
                  '<div class="preloader-progress-bar" ' +
                       'ng-style="{width: loadCounter + \'%\'}"></div>' +
              '</div>'
            ,
            link: link
        };
        return directive;

        ///////

        function link(scope, el) {

          scope.loadCounter = 0;

          var counter  = 0,
              timeout;

          // disables scrollbar
          angular.element('body').css('overflow', 'hidden');
          // ensure class is present for styling
          el.addClass('preloader');

          appReady().then(endCounter);

          timeout = $timeout(startCounter);

          ///////

          function startCounter() {

            var remaining = 100 - counter;
            counter = counter + (0.015 * Math.pow(1 - Math.sqrt(remaining), 2));

            scope.loadCounter = parseInt(counter, 10);

            timeout = $timeout(startCounter, 20);
          }

          function endCounter() {

            $timeout.cancel(timeout);

            scope.loadCounter = 100;

            $timeout(function(){
              // animate preloader hiding
              $animate.addClass(el, 'preloader-hidden');
              // retore scrollbar
              angular.element('body').css('overflow', '');
            }, 300);
          }

          function appReady() {
            var deferred = $q.defer();
            var viewsLoaded = 0;
            // if this doesn't sync with the real app ready
            // a custom event must be used instead
            var off = scope.$on('$viewContentLoaded', function () {
              viewsLoaded ++;
              // we know there are at least two views to be loaded 
              // before the app is ready (1-index.html 2-app*.html)
              if ( viewsLoaded === 2) {
                // with resolve this fires only once
                $timeout(function(){
                  deferred.resolve();
                }, 3000);

                off();
              }

            });

            return deferred.promise;
          }

        } //link
    }

})();
/**=========================================================
 * Module: helpers.js
 * Provides helper functions for routes definition
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.routes')
        .provider('RouteHelpers', RouteHelpersProvider)
        ;

    RouteHelpersProvider.$inject = ['APP_REQUIRES'];
    function RouteHelpersProvider(APP_REQUIRES) {

      /* jshint validthis:true */
      return {
        // provider access level
        basepath: basepath,
        resolveFor: resolveFor,
          resolveForWithAuthentication: resolveForWithAuthentication,
        // controller access level
        $get: function() {
          return {
            basepath: basepath,
            resolveFor: resolveFor,
              resolveForWithAuthentication: resolveForWithAuthentication
          };
        }
      };

      // Set here the base of the relative path
      // for all app views
      function basepath(uri) {
        return 'app/views/' + uri;
      }

      // Generates a resolve object by passing script names
      // previously configured in constant.APP_REQUIRES
      function resolveFor() {
        var _args = arguments;
        return {
          deps: ['$ocLazyLoad','$q', function ($ocLL, $q) {
            // Creates a promise chain for each argument
            var promise = $q.when(1); // empty promise
            for(var i=0, len=_args.length; i < len; i ++){
              promise = andThen(_args[i]);
            }
            return promise;

            // creates promise to chain dynamically
            function andThen(_arg) {
              // also support a function that returns a promise
              if(typeof _arg === 'function')
                  return promise.then(_arg);
              else
                  return promise.then(function() {
                    // if is a module, pass the name. If not, pass the array
                    var whatToLoad = getRequired(_arg);
                    // simple error check
                    if(!whatToLoad) return $.error('Route resolve: Bad resource name [' + _arg + ']');
                    // finally, return a promise
                    return $ocLL.load( whatToLoad );
                  });
            }
            // check and returns required data
            // analyze module items with the form [name: '', files: []]
            // and also simple array of script files (for not angular js)
            function getRequired(name) {
              if (APP_REQUIRES.modules)
                  for(var m in APP_REQUIRES.modules)
                      if(APP_REQUIRES.modules[m].name && APP_REQUIRES.modules[m].name === name)
                          return APP_REQUIRES.modules[m];
              return APP_REQUIRES.scripts && APP_REQUIRES.scripts[name];
            }

          }]};
      } // resolveFor

       function resolveForWithAuthentication() {
            var _args = arguments;
            return {
                deps: ['$ocLazyLoad', '$q', function ($ocLL, $q) {
                    // Creates a promise chain for each argument
                    var promise = $q.when(1); // empty promise
                    for (var i = 0, len = _args.length; i < len; i++) {
                        promise = andThen(_args[i]);
                    }
                    return promise;

                    // creates promise to chain dynamically
                    function andThen(_arg) {
                        // also support a function that returns a promise
                        if (typeof _arg === 'function')
                            return promise.then(_arg);
                        else
                            return promise.then(function () {
                                // if is a module, pass the name. If not, pass the array
                                var whatToLoad = getRequired(_arg);
                                // simple error check
                                if (!whatToLoad)
                                    return $.error('Route resolve: Bad resource name [' + _arg + ']');
                                // finally, return a promise
                                return $ocLL.load(whatToLoad);
                            });
                    }
                    // check and returns required data
                    // analyze module items with the form [name: '', files: []]
                    // and also simple array of script files (for not angular js)
                    function getRequired(name) {
                        if (APP_REQUIRES.modules)
                            for (var m in APP_REQUIRES.modules)
                                if (APP_REQUIRES.modules[m].name && APP_REQUIRES.modules[m].name === name)
                                    return APP_REQUIRES.modules[m];
                        return APP_REQUIRES.scripts && APP_REQUIRES.scripts[name];
                    }

                }],
                auth: ["$q", "authenticationSvc", function ($q, authenticationSvc) {
                    return authenticationSvc.isUser_inServerLoggedIn();
                }

                ]};
        } // resolveForWithAuthentication

    }


})();


/**=========================================================
 * Module: config.js
 * App routes and resources configuration
 =========================================================*/


(function() {
    'use strict';

    angular
        .module('app.routes')
        .config(routesConfig);

    routesConfig.$inject = ['$stateProvider', '$locationProvider', '$urlRouterProvider', 'RouteHelpersProvider'];
    function routesConfig($stateProvider, $locationProvider, $urlRouterProvider, helper){
        
        // Set the following to true to enable the HTML5 Mode
        // You may have to set <base> tag in index and a routing configuration in your server
        $locationProvider.html5Mode(false);

        // defaults to dashboard
        $urlRouterProvider.otherwise('/app/singleview');

        // 
        // Application Routes
        // -----------------------------------   
        $stateProvider
            .state('app', {
                url: '/app',
                abstract: true,
                templateUrl: helper.basepath('app.html'),
                resolve: helper.resolveForWithAuthentication('modernizr', 'icons', 'toaster')
            })
            .state('app.singleview', {
                url: '/singleview',
                title: 'Single View',
                templateUrl: helper.basepath('singleview.html')
            })
            // .state('app.modalAdministrableList', {
            //     url: '/ModalAdministrableList',
            //     title: 'Modal Administrable list',
            //     templateUrl: helper.basepath('business/modal_administrable/modalAdministrable_list.html'),
            //     resolve: helper.resolveFor('ui.grid', 'loaders.css', 'spinkit'),
            //     controller: 'ModalAdministrableListController',
            //     controllerAs: 'table'
            // })
            .state('app.modalAdministrableDetail', {
                url: '/ModalAdministrable/',
                title: 'Modal Administrable detail',
                templateUrl: helper.basepath('business/modal_administrable/modalAdministrable_detail.html'),
                resolve: helper.resolveFor('oitozero.ngSweetAlert'),
                controller: "ModalAdministrableDetailController",
                controllerAs: "modCtrl"
            })
            //
            // Single Page Routes
            // -----------------------------------
            .state('page', {
                url: '/page',
                templateUrl: 'app/pages/page.html',
                resolve: helper.resolveFor('modernizr', 'icons'),
                controller: ['$rootScope', function($rootScope) { $rootScope.app.layout.isBoxed = false; }]
            })
            .state('page.login', {
                url: '/login',
                title: 'Login',
                templateUrl: 'app/pages/login.html',
                controller: 'LoginFormController',
                controllerAs: 'login'
            })


          //
          // CUSTOM RESOLVES
          //   Add your own resolves properties
          //   following this object extend
          //   method
          // -----------------------------------
          // .state('app.someroute', {
          //   url: '/some_url',
          //   templateUrl: 'path_to_template.html',
          //   controller: 'someController',
          //   resolve: angular.extend(
          //     helper.resolveFor(), {
          //     // YOUR RESOLVES GO HERE
          //     }
          //   )
          // })
          ;

    } // routesConfig

})();


(function() {
    'use strict';

    angular
        .module('app.settings')
        .run(settingsRun);

    settingsRun.$inject = ['$rootScope', '$localStorage'];

    function settingsRun($rootScope, $localStorage){

      // Global Settings
      // ----------------------------------- 
      $rootScope.app = {
        name: 'Angle',
        description: 'Angular Bootstrap Admin Template',
        year: ((new Date()).getFullYear()),
        layout: {
          isFixed: true,
          isCollapsed: false,
          isBoxed: false,
          isRTL: false,
          horizontal: false,
          isFloat: false,
          asideHover: false,
          theme: null
        },
        useFullLayout: false,
        hiddenFooter: false,
        offsidebarOpen: false,
        asideToggled: false,
        viewAnimation: 'ng-fadeInUp'
      };

      // Setup the layout mode
      $rootScope.app.layout.horizontal = ( $rootScope.$stateParams.layout === 'app-h') ;

      // Restore layout settings [*** UNCOMMENT TO ENABLE ***]
      // if( angular.isDefined($localStorage.layout) )
      //   $rootScope.app.layout = $localStorage.layout;
      // else
      //   $localStorage.layout = $rootScope.app.layout;
      //
      // $rootScope.$watch('app.layout', function () {
      //   $localStorage.layout = $rootScope.app.layout;
      // }, true);

      // Close submenu when sidebar change from collapsed to normal
      $rootScope.$watch('app.layout.isCollapsed', function(newValue) {
        if( newValue === false )
          $rootScope.$broadcast('closeSidebarMenu');
      });

    }

})();

/**=========================================================
 * Module: sidebar-menu.js
 * Handle sidebar collapsible elements
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.sidebar')
        .controller('SidebarController', SidebarController);

    SidebarController.$inject = ['$rootScope', '$scope', '$state', 'SidebarLoader', 'Utils'];
    function SidebarController($rootScope, $scope, $state, SidebarLoader,  Utils) {

        activate();

        ////////////////

        function activate() {
          var collapseList = [];

          // demo: when switch from collapse to hover, close all items
          $rootScope.$watch('app.layout.asideHover', function(oldVal, newVal){
            if ( newVal === false && oldVal === true) {
              closeAllBut(-1);
            }
          });


          // Load menu from json file
          // ----------------------------------- 

          SidebarLoader.getMenu(sidebarReady);
          
          function sidebarReady(items) {
            $scope.menuItems = items;
          }

          // Handle sidebar and collapse items
          // ----------------------------------
          
          $scope.getMenuItemPropClasses = function(item) {
            return (item.heading ? 'nav-heading' : '') +
                   (isActive(item) ? ' active' : '') ;
          };

          $scope.addCollapse = function($index, item) {
            collapseList[$index] = $rootScope.app.layout.asideHover ? true : !isActive(item);
          };

          $scope.isCollapse = function($index) {
            return (collapseList[$index]);
          };

          $scope.toggleCollapse = function($index, isParentItem) {

            // collapsed sidebar doesn't toggle drodopwn
            if( Utils.isSidebarCollapsed() || $rootScope.app.layout.asideHover ) return true;

            // make sure the item index exists
            if( angular.isDefined( collapseList[$index] ) ) {
              if ( ! $scope.lastEventFromChild ) {
                collapseList[$index] = !collapseList[$index];
                closeAllBut($index);
              }
            }
            else if ( isParentItem ) {
              closeAllBut(-1);
            }
            
            $scope.lastEventFromChild = isChild($index);

            return true;
          
          };

          // Controller helpers
          // ----------------------------------- 

            // Check item and children active state
            function isActive(item) {

              if(!item) return;

              if( !item.sref || item.sref === '#') {
                var foundActive = false;
                angular.forEach(item.submenu, function(value) {
                  if(isActive(value)) foundActive = true;
                });
                return foundActive;
              }
              else
                return $state.is(item.sref) || $state.includes(item.sref);
            }

            function closeAllBut(index) {
              index += '';
              for(var i in collapseList) {
                if(index < 0 || index.indexOf(i) < 0)
                  collapseList[i] = true;
              }
            }

            function isChild($index) {
              /*jshint -W018*/
              return (typeof $index === 'string') && !($index.indexOf('-') < 0);
            }
        
        } // activate
    }

})();

/**=========================================================
 * Module: sidebar.js
 * Wraps the sidebar and handles collapsed state
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.sidebar')
        .directive('sidebar', sidebar);

    sidebar.$inject = ['$rootScope', '$timeout', '$window', 'Utils'];
    function sidebar ($rootScope, $timeout, $window, Utils) {
        var $win = angular.element($window);
        var directive = {
            // bindToController: true,
            // controller: Controller,
            // controllerAs: 'vm',
            link: link,
            restrict: 'EA',
            template: '<nav class="sidebar" ng-transclude></nav>',
            transclude: true,
            replace: true
            // scope: {}
        };
        return directive;

        function link(scope, element, attrs) {

          var currentState = $rootScope.$state.current.name;
          var $sidebar = element;

          var eventName = Utils.isTouch() ? 'click' : 'mouseenter' ;
          var subNav = $();

          $sidebar.on( eventName, '.nav > li', function() {

            if( Utils.isSidebarCollapsed() || $rootScope.app.layout.asideHover ) {

              subNav.trigger('mouseleave');
              subNav = toggleMenuItem( $(this), $sidebar);

              // Used to detect click and touch events outside the sidebar          
              sidebarAddBackdrop();

            }

          });

          scope.$on('closeSidebarMenu', function() {
            removeFloatingNav();
          });

          // Normalize state when resize to mobile
          $win.on('resize', function() {
            if( ! Utils.isMobile() )
          	asideToggleOff();
          });

          // Adjustment on route changes
          $rootScope.$on('$stateChangeStart', function(event, toState) {
            currentState = toState.name;
            // Hide sidebar automatically on mobile
            asideToggleOff();

            $rootScope.$broadcast('closeSidebarMenu');
          });

      	  // Autoclose when click outside the sidebar
          if ( angular.isDefined(attrs.sidebarAnyclickClose) ) {
            
            var wrapper = $('.wrapper');
            var sbclickEvent = 'click.sidebar';
            
            $rootScope.$watch('app.asideToggled', watchExternalClicks);

          }

          //////

          function watchExternalClicks(newVal) {
            // if sidebar becomes visible
            if ( newVal === true ) {
              $timeout(function(){ // render after current digest cycle
                wrapper.on(sbclickEvent, function(e){
                  // if not child of sidebar
                  if( ! $(e.target).parents('.aside').length ) {
                    asideToggleOff();
                  }
                });
              });
            }
            else {
              // dettach event
              wrapper.off(sbclickEvent);
            }
          }

          function asideToggleOff() {
            $rootScope.app.asideToggled = false;
            if(!scope.$$phase) scope.$apply(); // anti-pattern but sometimes necessary
      	  }
        }
        
        ///////

        function sidebarAddBackdrop() {
          var $backdrop = $('<div/>', { 'class': 'dropdown-backdrop'} );
          $backdrop.insertAfter('.aside-inner').on('click mouseenter', function () {
            removeFloatingNav();
          });
        }

        // Open the collapse sidebar submenu items when on touch devices 
        // - desktop only opens on hover
        function toggleTouchItem($element){
          $element
            .siblings('li')
            .removeClass('open')
            .end()
            .toggleClass('open');
        }

        // Handles hover to open items under collapsed menu
        // ----------------------------------- 
        function toggleMenuItem($listItem, $sidebar) {

          removeFloatingNav();

          var ul = $listItem.children('ul');
          
          if( !ul.length ) return $();
          if( $listItem.hasClass('open') ) {
            toggleTouchItem($listItem);
            return $();
          }

          var $aside = $('.aside');
          var $asideInner = $('.aside-inner'); // for top offset calculation
          // float aside uses extra padding on aside
          var mar = parseInt( $asideInner.css('padding-top'), 0) + parseInt( $aside.css('padding-top'), 0);
          var subNav = ul.clone().appendTo( $aside );
          
          toggleTouchItem($listItem);

          var itemTop = ($listItem.position().top + mar) - $sidebar.scrollTop();
          var vwHeight = $win.height();

          subNav
            .addClass('nav-floating')
            .css({
              position: $rootScope.app.layout.isFixed ? 'fixed' : 'absolute',
              top:      itemTop,
              bottom:   (subNav.outerHeight(true) + itemTop > vwHeight) ? 0 : 'auto'
            });

          subNav.on('mouseleave', function() {
            toggleTouchItem($listItem);
            subNav.remove();
          });

          return subNav;
        }

        function removeFloatingNav() {
          $('.dropdown-backdrop').remove();
          $('.sidebar-subnav.nav-floating').remove();
          $('.sidebar li.open').removeClass('open');
        }
    }


})();


(function() {
    'use strict';

    angular
        .module('app.sidebar')
        .service('SidebarLoader', SidebarLoader);

    SidebarLoader.$inject = ['$http'];
    function SidebarLoader($http) {
        this.getMenu = getMenu;

        ////////////////

        function getMenu(onReady, onError) {
          var menuJson = 'server/sidebar-menu.json',
              menuURL  = menuJson + '?v=' + (new Date().getTime()); // jumps cache
            
          onError = onError || function() { alert('Failure loading menu'); };

          $http
            .get(menuURL)
            .success(onReady)
            .error(onError);
        }
    }
})();
(function() {
    'use strict';

    angular
        .module('app.sidebar')
        .controller('UserBlockController', UserBlockController);

    UserBlockController.$inject = ['$rootScope'];
    function UserBlockController($rootScope) {

        activate();

        ////////////////

        function activate() {
          $rootScope.user = {
            name:     'John',
            job:      'ng-developer',
            picture:  'app/img/user/02.jpg'
          };

          // Hides/show user avatar on sidebar
          $rootScope.toggleUserBlock = function(){
            $rootScope.$broadcast('toggleUserBlock');
          };

          $rootScope.userBlockVisible = true;
          
          $rootScope.$on('toggleUserBlock', function(/*event, args*/) {

            $rootScope.userBlockVisible = ! $rootScope.userBlockVisible;
            
          });
        }
    }
})();

(function() {
    'use strict';

    angular
        .module('app.translate')
        .config(translateConfig)
        ;
    translateConfig.$inject = ['$translateProvider'];
    function translateConfig($translateProvider){
  
      $translateProvider.useStaticFilesLoader({
          prefix : 'app/i18n/',
          suffix : '.json'
      });
      $translateProvider.preferredLanguage('en');
      $translateProvider.useLocalStorage();
      $translateProvider.usePostCompiling(true);

    }
})();
(function() {
    'use strict';

    angular
        .module('app.translate')
        .run(translateRun)
        ;
    translateRun.$inject = ['$rootScope', '$translate'];
    
    function translateRun($rootScope, $translate){

      // Internationalization
      // ----------------------

      $rootScope.language = {
        // Handles language dropdown
        listIsOpen: false,
        // list of available languages
        available: {
          'en':       'English',
          'es_AR':    'Español'
        },
        // display always the current ui language
        init: function () {
          var proposedLanguage = $translate.proposedLanguage() || $translate.use();
          var preferredLanguage = $translate.preferredLanguage(); // we know we have set a preferred one in app.config
          $rootScope.language.selected = $rootScope.language.available[ (proposedLanguage || preferredLanguage) ];
        },
        set: function (localeId) {
          // Set the new idiom
          $translate.use(localeId);
          // save a reference for the current language
          $rootScope.language.selected = $rootScope.language.available[localeId];
          // finally toggle dropdown
          $rootScope.language.listIsOpen = ! $rootScope.language.listIsOpen;
        }
      };

      $rootScope.language.init();

    }
})();
/**=========================================================
 * Module: animate-enabled.js
 * Enable or disables ngAnimate for element with directive
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.utils')
        .directive('animateEnabled', animateEnabled);

    animateEnabled.$inject = ['$animate'];
    function animateEnabled ($animate) {
        var directive = {
            link: link,
            restrict: 'A'
        };
        return directive;

        function link(scope, element, attrs) {
          scope.$watch(function () {
            return scope.$eval(attrs.animateEnabled, scope);
          }, function (newValue) {
            $animate.enabled(!!newValue, element);
          });
        }
    }

})();

/**=========================================================
 * Module: browser.js
 * Browser detection
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.utils')
        .service('Browser', Browser);

    Browser.$inject = ['$window'];
    function Browser($window) {
      return $window.jQBrowser;
    }

})();

/**=========================================================
 * Module: clear-storage.js
 * Removes a key from the browser storage via element click
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.utils')
        .directive('resetKey', resetKey);

    resetKey.$inject = ['$state', '$localStorage'];
    function resetKey ($state, $localStorage) {
        var directive = {
            link: link,
            restrict: 'A',
            scope: {
              resetKey: '@'
            }
        };
        return directive;

        function link(scope, element) {
          element.on('click', function (e) {
              e.preventDefault();

              if(scope.resetKey) {
                delete $localStorage[scope.resetKey];
                $state.go($state.current, {}, {reload: true});
              }
              else {
                $.error('No storage key specified for reset.');
              }
          });
        }
    }

})();

/**=========================================================
 * Module: fullscreen.js
 * Toggle the fullscreen mode on/off
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.utils')
        .directive('toggleFullscreen', toggleFullscreen);

    toggleFullscreen.$inject = ['Browser'];
    function toggleFullscreen (Browser) {
        var directive = {
            link: link,
            restrict: 'A'
        };
        return directive;

        function link(scope, element) {
          // Not supported under IE
          if( Browser.msie ) {
            element.addClass('hide');
          }
          else {
            element.on('click', function (e) {
                e.preventDefault();

                if (screenfull.enabled) {
                  
                  screenfull.toggle();
                  
                  // Switch icon indicator
                  if(screenfull.isFullscreen)
                    $(this).children('em').removeClass('fa-expand').addClass('fa-compress');
                  else
                    $(this).children('em').removeClass('fa-compress').addClass('fa-expand');

                } else {
                  $.error('Fullscreen not enabled');
                }

            });
          }
        }
    }


})();

/**=========================================================
 * Module: load-css.js
 * Request and load into the current page a css file
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.utils')
        .directive('loadCss', loadCss);

    function loadCss () {
        var directive = {
            link: link,
            restrict: 'A'
        };
        return directive;

        function link(scope, element, attrs) {
          element.on('click', function (e) {
              if(element.is('a')) e.preventDefault();
              var uri = attrs.loadCss,
                  link;

              if(uri) {
                link = createLink(uri);
                if ( !link ) {
                  $.error('Error creating stylesheet link element.');
                }
              }
              else {
                $.error('No stylesheet location defined.');
              }

          });
        }
        
        function createLink(uri) {
          var linkId = 'autoloaded-stylesheet',
              oldLink = $('#'+linkId).attr('id', linkId + '-old');

          $('head').append($('<link/>').attr({
            'id':   linkId,
            'rel':  'stylesheet',
            'href': uri
          }));

          if( oldLink.length ) {
            oldLink.remove();
          }

          return $('#'+linkId);
        }
    }

})();

/**=========================================================
 * Module: now.js
 * Provides a simple way to display the current time formatted
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.utils')
        .directive('now', now);

    now.$inject = ['dateFilter', '$interval'];
    function now (dateFilter, $interval) {
        var directive = {
            link: link,
            restrict: 'EA'
        };
        return directive;

        function link(scope, element, attrs) {
          var format = attrs.format;

          function updateTime() {
            var dt = dateFilter(new Date(), format);
            element.text(dt);
          }

          updateTime();
          var intervalPromise = $interval(updateTime, 1000);

          scope.$on('$destroy', function(){
            $interval.cancel(intervalPromise);
          });

        }
    }

})();

/**=========================================================
 * Module: table-checkall.js
 * Tables check all checkbox
 =========================================================*/
(function() {
    'use strict';

    angular
        .module('app.utils')
        .directive('checkAll', checkAll);

    function checkAll () {
        var directive = {
            link: link,
            restrict: 'A'
        };
        return directive;

        function link(scope, element) {
          element.on('change', function() {
            var $this = $(this),
                index= $this.index() + 1,
                checkbox = $this.find('input[type="checkbox"]'),
                table = $this.parents('table');
            // Make sure to affect only the correct checkbox column
            table.find('tbody > tr > td:nth-child('+index+') input[type="checkbox"]')
              .prop('checked', checkbox[0].checked);

          });
        }
    }

})();

/**=========================================================
 * Module: trigger-resize.js
 * Triggers a window resize event from any element
 =========================================================*/
(function() {
    'use strict';

    angular
        .module('app.utils')
        .directive('triggerResize', triggerResize);

    triggerResize.$inject = ['$window', '$timeout'];
    function triggerResize ($window, $timeout) {
        var directive = {
            link: link,
            restrict: 'A'
        };
        return directive;

        function link(scope, element) {
          element.on('click', function(){
            $timeout(function(){
              $window.dispatchEvent(new Event('resize'));
            });
          });
        }
    }

})();

/**=========================================================
 * Module: utils.js
 * Utility library to use across the theme
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.utils')
        .service('Utils', Utils);

    Utils.$inject = ['$window', 'APP_MEDIAQUERY'];
    function Utils($window, APP_MEDIAQUERY) {

        var $html = angular.element('html'),
            $win  = angular.element($window),
            $body = angular.element('body');

        return {
          // DETECTION
          support: {
            transition: (function() {
                    var transitionEnd = (function() {

                        var element = document.body || document.documentElement,
                            transEndEventNames = {
                                WebkitTransition: 'webkitTransitionEnd',
                                MozTransition: 'transitionend',
                                OTransition: 'oTransitionEnd otransitionend',
                                transition: 'transitionend'
                            }, name;

                        for (name in transEndEventNames) {
                            if (element.style[name] !== undefined) return transEndEventNames[name];
                        }
                    }());

                    return transitionEnd && { end: transitionEnd };
                })(),
            animation: (function() {

                var animationEnd = (function() {

                    var element = document.body || document.documentElement,
                        animEndEventNames = {
                            WebkitAnimation: 'webkitAnimationEnd',
                            MozAnimation: 'animationend',
                            OAnimation: 'oAnimationEnd oanimationend',
                            animation: 'animationend'
                        }, name;

                    for (name in animEndEventNames) {
                        if (element.style[name] !== undefined) return animEndEventNames[name];
                    }
                }());

                return animationEnd && { end: animationEnd };
            })(),
            requestAnimationFrame: window.requestAnimationFrame ||
                                   window.webkitRequestAnimationFrame ||
                                   window.mozRequestAnimationFrame ||
                                   window.msRequestAnimationFrame ||
                                   window.oRequestAnimationFrame ||
                                   function(callback){ window.setTimeout(callback, 1000/60); },
            /*jshint -W069*/
            touch: (
                ('ontouchstart' in window && navigator.userAgent.toLowerCase().match(/mobile|tablet/)) ||
                (window.DocumentTouch && document instanceof window.DocumentTouch)  ||
                (window.navigator['msPointerEnabled'] && window.navigator['msMaxTouchPoints'] > 0) || //IE 10
                (window.navigator['pointerEnabled'] && window.navigator['maxTouchPoints'] > 0) || //IE >=11
                false
            ),
            mutationobserver: (window.MutationObserver || window.WebKitMutationObserver || window.MozMutationObserver || null)
          },
          // UTILITIES
          isInView: function(element, options) {
              /*jshint -W106*/
              var $element = $(element);

              if (!$element.is(':visible')) {
                  return false;
              }

              var window_left = $win.scrollLeft(),
                  window_top  = $win.scrollTop(),
                  offset      = $element.offset(),
                  left        = offset.left,
                  top         = offset.top;

              options = $.extend({topoffset:0, leftoffset:0}, options);

              if (top + $element.height() >= window_top && top - options.topoffset <= window_top + $win.height() &&
                  left + $element.width() >= window_left && left - options.leftoffset <= window_left + $win.width()) {
                return true;
              } else {
                return false;
              }
          },
          
          langdirection: $html.attr('dir') === 'rtl' ? 'right' : 'left',

          isTouch: function () {
            return $html.hasClass('touch');
          },

          isSidebarCollapsed: function () {
            return $body.hasClass('aside-collapsed');
          },

          isSidebarToggled: function () {
            return $body.hasClass('aside-toggled');
          },

          isMobile: function () {
            return $win.width() < APP_MEDIAQUERY.tablet;
          }

        };
    }
})();

(function() {
    'use strict';

    angular.module('app.modalAdministrable', [
        /** list */
        'ui-grid-base-controller', 
        'dt-default-directives',
        /** detail */
        'default-formbuttonctrl',
        'simple-modalpanel',
        'xhr-basic',
        'msg-display',
        'simple-form'
    ]);
    
})();
/**=========================================================
 * Module: xhr-basic
 =========================================================*/

(function () {

    angular.module('xhr-basic',[
        'url-provider'
    ])

})();
(function () {

    angular.module('miscelaneos', []);

})();
/**=========================================================
 * Module: datepicker-ctrl
 * Provides a simple demo for bootstrap datepicker
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('datepicker-ctrl',[])
        ;

})();

/**=========================================================
 * Module: datetimepicker-ctrl
 * Provides a simple demo for bootstrap datepicker
 =========================================================*/


(function () {
    'use strict';

    angular
        .module('datetimepicker-ctrl', [])
    ;

})();

/**
 * Module: simpleFileUploadMod
 * 
 * Required modules:
 *  'url-provider'
 * 
 */

( function() {

angular.module('simpleFileUploadMod', [
    'ngAnimate'
    ,'ui.bootstrap'
    ,'url-provider'
    ]);

})();
(function () {

    angular.module('simple-form', []);

})();
/**=========================================================
 * Module: UIGridUtils
 =========================================================*/

(function () {

    angular.module('ui-grid-utils',[])

})();
(function() {
    'use strict';

    angular
        .module('custom', [
            // request the the entire framework
            'angle',
            // or just modules
            'app.core',
            'app.sidebar',
            'app.config',
            'app.pages',
            'app.authenticationSvc',
            'app.modalAdministrable'
            /*...*/
        ]);
})();
(function() {
    'use strict';
    angular
        .module('app.config',[])

        .constant('DATA_PROVIDER_URL', {
            //Tecdata desarrollo
            'dev2.tecdata':'dataservice/index.php',
            //Default
            'default': 'dataservice/index.php'
        })
        .constant('FILE_UPLOAD_URL',{
            //Tecdata desarrollo
            'dev2.tecdata':{
                'defaultUploadUrl': '',
                'seccionUploadUrl': ''
            },
            //default
            'default':{
                'defaultUploadUrl': '',
                'seccionUploadUrl': ''
            }
        })
        .config(["$httpProvider", function($httpProvider) {
            $httpProvider.defaults.withCredentials = true;
        }]);
})();


// To run this code, edit file index.html or index.jade and change
// html data-ng-app attribute from angle to myAppName
// ----------------------------------------------------------------------

(function() {
    'use strict';

    angular
        .module('custom')
        .controller('Controller', Controller);

    Controller.$inject = ['$log'];
    function Controller($log) {
        // for controllerAs syntax
        // var vm = this;

        activate();

        ////////////////

        function activate() {
          $log.log('I\'m a line from custom.js');
        }
    }
})();

(function() {
    'use strict';

    angular
        .module('app.modalAdministrable')
        .controller('ModalAdministrableDetailController', ModalAdministrableDetailController);

    ModalAdministrableDetailController.$inject = ['$scope', 'XhrData', 'XhrEntity', 'SimpleForm', 'MsgDisplay', 'misc'];
    function ModalAdministrableDetailController($scope, XhrData, XhrEntity, SimpleForm, MsgDisplay, misc) {
        var _self = this;

        SimpleForm.setEntity("ModalAdministrable");
        var _form = SimpleForm.getForm();
        var id = _form.entityId;

        _self.itemActive = null;

        $scope.newform = _form.newform;

        $scope.formdata = {};
        $scope.comboInfo = {};

        XhrEntity.setEntity(_form.entity);
        XhrEntity.getEntityData(id, function (err, response) {

            if (err === null){
                if (response.statusCode === 200) {
                    XhrData.setData(response);
                    XhrData.setScope($scope);

                    SimpleForm.setGrantedOperations(["cancel", "update"]);
                } else
                    MsgDisplay.DisplayResponse(response);
            }else {
                MsgDisplay.DisplayError("Error al recuperar datos (xhr)");
                //console.log(err);
            }

        });

        $scope.onSave_callback = function(err, response){
            //if(response.statusCode === 200)
                //angular.copy(response.data, $scope.formdata);
        }


    }

})();
(function() {
    'use strict';

    angular
        .module('app.modalAdministrable')
        .controller('ModalAdministrableListController', ModalAdministrableListController);

    ModalAdministrableListController.inject = ['$scope', '$controller', 'uiGridConstants'];
    function ModalAdministrableListController ($scope,  $controller, uiGridConstants) {
        var _self = this;

        //$scope.data_error_msg = ""

        // Extiende al controlador base, implementa todos los metodos para articular la lista/filtros/orden/scroll-infinito
        angular.extend(this, $controller('UiGridBaseController', {$scope: $scope}));

        this.rows_length = 100;
        this.infiniteScrollFromEnd = 20;

        this.entity = "ModalAdministrable";
        this.url_base = "app/";
        this.PK = "ma_id";
       

        this.ForEachRow_Downloaded = function(row) {

        };

        this.columnDefs = [
            {field: 'ma_id', width: '20%', displayName: 'Id',
                sort: {direction: uiGridConstants.DESC, priority: 0}},
            {field: 'ma_descripcion', width: '80%', displayName: 'Descripcion'}
        ];

        this.activate();
    }
    ModalAdministrableListController.$inject = ["$scope", "$controller", "uiGridConstants"];

})();
(function () {

    angular.module('app.authenticationSvc', ['ngStorage', 'url-provider'])

            .factory("authenticationSvc", ['$http', 'XhrEntity', '$q', '$localStorage', 'urlProvider', function ($http, XhrEntity,$q, $localStorage, urlProvider) {

                    var userInfo = null;
                    var authenticated = false;

                    $localStorage.$default({userInfo: null});

                    function login(userName, password) {
                        var deferred = $q.defer();
                        var url = urlProvider.getUrlforAction('Login', 'validateLogin');

                        $http.post(url, {frm_login_input: userName, frm_password_input: password})
                                .then(
                                        function (result) {
                                            authenticated = false;
                                            if (result.data.statusCode === 200) {
                                                authenticated = true;
                                                //userInfo = {accessToken: result.data.statusCode, userData: result.data.data};
                                                //$localStorage.userInfo = JSON.stringify(userInfo);
                                            }
                                            deferred.resolve(result.data);
                                        },
                                        function (error) {
                                            deferred.reject(error);
                                        });
                        return deferred.promise;
                    }
                    
                    function serverLogout(){
                        XhrEntity.setEntity('Login');
                        XhrEntity.getActionPromise('logout').then(function(response){
                            
                        });
                    }

                    function getUserInfo() {
                        if (angular.isDefined(userInfo) || userInfo == null) {
                            if ($localStorage.userInfo !== null) {
                                userInfo = JSON.parse($localStorage.userInfo);
                                authenticated = true;
                            }
                        }

                        var ret = userInfo;
                        return ret;
                    }

                    function isLoggedIn() {
                        return authenticated;
                    }

                    function logout() {
                        serverLogout();
                        $localStorage.userInfo = null;
                        userInfo = null;
                        authenticated = false;
                    }

                    function isUser_inServerLoggedIn() {
                        
                        var defer = $q.defer();
                        var url = urlProvider.getUrlforAction('Login', 'getUserLoggedIn');

                        var ret = null;

                        $http.get(url)
                                .then(
                                    function (result) {                                            
                                        if (result.data.statusCode === 200) {
                                            return defer.resolve(ret);
                                        } else {
                                            return defer.reject({'authenticated': false});
                                        }
                                    },
                                    function (error) {
                                        defer.reject(error);
                                    });

                        return defer.promise;
                    }

                    return {
                        login: login,
                        logout: logout,
                        getUserInfo: getUserInfo,
                        isLoggedIn: isLoggedIn,
                        isUser_inServerLoggedIn: isUser_inServerLoggedIn
                    };

                }]);


})();
/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

(function() {	
	
    angular.module('url-provider', [])

        .factory('urlProvider', urlProvider);

    urlProvider.$inject = [
        "$location"
        ,"DATA_PROVIDER_URL"
       // ,"FILE_UPLOAD_URL"
    ];

    function urlProvider (
        $location
        ,DATA_PROVIDER_URL
        ,FILE_UPLOAD_URL
    ){

        var _host = $location.$$host;
        var _protocol = $location.$$protocol;
        var _baseUrl = _protocol + '://' + _host;

        var getPath = function(path) {
            var _ret = _baseUrl + path;

            if (path.toLowerCase().indexOf("http") === 0)
                _ret = path;
            if (path.toLowerCase().indexOf("/") !== 0)
                _ret = path;

            return _ret;
        };

        var getUrlBase = function(){
            var ret = DATA_PROVIDER_URL[_host];
            if(!angular.isDefined(ret))
                ret = DATA_PROVIDER_URL.default;
            return ret;
        };

        return {
            getUrlBase: function () {
                return getPath(getUrlBase());
            },
            getUrlforAction: function(entity, action) {
                var path = getUrlBase();
                var params = '?dispatcher=' + entity + '&action=' + action;
                return getPath(path + params);
            },
            getUrlforList: function(entity) {
                var path = getUrlBase();
                var params = '?dispatcher=' + entity + '&action=list';
                return getPath(path + params);
            },
            getUrlforUpload: function(constant){
                return getPath(FILE_UPLOAD_URL[_host][constant]);
            },
            getDefaultUploadUrl: function(){
                return getPath(FILE_UPLOAD_URL[_host].defaultUploadUrl);
            }
        };

    }

})();

/**=========================================================
 * Module: xhr-basic
 =========================================================*/

(function () {

    angular.module('xhr-basic')
        .factory('XhrAutocompleteData', ['$http', 'urlProvider', function ($http, urlProvider) {

            var _self = this;
            var entity = "";
            var action = "autocomplete";

            this.getNoResults = function (labelText) {
                return [{
                    isLast: false,
                    isNoResult: true,
                    isGrouped: false,
                    label: labelText,
                    id: null,
                    value: null
                }];

            };

            return {
                getOptions: function (val) {
                    var url = urlProvider.getUrlforAction(entity, action);

                    return $http.get(url, {
                        params: {
                            term: val,
                            sensor: false
                        }
                    }).then(function (response) {
                        // response viene con un response.config y response.data
                        if (response.status !== 200) {
                            return _self.getNoResults("error en la busqueda (xhr)");
                        }

                        if (response.data.data === false) {
                            return _self.getNoResults("no hay resultados que coincidan");
                        }

                        return response.data.data.map(
                            function (item) {
                                // console.log(item.label);
                                return item;
                            });
                    });
                },
                setEntity: function (value) {
                    entity = value;
                }

            };
        }]);

})();
/**=========================================================
 * Module: xhr-basic
 =========================================================*/

(function () {

    angular.module('xhr-basic')

        .factory('XhrData', function () {

            var response = {
                data: {},
                responseStatus: {},
                selectedItem: {},
                pkId: ""
            };

            return {
                getDataObject: function () {
                    return response.data.dvm.dvme;
                },
                getDataConfig: function () {
                    return response.data.dvm.config;
                },
                getDataComboInfo: function () {
                    return response.data.dvm.config.comboInfo;
                },
                getData: function () {
                    return response.data;
                },
                setData: function (value) {
                    response.data = value.data;
                    response.responseStatus = value.statusCode;
                },
                setScope: function (scope) {
                    scope.formdata = response.data.dvm.dvme;
                    if (response.data.dvm.config !== null) {
                        scope.comboInfo = response.data.dvm.config.comboInfo;
                        if (response.data.dvm.config.lifeCycleActions)
                            scope.lifeCycleActions = response.data.dvm.config.lifeCycleActions;
                    }
                    if (response.data.dvm.dvme.lifeCycleActionList)
                        scope.lifeCycleActionList = response.data.dvm.dvme.lifeCycleActionList;
                },
                searchInComboInfo: function (comboName, key) {
                    var _ret;
                    response.data.dvm.config.comboInfo[comboName].forEach(
                        function (item) {
                            if (key === item.id) {
                                _ret = item;
                                return false;
                            }
                        });
                    return _ret;
                },
                getResponseStatus: function () {
                    return response.responseStatus;
                },
                setResponseStatus: function (value) {
                    response.reponseStatus = value;
                },
                getSelectedItem: function () {
                    return response.selectedItem;
                },
                setSelectedItem: function (value) {
                    response.selectedItem = value;
                },
                setPkId: function (value) {
                    response.pkId = value;
                },
                setPkValue: function (value) {
                    response.data.dvm.dvme[response.pkId] = value;
                },
                getPkValue: function () {
                    return response.data.dvm.dvme[response.pkId];
                },
                getFieldValue: function (fieldName) {
                    return response.data.dvm.dvme[fieldName];
                }
            };
        });

})();
/**=========================================================
 * Module: xhr-basic
 =========================================================*/

(function () {

    angular.module('xhr-basic')

        .factory('XhrEntity', ['$http', 'urlProvider', '$q', function ($http, urlProvider, $q) {

            var entity = "";
            var action = "";
            var id = "";

            var vm = this;

            return {
                refresh: function (callback) {
                    action = "instantiate";
                    var url = urlProvider.getUrlforAction(entity, action);
                    url += "&id=" + id;


                    $http.get(url)
                        .success(
                        function (response) {
                            var err = null;
                            callback(err, response);
                        })
                        .error(
                        function (err) {
                            var response = null;
                            callback(err, response);
                        });
                },
                getEntityData: function (_id, callback) {
                    action = "instantiate";
                    id = _id;

                    var url = urlProvider.getUrlforAction(entity, action);
                    url += "&id=" + id;

                    $http.get(url)
                        .success(
                        function (response) {
                            var err = null;
                            callback(err, response);
                        })
                        .error(
                        function (err) {
                            var response = null;
                            callback(err, response);
                        });
                },
                getList: function (callback) {
                    action = "list";

                    var url = urlProvider.getUrlforAction(entity, action);
                    url += "&id=" + id;

                    $http.get(url)
                        .success(
                        function (response) {
                            var err = null;
                            if (response.statusCode === 501) {
                                console.log("aca clear userinfo y luego redirect al login");
                            }
                            callback(err, response);
                        })
                        .error(
                        function (err) {
                            var response = null;
                            callback(err, response);
                        });
                },
                saveEntity: function (entityObjectData, callback) {
                    action = "update";
                    var url = urlProvider.getUrlforAction(entity, action);
                    $http.post(url, entityObjectData)
                        .success(
                        function (response) {
                            var err = null;
                            callback(err, response);
                        })
                        .error(
                        function (err) {
                            var response = null;
                            callback(err, response);
                        });
                },
                deleteEntity: function (_id, callback) {
                    id = _id;
                    action = "delete";
                    var url = urlProvider.getUrlforAction(entity, action);
                    url += "&id=" + id;

                    $http.get(url)
                        .success(
                        function (response) {
                            var err = null;
                            callback(err, response);
                        })
                        .error(
                        function (err) {
                            var response = null;
                            callback(err, response);
                        });
                },
                postAction: function (_action, entityObjectData, callback) {
                    action = _action;
                    var url = urlProvider.getUrlforAction(entity, action);
                    $http.post(url, entityObjectData)
                        .success(
                        function (response) {
                            var err = null;
                            callback(err, response);
                        })
                        .error(
                        function (err) {
                            var response = null;
                            callback(err, response);
                        });
                },
                postActionPromise: function (_action, entityObjectData) {
                    action = _action;
                    var url = urlProvider.getUrlforAction(entity, action);

                    var deferred = $q.defer();

                    $http.post(url, entityObjectData)
                        .success(
                        function (response) {
                            deferred.resolve(response);
                        })
                        .error(
                        function (err) {
                            deferred.reject(err);
                        });

                    return deferred.promise;
                },
                getActionPromise: function (_action) {
                    action = _action;
                    var url = urlProvider.getUrlforAction(entity, action);
                    var deferred = $q.defer();

                    $http.get(url)
                        .success(
                        function (response) {
                            deferred.resolve(response)
                        })
                        .error(
                        function (err) {
                            deferred.reject(err);
                        });

                    return deferred.promise;
                },
                setEntity: function (value) {
                    entity = value;
                },
                setAction: function (value) {
                    action = value;
                },
                setUrl_Base: function (value) {
                    url_base = value;
                }
            };
        }])

})();
(function () {
   
    angular.module('dt-default-directives', [])   
    
    .directive('dtResetFilterButton', ['DtDefaultOptions', function(DtDefaultOptions){
                    
        return {
            restrictive: "A",
            templateUrl: "app/views/common/dtButtonReset.html",
            link: function(scope, element, attrs){
                
                element.click(function(){   
                                                           
                    DtDefaultOptions.resetFilters();
                    DtDefaultOptions.reloadData();
                                        
                });
            }
        };
    }])

    .directive('dtNewButton', ['$window', '$location', function($window, $location){    
        return {
            restrictive: "A",
            templateUrl: "app/views/common/dtButtonNew.html",
            link: function(scope, element, attrs){
                                
                var _entity = attrs.entity;
                
                element.click(function(){
                    $window.open('#/app/' + _entity + '/new', '_self');
                });
            }            
        };
    }]);
    
})();



/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
(function () {

    var items_x_page = 10;
    var aoPreSearchCols = {};
    var sDomOptions = " 'dom': \"<'top'rt><'bottom'i <'datatables-page-length'l> p>\" ";

    angular.module('dt-default-options', [])
            .service('DtDefaultOptions', ['$location', 'DTOptionsBuilder', 'urlProvider', function ($location, DTOptionsBuilder, urlProvider) {
                    var vm = this;

                    var _entity = "";
                    var _url = "";
                    var _pk = "";
                    var _columns = [];
                    var _columnsFilter = null;
                                        
                    vm.controller = {};
                    vm.controller.dtInstance = {};

                    vm.setController = function(controller){
                        vm.controller = controller;
                        vm.controller.reloadData = vm.reloadData;
                        vm.controller.dtInstance = {};
                    };
                    vm.setOptions = function (scope) {
                        
                        var aoPreSearchCols = {};

                        if (_columnsFilter === null) {
                            _columnsFilter = {};
                            for (var i = 0; i < _columns.length; i++) {
                                _columnsFilter[i] = {"type": "text", "time": 750, "options":"<select><option>a</option></select>"};
                            }
                        }

                        vm.dtOptions = DTOptionsBuilder
                                .newOptions()
                                .withOption('ajax',
                                        {url: _url,
                                            type: 'GET',
                                            dataType: "json",
                                            dataSrc: function (json, v) {
                                                vm.setFilterValues(aoPreSearchCols);
                                                return json.data;
                                            }
                                        })
                                .withDataProp('data')
                                .withOption('processing', true)
                                .withOption('sDom', sDomOptions)
                                .withOption('serverSide', true)
                                .withOption('stateSave', true)
                                .withOption('stateDuration', -1)
                                .withOption('stateLoadParams', function (settings, data) {
                                    aoPreSearchCols = settings.aoPreSearchCols;
                                })
                                .withDisplayLength(items_x_page)
                                .withOption('fnRowCallback',
                                        function (nRow, aData, iDisplayIndex, iDisplayIndexFull) {
                                            $('td', nRow).unbind('click');
                                            $('td', nRow).bind('click', function () {
                                                scope.$apply(function () {
                                                    vm.ClickHandler(aData);
                                                });
                                            });
                                            return nRow;
                                        })
                                .withLightColumnFilter(_columnsFilter)
                                .withPaginationType('full_numbers');
                    };
                    
                    vm.resetFilters = function() {
                        
                        $("thead input").each(function (i) {
                                    $(this).val("");                       
                        });            
                                                
                        var aoSettings = vm.controller.dtInstance.dataTable.dataTableSettings;
                        var ndx = aoSettings.length-1;
                        
                        //console.log(ndx);
                        //console.log(vm);

                        
                        if (ndx >= 0) {
                            var lastAoSettings = aoSettings[ndx];
                            var searchCols = lastAoSettings.aoPreSearchCols;

                            for (var i=0; i < searchCols.length; i++ ) {
                                searchCols[i].sSearch = "";                            
                            }
                        }
                                                
                    };
                    
                    vm.reloadData = function() {
                        vm.controller.dtInstance.reloadData();
                    };
                    vm.ClickHandler = function (aData) {
                        var _url = 'app/' + _entity + '/' + aData[ _pk ];
                        $location.path(_url);
                    };

                    vm.setFilterValues = function (aoPreSearchCols) {
                        var filter_inputs = angular.element('table thead tr th input');

                        for (var ndx = 0; ndx < filter_inputs.length; ndx++) {
                            var filt = filter_inputs[ndx];
                            if (aoPreSearchCols.length > 0 && typeof (aoPreSearchCols[ndx]) !== "undefined")
                                filt.value = aoPreSearchCols[ndx].sSearch;
                        }
                    };

                    return {
                        setController: function(controller) {
                            vm.setController(controller);
                        },
                        setEntity: function (value) {
                            _entity = value;
                            _url = urlProvider.getUrlforList(_entity);
                        },
                        setPk: function (value) {
                            _pk = value;
                        },
                        setColumns: function (columnsArray) {
                            _columns = columnsArray;
                        },
                        setColumnsFilter: function (columnsFilterArray) {
                            _columnsFilter = columnsFilterArray;
                        },
                        setCreateRow_callback: function (callback) {
                            vm.dtOptions.withOption('createdRow', function (row, data, index, type) {
                                callback(row, data, index, type);
                            });
                        },
                        getDtOptions: function (scope) {
                            vm.setOptions(scope);
                            return vm.dtOptions;
                        },
                        setDtInstance: function(DtInstance){
                            vm.controller.dtInstance = DtInstance;
                        },
                        getDtInstance: function() {
                            return vm.controller.dtInstance;
                        },
                        resetFilters: function() {                            
                            vm.resetFilters();
                        },
                        reloadData: function() {
                            vm.reloadData();
                        }                        
                    };


                }]);

})();


(function () {


    angular.module('default-formbuttonctrl', [])
        .directive("formButtonpanel", function () {
            return {
                restrictive: "E",
                templateUrl: "app/views/common/buttonPanel.html",
                controller: "defaultFormButtonCtrl",
                controllerAs: "defaultBtnCtrl",
                link: function (scope, element, attrs, controller) {
                    if (typeof (attrs.onsave) !== "undefinded")
                        controller.onSave = scope[attrs.onsave];
                }
            };
        })

        /**
         * defaultFormButtonCtrl, controlador utilizado por la directiva
         * default-formbuttonctrl que implementa la botonera por defecto
         * (save,cancel,delete)
         */
        .controller('defaultFormButtonCtrl', ["$scope", "$http", "$location", "XhrData", "XhrEntity", "MsgDisplay", "modalPanelService", "SimpleForm", "$q", "localStoreData", function ($scope, $http, $location, XhrData, XhrEntity, MsgDisplay, modalPanelService, SimpleForm, $q, localStoreData) {

            var _self = this;
            this._form = SimpleForm.getForm();
            //console.log($location.path());

            _self.onSave;

            $scope.save = function () {

                var data = {
                    object_data: XhrData.getDataObject()
                };
                XhrEntity.setEntity(_self._form.entity);
                var entity = SimpleForm.getEntity();

                //   (No se envio el formulario  Y   Los campos son validos)  ó  (Se envió el formualrio     Y  Se cambiaron los campos)
                if ((!$scope[entity].$submitted && !$scope[entity].$invalid) || ($scope[entity].$submitted && $scope[entity].$dirty)) {
                
                    XhrEntity.saveEntity(data, function (err, response) {
                        if (err === null) {

                            MsgDisplay.DisplayResponse(response);

                            if (response.statusCode === 600) {
                                $scope[entity].$setPristine()   //$dirty = false; (No se tocó el formulario)
                                if (response.statusDetail) {

                                    for (var ndx = 0; ndx < response.statusDetail.length; ndx++) {
                                        var msg = response.statusDetail[ndx];

                                        $scope[entity][msg.field].$setUntouched();
                                        $scope[entity][msg.field].$setValidity('serverError', false);
                                        $scope[entity][msg.field].$error.serverError = msg.message;
                                    }
                                }
                            }
                            $scope[entity].$setSubmitted(); //$submitted = true; (Se envió el formulario)

                            if (response !== null && response.statusCode === 200) {
                                localStoreData.clearForEntity(entity);

                                if ((typeof (response.data.dvm) !== 'undefined') && (typeof (response.data.dvm.dvme) !== 'undefined')) {
                                    //Vuelve a setear el dvme (devuelto por el Update) con los respectivos IDs generados a $scope.formdata
                                    angular.copy(response.data.dvm.dvme, $scope.formdata);
                                }

                                if (response.statusDetail != null && response.statusDetail.insert > 0) {

                                    _self._form.entityId = response.statusDetail.insert;
                                    XhrData.setPkValue(response.statusDetail.insert);

                                    if (window.history.replaceState) {
                                        //prevents browser from storing history with each change:
                                        // $state.go('page.login');
                                        //window.history.pushState("", "title", _self._form.base_url + "#/app/" + _self._form.relativeformPath);
                                        //console.log(_self._form.base_url + "#/app/" + _self._form.relativeformPath);
                                    }
                                }

                                /**
                                 * Retorna a listado
                                $timeout(function() {
                                    $location.path(_self._form.listPath);
                                },5000);
                                */

                            }

                        } else {
                            MsgDisplay.DisplayError(err);
                        }

                        if (typeof (_self.onSave) !== "undefined")
                            _self.onSave(err, response);
                    });

                } else {
                    if ($scope[entity].$submitted) {
                        //campos mal llenados y no corregidos
                        MsgDisplay.DisplayError("Debe cambiar los elementos marcados");
                    } else {
                        //campos mal llenados por primera vez
                        MsgDisplay.DisplayWarning("Hay elementos que no se completaron correctamente");
                    }
                }

            };

            $scope.cancel = function () {
                // document.location = _form.listUrl;
                $location.path(_self._form.listPath);
            };

            $scope.deletex = function () {

                var id = _self._form.entityId;
                var msg = "Borrás este item: " + _self._form.entity + " (Id:" + parseInt(id) + ") ?";

                modalPanelService.showModal({}, {
                    bodyText: msg
                }).then(function (confirma) {
                    if (confirma) {
                        XhrEntity.setEntity(_self._form.entity);
                        XhrEntity.deleteEntity(id, function (err, response) {
                            if (err === null) {
                                MsgDisplay.DisplayResponse(response);
                            }
                            else {
                                MsgDisplay.DisplayError(err);
                            }
                        });
                    } else {
                        console.log("modal cancelada por else");
                    }
                }, function () { // modal cancelada
                    console.log("modal cancelada");
                });

            };
        }])
        /*
        .directive("defaultItemFormButtonpanel", function () {
            return {
                restrictive: "E",
                templateUrl: "app/views/common/itemButtonPanel.html",
                controller: "defaultItemFormButtonCtrl",
                controllerAs: "defaultItemBtnCtrl",
                link:function (scope,element,attrs,controller){
                    if (typeof(attrs.onsave) !== "undefinded")
                        controller.onSave = scope[attrs.onsave];
                }
            };
        })
        */
        ;

})();

(function () {
    'use strict';

    angular.module('detail-form-base-ctrl', [
        'ui.bootstrap', 
        'msg-display', 
        'xhr-basic', 
        'simple-modalpanel', 
        'default-formbuttonctrl', 
        'simple-form', 
        'ui-grid-base-controller', 
        'datetimepicker-ctrl', 
        //'ng-currency', 
        //'msg-table', 
        'ui-grid-utils'
        ])
        .controller('detailFormBaseCtrl', detailFormBaseCtrl);

    detailFormBaseCtrl.$inject = ['$scope', 'XhrData', 'XhrEntity', 'MsgDisplay', 'SimpleForm', 'uiGridConstants', '$window', 'modalPanelService', 'urlProvider', 'MsgTable'];

    function detailFormBaseCtrl($scope, XhrData, XhrEntity, MsgDisplay, SimpleForm, uiGridConstants,  $window, modalPanelService, urlProvider, MsgTable) {

        var _self = this;
        _self.data = XhrData;

        this.entity = '';               //Entidad
        this.entity_itemList = '';      //Lista de items.
        this.entityPk = '';             //Clave Foranea de la Entidad.

        //GridOptions
        this.gridOptions = false;       //Opciones de la tabla, se pueden redefinir o agregar opciones, no obligatoria.
        this.gridRowNgClass = [];       //Lista de Ng-Class (String), formato: [' \'CLASE\':EXPRESION_BOOLEANA '] (OBS: se tiene row.entity como la fila), no obligatoria.
        this.columnDefs = [];           //Columnas definidas para la lista de items.
        this.columnDefs_mobile = [];    //Columnas definidas para cuando la ventana < 500px, no obligatoria.

        //Modal Options
        this.modalTemplate = null;      //Necesaria para Abrir el modal automaticamente con agregarItem_modalOpen
        this.modalController = null;    //modal Controoller, no obligatoria.
        this.modalControllerAs = null;  //modal ControollerAs, no obligatoria.

        //Funciones
        this.agregarItem_modalOpen = function (row) {};         // Funcion que se llama para abrir el modal, no obligatoria si se define un modalTemplate.
        this.forEachRowSendToGrid = function(row){};		// Funcion que se ejecuta justo antes de agregar una fila(row, parámetro) a la tabla(ui-grid), no obligatoria.
        this.agregarItem_modalClose_callback = function(){};    // Callback al cerrar la modal (no tiene parametros),no obligatoria.
        this.getEntityData_callback = function(response){};	// Callback del getEntityData. Atención: es solo un callback, getEntityData no deja de llamar a sus subFunciones, no obligatoria.

        //   Activa el Controlador
        this.activate = function () {

            var _self = this;

            SimpleForm.setEntity(this.entity);
            _self.data.setPkId(this.entityPk);

            var _form = SimpleForm.getForm();
            var id = _form.entityId;

            $scope.newform = _form.newform;
            $scope.formdata = {};
            $scope.comboInfo = {};

            XhrEntity.setEntity(_form.entity);
            XhrEntity.getEntityData(id, function (err, response) {

                if (err === null){
                    if (response.statusCode === 200) {
                        XhrData.setData(response);
                        XhrData.setScope($scope);
                        //SimpleForm.setGrantedOperations(response.data.dvm.config.grantedOperations);

                    }else {
                        MsgDisplay.DisplayResponse(response);
					}
					_self.getEntityData_callback(response);
                }else {
                    MsgDisplay.DisplayError(MsgTable.xhr_error);
                }

            });

            var GridOptions = {
                enableSorting: true,
                enableRowSelection: true,
                multiSelect: false,
                modifierKeysToMultiSelect: false,
                noUnselect: false,
                enableRowHeaderSelection: false,
                columnDefs: this.columnDefs,
                data: []
            };

            // para agregar las classes de css
            if(_self.gridRowNgClass.length > 0){
                var ngClasses = '';
                for(var i in _self.gridRowNgClass){
                    ngClasses += _self.gridRowNgClass[i] +',';
                }
                GridOptions.rowTemplate = '<div ng-repeat="(colRenderIndex, col) in colContainer.renderedColumns track by col.colDef.name" ng-click="getExternalScopes().rowClick(row)" class="ui-grid-cell" ng-class="{'+ngClasses+'\'ui-grid-row-header-cell\': col.isRowHeader }" ui-grid-cell></div>';
            }
            //Extiende GirdOptions por las que quieras pisar en this.gridOptions
            if(_self.gridOptions)
              angular.extend(GridOptions, _self.gridOptions);

            $scope.gridOptions = GridOptions;

            $scope.gridOptions.onRegisterApi = function (gridApi) {
                //set gridApi on scope
                $scope.gridApi = gridApi;
                // row select, clickhandler

                // Si la ventana es chica(< 500px), usa las columnas_mobile (si es que están seteadas)
                if (window.innerWidth < 500 && _self.columnDefs_mobile.length !== 0){
                    $scope.gridOptions.columnDefs = _self.columnDefs_mobile;
                }

                gridApi.selection.on.rowSelectionChanged($scope, function (row) {
                    _self.agregarItem_modalOpen(row.entity);
                });
            };

            //Recalcula las columnas depende al tamaño de la ventana
            $(window).resize(function(){
                if (window.innerWidth < 500 && _self.columnDefs_mobile.length !== 0){
                    $scope.gridOptions.columnDefs = _self.columnDefs_mobile;
                } else {
                    $scope.gridOptions.columnDefs = _self.columnDefs;
                }
            });

            var _entityListRef = "formdata." + this.entity_itemList;

            $scope.$watch(_entityListRef, function (newValue, oldValue) {
                $scope.gridOptions.data = [];
                if (newValue !== null && typeof (newValue) !== 'undefined') {
                    //newValue.forEach(function (row) {
                    for(var _indx  in newValue){
                        var row = newValue[_indx];
                        _self.forEachRowSendToGrid(row);
                        if (typeof (row.__delete) === 'undefined' || row.__delete === false)
                            $scope.gridOptions.data.push(row);
                    }
                    //});
                }
            });


            /**
            * Funcion encargada de abrir el modal, siempre y cuando el controllador que la Extiende
            * no la pise redefiniendola y modalTemplate !== null.
            *
            * Define un Controller si modalController !== null (esta propiedad no es obligatoria)
            * Define un ControllerAs si modalControllerAs !== null (esta propiedad no es obligatoria)
            */
            if(_self.modalTemplate !== null)
            _self.agregarItem_modalOpen = function(row) {
                    var Item = null;

                    if (row !== null && typeof (row) !== "undefined")
                        Item = row;

                    var modalDefaults = {
                        backdrop: true,
                        keyboard: true,
                        size: 'lg',
                        templateUrl: _self.modalTemplate,
                        resolve: {
                            dataConfig: function () {
                                return XhrData.getDataConfig();
                            },
                            formdata: function () {
                                return XhrData.getData().dvm.dvme;
                            },
                            Item: function () {
                                return Item;
                            },
                            Form: function () {
                                return $scope[_self.entity];
                            }
                        }
                    };

                    if(_self.modalController !== null)
                      modalDefaults.controller = _self.modalController;
                    if(_self.modalControllerAs !== null)
                      modalDefaults.controllerAs = _self.modalControllerAs;

                    var modalOptions = {scope: $scope};
                    modalPanelService.show(modalDefaults, modalOptions).then(function(a,e,i){
                        _self.agregarItem_modalClose_callback();
                    });
            };

        };
    }
    ;
})();

/**(function () {

    angular.module('simple-form', [])
            .factory('SimpleForm', ['$location', function ($location) {

                    var _form = new Form($location);

                    this.serverValidation = function(entity){

                    }

                    return {
                        setEntity: function (entityName) {
                            _form.entity = entityName;
                        },
                        setEntityId: function (entityId) {
                            _form.entityId = entityId;
                        },
                        getForm: function () {
                            return _form;
                        },
                        getEntity: function () {
                            return _form.entity;
                        },
                        setGrantedOperations: function (array) {
                            _form.grantedOperations = array;
                        }
                    };

                }])
                .directive('focus', function ($timeout) {
                    return {
                        scope: {trigger: '@focus'},
                        link: function (scope, element) {
                            var elem = element[0];
                            scope.$watch('trigger', function (value) {
                                if (value === "focus") {
                                    $timeout(function () {
                                        elem.focus();
                                    });
                                }
                            });
                        }
                    };
                })
                .directive('selectOnClick', ['$window', function ($window) {
                    return {
                        restrict: 'A',
                        link: function (scope, element, attrs) {
                            element.on('click', function () {
                                if (!$window.getSelection().toString()) {
                                    // Required for mobile Safari
                                    this.setSelectionRange(0, this.value.length);
                                }
                            });
                        }
                    };
                }])
                .directive('serverValidation',["$compile",function($compile){
                    return {
                      restrict: 'A',
                      require: 'ngModel',
                      link: function(scope, element, attrs, ngModel){
                          var form = element[0].form;
                          var form_name = $(form)[0].name;
                          var input_name = ngModel.$name;

                          var elem = angular.element('<small ng-show="'+form_name+'.$submitted && '+form_name+'.'+input_name+'.$untouched" class="text-danger">{{ '+form_name+'.'+input_name+'.$error.serverError }}</small>');
                          elem.insertAfter(element);
                          $compile(elem)(scope);
                      }
                    };
                }])
                .directive('selectTextOnfocus',[function(){
                    return{
                        restrict: 'A',
                        require: 'ngModel',
                        link: function(scope, element, attrs, ngModel){
                            element[0].onfocus = function(e){
                                var input = $(this);
                                setTimeout(function () { input.select(); });
                            }
                        }
                    };
                }])
                .directive('checkboxList',["$parse",function($parse){
                    function checkboxCtrl(){
                    }
                    return{
                        restrict: 'E',
                        templateUrl: function (elem, attrs) {
                        return 'app/views/common/checkboxList.html';
                        },
                        controller: checkboxCtrl,
                        controllerAs:'checkboxCtrl',
                        link: function(scope, element, attrs, ctrl){
                            ctrl.buttonList = $parse(attrs.buttonlist)(scope);
                        }
                    };
                }])
                ;



    Form = function (location) {

        this.base_url = $("base").attr("href");
        this._entity;
        this.entityLocationKey;
        this.listUrl;
        this.listPath;

        this._entityId;
        this.relativeformPath;
        this.newform = false;

        this._grantedOperations;
        this.showBtnSave = true;
        this.showBtnDelete = true;
        this.showBtnCancel = true;

        Object.defineProperty(this, "grantedOperations", {
            get: function () {
                return this._grantedOperations;
            },
            set: function (array) {
                if (typeof (array) !== "undefined") {
                    this._grantedOperations = array;
                    this.showBtnSave = true;
                    this.showBtnDelete = true;
                    this.showBtnCancel = true;

                    if (this._grantedOperations.indexOf("update") === -1)
                        this.showBtnSave = false;
                    if (this._grantedOperations.indexOf("delete") === -1)
                        this.showBtnDelete = false;
                    if (this._grantedOperations.indexOf("cancel") === -1)
                        this.showBtnCancel = false;
                }
            }
        });

        Object.defineProperty(this, "entity", {
            get: function () {
                return this._entity;
            },
            set: function (entity) {
                this._entity = entity;
                this.entityLocationKey = entity;// + "Ext";
                // this.listUrl = this.base_url + "/" + this._entity;
                this.listUrl = this.base_url + "/#/app/" + this._entity + "List";
                this.listPath = "app/" + this._entity + "List";

                var path_arr = location.path().split("/");
                if (path_arr.length > 1)
                    this._entityId = path_arr[path_arr.length - 1];
                // this._entityId = routeParams.id;

                this.newform = false;
                if (this._entityId === "new")
                    this.newform = true;

                  this.showBtnSave = true;
                  this.showBtnDelete = true;
                  this.showBtnCancel = true;

            }
        });


        Object.defineProperty(this, "entityId", {
            get: function () {
                return this._entityId;
            },
            set: function (entityId) {
                this._entityId = entityId;
                this.relativeformPath = this.entityLocationKey + "/" + this._entityId;
                this.newform = false;
                if (this._entityId === "new")
                    this.newform = true;

            }
        });

    };
})();*/

(function () {

    angular.module('lifecycle-button-mod', [])
        .controller('defaultLifecycleButtonCtrl', defaultLifecycleButtonCtrl)
        .directive("lifecycleActionButtonpanel", function () {
            return {
                restrictive: "E",
                templateUrl: "app/views/common/lifecycleButtonPanel.html",
                controller: "defaultLifecycleButtonCtrl"
            };
        });

    defaultLifecycleButtonCtrl.$inject = ["$scope", "XhrEntity", "MsgDisplay", "infoModalPanelService", "SimpleForm", "XhrData", "modalPanelService", "localStoreData"];

    function defaultLifecycleButtonCtrl($scope, XhrEntity, MsgDisplay, infoModalPanelService, SimpleForm, XhrData, modalPanelService, localStoreData) {
        var _self = this;

        $scope.lifeCycleEvent = function (action) {

            if ( angular.isDefined(action.validate_form_field) && action.validate_form_field !== null) {
                var fieldValue = XhrData.getFieldValue(action.validate_form_field);

                if (typeof (fieldValue) !== "undefined" && fieldValue !== "" && fieldValue !== null) {
                    $scope.showPanelOk(action);
                } else {
                    $scope.showPanelAlert(action);
                }
            } else {
                $scope.showPanelOk(action);
            }

        };

        $scope.showPanelAlert = function (action) {
            var msg = action.error_message;

            if (action.need_confirm) {
                modalPanelService.showModalAlert({}, {bodyText: msg});
            }
        };

        $scope.showPanelOk = function (action) {
            var _form = SimpleForm.getForm();
            var id = _form.entityId;

            var txData = {
                action: action,
                data: {
                    id: id
                }
            };

            var msg = action.action + " " + _form.entity + " ?";

            if (action.need_confirm) {

                infoModalPanelService.showModal({scope: $scope}, {bodyText: msg}, action.get_info)
                    .then(function (modalFormData) {

                        if (modalFormData !== null) {

                            txData.data.formData = modalFormData;
                            txData.data.id = id;
                            txData.data.validate_form_field = $scope.formdata[action.validate_form_field];

                            _self.postActionLifeCycleStateChange(_form.entity, txData);
                        }
                    }, function () { /* modal cancelada*/
                    });

            } else {

                _self.postActionLifeCycleStateChange(_form.entity, txData);
            }
        };


        this.postActionLifeCycleStateChange = function (entity,data){
            XhrEntity.setEntity(entity);
            XhrEntity.postAction("lifeCycleStateChange", data, function (err, response) {
                if (err === null) {
                    MsgDisplay.DisplayResponse(response);
                    XhrEntity.refresh(function (err, response) {
                        XhrData.setData(response);
                        XhrData.setScope($scope);
                        localStoreData.clearForEntity(entity);

                        //Para que pueda cambiar los botones inferiores
                        if(response.data && response.data.dvm){
                            if(response.data.dvm.config && response.data.dvm.config.grantedOperations){
                                SimpleForm.setGrantedOperations(response.data.dvm.config.grantedOperations);
                            }
                        }
                    });

                } else
                    MsgDisplay.DisplayError_Msg(err);
            });
        }

    }

})();
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

(function () {
    'use strict';

    angular.module("app.mapDrawDirections",[])   

    .directive('mapDrawDirections',['$q','$timeout','$parse', 'misc',

        function($q, $timeout, $parse, misc) {
            
            function mapDirectionsController() {
                var _self = this;

                _self.floatingPanelShow = false;
                _self.mapFloatingPanel = 'map-floating-panel';
                _self.error_position_coordinates = "Error en la posicion por coordenadas";
                _self.error_position_address = "Error en la posicion por domicilio";

                _self.wrapMapElement;
                _self.mapElement;

                _self.cssClass = "";
                _self.geocoder = new google.maps.Geocoder();

                _self.mapOptions = {
                    zoom: 11,
                    center: new google.maps.LatLng(-34.5218, -58.4873),
                    mapTypeId: google.maps.MapTypeId.ROADMAP
                };

                _self.init = function() {
                    _self.mapElement = _self.wrapMapElement[0].querySelector('.map');
                    _self.map = new google.maps.Map(_self.mapElement, _self.mapOptions);                    
                    _self.directionsService = new google.maps.DirectionsService();
                }

                _self.addMarker = function(map, position) {
                    return new google.maps.Marker({
                    position: position,
                    map: map
                    });
                };

                _self.setCenter = function (location) {
                    _self.Resize();
                    _self.map.setCenter(location);
                }

                _self.Resize = function() {
                        google.maps.event.trigger(_self.map, 'resize');
                }

                _self.getCurrentPosition = function() {
                    var _myPosition;

                    var deferred = $q.defer();

                    if (navigator.geolocation) {
                        navigator.geolocation.getCurrentPosition(
                            function(position) {
                                var _myPos = {
                                    lat: position.coords.latitude,
                                    lng: position.coords.longitude
                                }

                                _myPosition = new google.maps.LatLng(_myPos.lat, _myPos.lng);
                                deferred.resolve(_myPosition);
                            });
                    }
                    return deferred.promise;
                }

                _self.addMarkerForCurrentPosition = function() {
                     _self.getCurrentPosition()
                             .then( function(_myPosition) {
                                 _self.addMarker(_self.map, _myPosition);
                                 _self.setCenter(_myPosition);
                            });
                };

                _self.getPositionByAddress = function(_address) {

                    var deferred = $q.defer();

                    _self.geocoder.geocode({
                            'address': _address
                        }, function(results, status){
                            if(status == google.maps.GeocoderStatus.OK) {
                                var _location = results[0].geometry.location;
                                deferred.resolve(_location);
                            } else {
                                deferred.reject(_self.error_position_address);
                            }
                        }
                    );
                    return deferred.promise;

                }

                _self.setMarkerByAddress = function(_address) {

                    _self.getPositionByAddress(_address)
                            .then( function(_location) {
                                _self.addMarker(_self.map, _location);
                                _self.setCenter(_location);
                            });

                };

                _self.getPositionByCoordinates = function(position) {

                    var deferred = $q.defer();

                    _self.geocoder.geocode({
                            'latLng': position
                        }, function(results, status){
                            if (status == google.maps.GeocoderStatus.OK) {
                                var _location = results[0].geometry.location;
                                deferred.resolve(_location);
                            } else {
                                deferred.reject(_self.error_position_coordinates);
                            }
                        }
                    );

                    return deferred.promise;
                };

                _self.setMarkerByCoordinates = function(lat, lng) {

                    var _position = new google.maps.LatLng(Number(lat), Number(lng));

                    _self.getPositionByCoordinates(_position)
                            .then( function(_location) {
                                _self.addMarker(_self.map, _location);
                                _self.setCenter(_location);
                            });
                };

                _self.setMarkers = function(markerList){
                    markerList.forEach(function(marker){
                        var _address = marker.address;
                        var _lat = marker.coordinates.lat;
                        var _lng = marker.coordinates.lng;
                        if ( _self.validCoordinate(_lat, _lng)){
                            _self.setMarkerByCoordinates(_lat, _lng);
                        }else
                            _self.setMarkerByAddress(_address);
                    });
                }


                _self.addTrafficLayer = function() {
                    _self.trafficLayer = new google.maps.TrafficLayer();
                    _self.trafficLayer.setMap(_self.map);
                }

                _self.getDirectionsRender = function() {
                    var directionsDisplay = new google.maps.DirectionsRenderer();
                    directionsDisplay.setMap(_self.map);
                    return directionsDisplay;
                }

                _self.showFloatingPanel = function(html){

                    _self.floatingPanelShow = true;
                    var divMapLabel = _self.wrapMapElement[0].querySelector('.map-label');
                    $(divMapLabel).html(html);

                    $timeout(function() {
                        _self.Resize();
                    },1000);


                }

                _self.showDistanciaYDuracionToFloatingPanel = function(route){
                    var trip_distance_mts = 0, trip_time_sec = 0;
                    var trip_distance = "", trip_time = "";
                    for (var i=0; i<route.legs.length; i++) {
                        trip_distance_mts += route.legs[i].distance.value;
                        trip_time_sec += route.legs[0].duration.value;
                    }
                    trip_distance = trip_distance_mts / 1000 + " km";
                    trip_time = misc.SecondsToHoursMinutesSec(trip_time_sec);
                    
                    var html = '<p style="margin:inherit;">Distancia: '+trip_distance+', Duración: '+trip_time+' </p>';
                    _self.showFloatingPanel(html);
                }

                _self.calcRoute = function(start, markerList) {
                    
                    if (typeof(markerList)==="undefined") return false;
                    
                    var _start = angular.copy(start);
                    var _end_lat = markerList[markerList.length - 1].coordinates.lat;
                    var _end_lng = markerList[markerList.length - 1].coordinates.lng;
                    if(_end_lat && _end_lng){
                        var _end = new google.maps.LatLng(_end_lat, _end_lng);
                    }else{
                        var _end = markerList[markerList.length - 1].address;
                    }
                    
                    var _waypts = [];
                    var _directionsRender;

                    var request = {
                        origin:_start,
                        destination:_end,
                        waypoints: _waypts,
                        //optimizeWaypoints: true, SIRVE SI QUIERO QUE OPTIMICE LA RUTA REORDENANDO LOS WAYPOINTS COMO CREA CONVENIENTE.
                        travelMode: google.maps.TravelMode.DRIVING,
                        drivingOptions: {
                            departureTime: new Date(Date.now() + 60000),  // for the time N milliseconds from now.
                            trafficModel: google.maps.TrafficModel.PESSIMISTIC
                        }
                    };

                    for (var i = 0; i < Math.min(markerList.length - 1,8); i++){
                        var _lat = markerList[i].coordinates.lat;
                        var _lng = markerList[i].coordinates.lng;
                        if(_lat && _lng){
                            var _location = new google.maps.LatLng(_lat, _lng);
                        }else{
                            var _location = markerList[i].address;
                        }
                        _waypts.push({
                            location: _location,
                            stopover: true
                        });
                    }

                    _self.directionsService.route(request,
                        function(response, status) {                            
                            if (status == google.maps.DirectionsStatus.OK) {                                
                                _self.showDistanciaYDuracionToFloatingPanel(response.routes[0]);
                                _directionsRender = new google.maps.DirectionsRenderer();
                                _directionsRender.setMap(_self.map);
                                _directionsRender.setDirections(response);
                            }
                        }
                    )
                    _self.Resize();
                };
                
                

                _self.validCoordinate  = function (lat, long) {
                    if (typeof(lat) !== "undefined" && lat !== null && lat !== "" )
                        return true;
                    return false;
                };
        }

        return {
            restrict: 'E',
            templateUrl: function (elem, attrs) {
                return 'app/views/common/mapDraw.html';
            },
            controller: mapDirectionsController,
            controllerAs:'mapController',
            link: function(scope, element, attrs, ctrl){
                var _markerList = $parse(attrs.mapMarkerList)(scope);
                attrs.$observe('mapMarkerList', function(val) {
                    var _listMarker = $parse(val)(scope);
                    if ($parse(attrs.mapTriggerVarname)(scope) === attrs.mapTriggerValue) {
                        if (typeof(attrs.mapAddDirections) !== "undefined") {
                            if(attrs.useCurrentPosition){
                                ctrl.getCurrentPosition()
                                    .then( function(_curPos) {
                                        ctrl.calcRoute(_curPos, _listMarker);
                                    });
                            } else {
                                // se hace esto porque la funcion getCurrentPosition no funciona en http (para chrome).
                                var _posActual = _listMarker[0];                               
                                if (_posActual.coordinates.lat && _posActual.coordinates.lng)
                                    _posActual = new google.maps.LatLng(_posActual.coordinates.lat, _posActual.coordinates.lng);
                                else
                                    _posActual = _posActual.address;
                                _listMarker.shift();
                                ctrl.calcRoute(_posActual, _listMarker);
                            }
                        }else{
                            ctrl.setMarkers(_listMarker);
                        }
                    }                    
                });
                ctrl.wrapMapElement = element;

                if (typeof(attrs.mapCssClass) !== "undefined"){
                    ctrl.cssClass = attrs.mapCssClass;
                }

                ctrl.init();
                                
                if (typeof(attrs.mapTriggerVarname) !== "undefined") {
                    
                    scope.$watch(attrs.mapTriggerVarname, function(newValue, oldValue) {                       
                        if (newValue === attrs.mapTriggerValue) {
                            if (typeof(attrs.mapAddDirections) !== "undefined") {
                                ctrl.getCurrentPosition()
                                    .then( function(_curPos) {
                                        ctrl.calcRoute(_curPos, _markerList);
                                });
                            }else{
                                ctrl.setMarkers(_markerList);
                            }
                        }

                    });

                } else {
                    if (typeof(attrs.mapAddDirections) !== "undefined") {
                        ctrl.getCurrentPosition()
                            .then( function(_curPos) {
                                ctrl.calcRoute(_curPos, _markerList);
                        });
                    }else{
                        ctrl.setMarkers(_markerList);
                        if (typeof(attrs.mapAddCurrentPositionMarker) !== "undefined") {
                            ctrl.addMarkerForCurrentPosition();
                        }
                    }
                }

                if (typeof(attrs.mapTrafficLayer) !== "undefined") {
                    ctrl.addTrafficLayer();
                }

            }
        };
}]);

})();

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/*(function () {
    'use strict';

    angular.module("app.mapDraw",[])

    .directive('mapDraw',['$q','$timeout','$parse',

        function($q, $timeout, $parse) {

            function mapController() {

                var _self = this;
                var _labels = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
                var _labelIndex = 1;

                _self.floatingPanelShow = false;
                _self.mapFloatingPanel = 'map-floating-panel';
                _self.error_position_coordinates = "Error en la posicion por coordenadas";
                _self.error_position_address = "Error en la posicion por domicilio";

                _self.id = "map";
                _self.cssClass = "";

                _self.geocoder = new google.maps.Geocoder();

                _self.mapOptions = {
                    zoom: 11,
                    center: new google.maps.LatLng(-34.5218, -58.4873),
                    mapTypeId: google.maps.MapTypeId.ROADMAP
                };

                _self.init = function(element) {
                    _self.map = new google.maps.Map(element, _self.mapOptions);
                    _self.directionsService = new google.maps.DirectionsService();
                }

                _self.addMarker = function(map, position) {
                    return new google.maps.Marker({
                    position: position,
                    map: map
                    });
                };

                _self.setCenter = function (location) {
                    google.maps.event.trigger(_self.map, 'resize');
                    _self.map.setCenter(location);
                }

                _self.getCurrentPosition = function() {
                    var _myPosition;

                    var deferred = $q.defer();

                    if (navigator.geolocation) {
                        navigator.geolocation.getCurrentPosition(
                            function(position) {
                                var _myPos = {
                                    lat: position.coords.latitude,
                                    lng: position.coords.longitude
                                }

                                _myPosition = new google.maps.LatLng(_myPos.lat, _myPos.lng);
                                deferred.resolve(_myPosition);
                            });
                    }
                    return deferred.promise;
                }

                _self.addMarkerForCurrentPosition = function() {
                     _self.getCurrentPosition()
                             .then( function(_myPosition) {
                                 _self.addMarker(_self.map, _myPosition);
                                 _self.setCenter(_myPosition);
                            });
                };

                _self.getPositionByAddress = function(_address) {

                    var deferred = $q.defer();

                    _self.geocoder.geocode({
                            'address': _address
                        }, function(results, status){
                            if(status == google.maps.GeocoderStatus.OK) {
                                var _location = results[0].geometry.location;
                                deferred.resolve(_location);
                            } else {
                                deferred.reject(_self.error_position_address);
                            }
                        }
                    );
                    return deferred.promise;

                }

                _self.setMarkerByAddress = function(_address) {

                    _self.getPositionByAddress(_address)
                            .then( function(_location) {
                                _self.addMarker(_self.map, _location);
                                _self.setCenter(_location);
                            });

                };

                _self.getPositionByCoordinates = function(position) {

                    var deferred = $q.defer();

                    _self.geocoder.geocode({
                            'latLng': position
                        }, function(results, status){
                            if (status == google.maps.GeocoderStatus.OK) {
                                var _location = results[0].geometry.location;
                                deferred.resolve(_location);
                            } else {
                                deferred.reject(_self.error_position_coordinates);
                            }
                        }
                    );

                    return deferred.promise;
                };

                _self.setMarkerByCoordinates = function(lat, lng) {

                    var _position = new google.maps.LatLng(Number(lat), Number(lng));

                    _self.getPositionByCoordinates(_position)
                            .then( function(_location) {
                                console.log(_location);
                                _self.addMarker(_self.map, _location);
                                _self.setCenter(_location);
                            });
                };

                _self.setMarkers = function(markerList){
                    markerList.forEach(function(marker){
                        var _address = marker.address;
                        var _lat = marker.coordinates.lat;
                        var _lng = marker.coordinates.lng;
                        if ( _self.validCoordinate(_lat, _lng))
                            _self.setMarkerByCoordinates(_lat, _lng);
                        else
                            _self.setMarkerByAddress(_address);
                    });
                }


                _self.addTrafficLayer = function() {
                    _self.trafficLayer = new google.maps.TrafficLayer();
                    _self.trafficLayer.setMap(_self.map);
                }

                _self.getDirectionsRender = function() {
                    var directionsDisplay = new google.maps.DirectionsRenderer();
                    directionsDisplay.setMap(_self.map);
                    return directionsDisplay;
                }

                _self.showFloatingPanel = function(html){
                    _self.floatingPanelShow = true;
                    var element = document.getElementById(_self.mapFloatingPanel);
                    $(element).html("");
                    $(element).append(html);
                }

                _self.showDistanciaYDuracionToFloatingPanel = function(distancia,duracion){
                    var html = '<p style="margin:inherit;">Distancia: '+distancia+', Duración: '+duracion+'</p>';
                    _self.showFloatingPanel(html);
                }

                _self.calcRoute = function(start, markerList) {
                    var _start = angular.copy(start);
                    var _directionsRender;

                    for (var i = 0; i < markerList.length; i++) {

                        var _end = markerList[i].address;
                        var request = {
                            origin:_start,
                            destination:_end,
                            travelMode: google.maps.TravelMode.DRIVING,
                            drivingOptions: {
                                departureTime: new Date(Date.now() + 60000),  // for the time N milliseconds from now.
                                trafficModel: google.maps.TrafficModel.PESSIMISTIC
                            }
                        };

                        _self.directionsService.route(request,
                            function(response, status) {
                                if (status == google.maps.DirectionsStatus.OK) {
                                    _self.showDistanciaYDuracionToFloatingPanel(response.routes[0].legs[0].distance.text, response.routes[0].legs[0].duration.text);
                                    _directionsRender = new google.maps.DirectionsRenderer();
                                    _directionsRender.setMap(_self.map);
                                    _directionsRender.setDirections(response);
                                    
                                    console.log(response);
                                }
                        });
                        _start = _end;
                    }
                };

                _self.validCoordinate  = function (lat, long) {
                    if (typeof(lat) !== "undefined" && lat !== null && lat !== "" )
                        return true;
                    return false;
                };
        }

        return {
            restrict: 'E',
            templateUrl: function (elem, attrs) {
                return 'app/views/common/mapDraw.html';
            },
            controller: mapController,
            controllerAs:'mapController',
            link: function(scope, element, attrs, ctrl){

                var _markerList = $parse(attrs.mapMarkerList)(scope);

                var map = element[0].querySelector('.map');
                if (typeof(attrs.mapCssClass) !== "undefined"){
                    ctrl.cssClass = attrs.mapCssClass;
                }

                ctrl.init(map);

                if (typeof(attrs.mapTriggerVarname) !== "undefined") {
                    scope.$watch(attrs.mapTriggerVarname, function(newValue, oldValue) {

                        if (newValue === attrs.mapTriggerValue) {                            
                            if (typeof(attrs.mapAddDirections) !== "undefined") {
                                ctrl.getCurrentPosition()
                                    .then( function(_curPos) {
                                        ctrl.calcRoute(_curPos, _markerList);
                                });
                            }else{
                                ctrl.setMarkers(_markerList);
                            }
                        }

                    });

                } else {
                    ctrl.setMarkers(_markerList);

                    if (typeof(attrs.mapAddCurrentPositionMarker) !== "undefined") {
                        ctrl.addMarkerForCurrentPosition();
                    }

                    if (typeof(attrs.mapAddDirections) !== "undefined") {
                        ctrl.getCurrentPosition()
                            .then( function(_curPos) {
                                ctrl.calcRoute(_curPos, _markerList);
                        });
                    }

                }

                if (typeof(attrs.mapTrafficLayer) !== "undefined") {
                    ctrl.addTrafficLayer();
                }
                
            }
        };
}]);

})();
*/
(function () {
    
        
    angular.module('app.mapDrawMarkerListService',[])
            .service('mapDrawMarkerListService', [ function () {
                
                var _self = this;
                                
                function mapMarkerListMember(){
                    return {
                        'coordinates': {'lat': null,'lng': null},
                        'address': '',
                        'info': {'title': null, 'subtitle': null, 'text': null},
                        'icon': {}
                    }
                };                                             
                
                this.mapMarkerList = new Array();
                
                this.addMarker = function(latLngCoord, completeAddress, labelTextInfo){
                    if((typeof(latLngCoord) !== "undefined" && latLngCoord !== null) || (typeof(completeAddress) !== "undefined" && completeAddress !== null)){
                        var _mapMarker = new mapMarkerListMember();
                        if(typeof(latLngCoord) !== "undefined" && latLngCoord !== null){
                            if(typeof(latLngCoord.lat) === 'string'){
                                _mapMarker.coordinates.lat = latLngCoord.lat;
                            }                              
                            if(typeof(latLngCoord.lng) === 'string'){
                                _mapMarker.coordinates.lng = latLngCoord.lng;
                            }                                
                        }
                        
                        if(completeAddress !== null && typeof(completeAddress) === 'string'){
                            _mapMarker.address = completeAddress;
                        }
                        
                        if(typeof(labelTextInfo) !== "undefined" && labelTextInfo !== null){
                            if (typeof(labelTextInfo.title) !== 'undefined')
                                _mapMarker.info.title = labelTextInfo.title;
                            if (typeof(labelTextInfo.subtitle) !== 'undefined')
                                _mapMarker.info.subtitle = labelTextInfo.subtitle;
                            if (typeof(labelTextInfo.text) !== 'undefined')
                                _mapMarker.info.text = labelTextInfo.text;
                        }
                        
                        
                        var _length = this.mapMarkerList.length;
                        this.mapMarkerList[_length] = _mapMarker;
                    }
                };      
                
                this.addMarkerObj =  function(markerObj) {
                    var _length = this.mapMarkerList.length;
                    this.mapMarkerList[_length] = markerObj;
                }
                
                this.getInstanceMapMarkerListMember = function(){
                    return new mapMarkerListMember();
                }
                
                this.getList = function() {
                    return this.mapMarkerList;
                }
                
                this.initList = function() {
                    this.mapMarkerList = new Array();
                }
                                                                                                
            }]);
})();

(function () {
    'use strict';

    angular.module("app.mapDrawMarkers", [])

        .directive('mapDrawMarkers', ['$q', '$timeout', '$parse', 'misc',
            function ($q, $timeout, $parse, misc) {

                function mapMarkersController() {

                    var _self = this;

                    this.overflow = false;

                    _self.floatingPanelShow = false;
                    _self.mapFloatingPanel = 'map-floating-panel';
                    _self.error_position_coordinates = "Error en la posicion por coordenadas";
                    _self.error_position_address = "Error en la posicion por domicilio";
                    _self.mapSetInfoWindow = false;
                    _self.wrapMapElement;
                    _self.mapElement;
                    _self._markersAddedToMap = [];

                    _self.cssClass = "";
                    _self.geocoder = new google.maps.Geocoder();

                    _self.mapOptions = {
                        zoom: 11,
                        center: new google.maps.LatLng(-34.5218, -58.4873),
                        mapTypeId: google.maps.MapTypeId.ROADMAP
                    };

                    _self.init = function () {
                        _self.mapElement = _self.wrapMapElement[0].querySelector('.map');
                        _self.map = new google.maps.Map(_self.mapElement, _self.mapOptions);
                    }
                    
                    var _icon = {
                        path: 'M 0,0 C -2,-20 -10,-22 -10,-30 A 10,10 0 1,1 10,-30 C 10,-22 2,-20 0,0 z M -2,-30 a 2,2 0 1,1 4,0 2,2 0 1,1 -4,0z',
                        scale: 1,
                        fillColor: 'red',
                        fillOpacity: 1.0,
                        strokeColor: 'black',
                        strokeOpacity: 0.5,
                        strokeWeight: 2
                    }
                    
                    _self.addMarker = function (map, position, info, icon) {
                        var _iconx = {};
                        angular.copy(_icon, _iconx);
                        angular.extend(_iconx, icon);
                        
                        var _location = new google.maps.LatLng(Number(-34.5213039), Number(-58.4897496));
                        _self.setCenter(_location);
                        var Marker = new google.maps.Marker({
                            position: position,
                            map: map,
                            icon: _iconx
                        });
                        
                        _self._markersAddedToMap.push(Marker);

                        if (_self.mapSetInfoWindow) {
                            if (typeof (info.title) !== "undefined" && info.title != null) {
                                var _content = '<h4>' + info.title + '</h4><h6>' + info.subtitle + '</h6><h8>' + info.text + '</h8>';

                                var data = new google.maps.InfoWindow({
                                    content: _content,
                                    notOpened: true
                                });

                                google.maps.event.addListener(Marker, "click", function (e) {
                                    if (data.notOpened) {
                                        data.open(map, this);
                                        data.notOpened = false;
                                    } else {
                                        data.close(map, this);
                                        data.notOpened = true;
                                    }
                                });
                            }
                        }

                        return Marker;
                    };

                    _self.setCenter = function (location) {
                        _self.map.setCenter(location);
                    }

                    _self.Resize = function () {
                        google.maps.event.trigger(_self.map, 'resize');
                    }

                    _self.getPositionByAddress = function (_address) {
                        var deferred = $q.defer();
                        _self.geocoder.geocode({
                            'address': _address
                        }, function (results, status) {
                            if (status == google.maps.GeocoderStatus.OK) {
                                var _location = results[0].geometry.location;
                                deferred.resolve(_location);
                            } else {
                                deferred.reject(status);
                            }
                        }
                        );
                        return deferred.promise;

                    }

                    _self.getPositionByCoordinates = function (position) {
                        var deferred = $q.defer();
                        _self.geocoder.geocode({
                            'latLng': position
                        }, function (results, status) {
                            if (status == google.maps.GeocoderStatus.OK) {
                                var _location = results[0].geometry.location;
                                deferred.resolve(_location);
                            } else {
                                deferred.reject(status);
                            }
                        }
                        );

                        return deferred.promise;
                    };

                    _self.setMarkerByAddress = function (marker) {
                        var deferred = $q.defer();
                        var _address = marker.address;
                        var _info = marker.info;
                        var _icon = marker.icon;
                        _self.getPositionByAddress(_address)
                            .then(function (_location) {
                                marker.added = true;
                                _self.addMarker(_self.map, _location, _info, _icon);
                                deferred.resolve(marker);
                            }, function (error) {
                                marker.added = false;
                                marker.status = error;
                                deferred.reject(marker);
                            });
                        return deferred.promise;
                    };


                    _self.setMarkerByCoordinates = function (marker) {
                        var deferred = $q.defer();
                        var lat = marker.coordinates.lat;
                        var lng = marker.coordinates.lng;
                        var _info = marker.info;
                        var _icon = marker.icon;

                        var _position = new google.maps.LatLng(Number(lat), Number(lng));

                        _self.getPositionByCoordinates(_position)
                            .then(function (_location) {
                                marker.added = true;
                                _self.addMarker(_self.map, _location, _info, _icon);
                                deferred.resolve(marker);
                            }, function (error) {
                                marker.added = false;
                                marker.status = error;
                                deferred.reject(marker);
                            });
                        return deferred.promise;
                    };

                    _self.getFirstMarkerNotAdded = function (markerList) {
                        var _ret = false;
                        markerList.forEach(function (marker) {
                            if (typeof (marker.added) === "undefined" || !marker.added) {
                                marker.added = false;
                                _ret = marker;
                                return _ret;
                            }

                        });
                        return _ret;
                    }

                    var overflow = false;

                    _self.setMarker = function (marker) {

                        var deferred = $q.defer();

                        if (_self.validCoordinate(marker)) {
                            _self.setMarkerByCoordinates(marker)
                                .then(function () {
                                    deferred.resolve(marker);
                                }, function (marker) {
                                    deferred.reject(marker);
                                });
                        } else {
                            _self.setMarkerByAddress(marker)
                                .then(function () {
                                    deferred.resolve(marker);
                                }, function (marker) {
                                    deferred.reject(marker);
                                });

                        };

                        return deferred.promise;
                    };


                    var first = true;
                    var _count = 0;
                    
                    _self.setMarkers = function (markerList) {
                        _count++;
                        if (typeof (markerList) === "undefined")
                            return false;

                        if (first)
                            _self.Resize();
                                                
                        var marker = _self.getFirstMarkerNotAdded(markerList);
                        
                        if (marker && _count <= 100) {
                            if (!marker.added) {
                                _self.setMarker(marker)
                                    .then(
                                    function (markerx) {
                                        markerx.added = true;
                                        _self.setMarkers(markerList);
                                        if (first) _self.Resize();
                                        first = false;
                                    },
                                    function (markerx) {
                                        if (markerx.status === "OVER_QUERY_LIMIT") {
                                            markerx.added = false;
                                        } else {
                                            markerx.added = true;
                                            // con error
                                        }
                                        $timeout(function () {
                                            _self.setMarkers(markerList);
                                        }, 1500);

                                    });
                            }
                        }
                        
                    };

                    _self.validCoordinate = function (marker) {

                        var lat = marker.coordinates.lat;
                        var lng = marker.coordinates.lng;

                        if (typeof (lat) !== "undefined" && lat !== null && lat !== "")
                            return true;
                        return false;
                    };
                }

                return {
                    restrict: 'E',
                    templateUrl: function (elem, attrs) {
                        return 'app/views/common/mapDraw.html';
                    },
                    controller: mapMarkersController,
                    controllerAs: 'mapController',
                    link: function (scope, element, attrs, ctrl) {
                        var _markerList = $parse(attrs.mapMarkerListReference)(scope);

                        // Observa los cambios de la lista mapMarkerList.
                        // si hubiera alguno, elimina todas las marcas 
                        // para luego volverlas a procesar en el watch
                        attrs.$observe('mapMarkerList', function (val) {
                            var _listMarker = $parse(val)(scope);
                            _markerList = _listMarker;
                            var _markersInMap = ctrl._markersAddedToMap;
                            for (var i=0; i < _markersInMap.length; i++){
                                _markersInMap[i].setMap(null);
                            }
                            ctrl._markersAddedToMap = [];
                        });

                        if (typeof (attrs.mapSetInfoWindow !== "undefined")) {
                            ctrl.mapSetInfoWindow = attrs.mapSetInfoWindow;
                        }

                        ctrl.wrapMapElement = element;

                        if (typeof (attrs.mapCssClass) !== "undefined") {
                            ctrl.cssClass = attrs.mapCssClass;
                        }

                        // Inicializa el mapa
                        ctrl.init();

                        if (typeof (attrs.mapTriggerVarname) !== "undefined") {

                            scope.$watch(attrs.mapTriggerVarname, function (newValue, oldValue) {
                                                           
                                // Si el triggerVarName = triggerValue, o sea la condicion para mostrar el mapa se da
                                // setea la lista de markers en el mapa
                                if (newValue === attrs.mapTriggerValue) {
                                    ctrl.setMarkers(_markerList);
                                }

                            });

                        } else {
                            ctrl.setMarkers(_markerList);
                        }
                    }
                };
            }]);

})();
( function () {

/**
 * ----------------------------------------------------------------------------- 
 * Append Message
 * -----------------------------------------------------------------------------
 */
/**
 * 
 * @param {String} msg_container_id
 * @returns {App_Message}
 */
angular.module('msg-display',[])

.factory('MsgDisplay', [ 'toaster' , function( toaster ) {
	
    var	msgType = { error: 'error', info: 'info', wait: 'wait', warning: 'warning', success:'success'};
    var	msgTitle = { error: 'Error', info: 'info', wait: 'Espera', warning: 'Atencion', success:'Ok'};
	
    Display = function(text, type) {
    	var title = msgTitle[type];    	
        toaster.pop(type, title, text);
    };
    
    DisplayResponse = function(response) {    	
    	if (response.statusCode === 200) {
    		Display(response.statusMsg, msgType.success);
    	} else {
    		Display(response.statusMsg, msgType.error);
    	}
    };
    
    return {
    	DisplayResponse: function(response) {
    		DisplayResponse(response);
    		
    	},
    	DisplayError: function(err) {
    		Display(err, msgType.error);        		
    	},
    	DisplayInfo: function(err) {
    		Display(err, msgType.info);        		
    	},
        DisplayWarning: function(msg){
            Display(msg, msgType.warning);
        }	
    	    
    };

}]);


function App_Message(msg_container_id) {
    
    
    this._msg_container_id;
    this.msg_container_obj;
    
    this.status_code="";
    this.status_msg="";
    this.status_detail="";
    
    this.response_obj;
    this.response_obj_null = false;
    
    this.style_class="";
    
    App_Message.prototype.ok_msg = "Ok";
    App_Message.prototype.ok_status_code = 200;
    
    this.msg_type = "ok";
    this.is_error = false;
    
    App_Message.prototype.error_style_class = "alert-danger";
    App_Message.prototype.success_style_class = "alert-success";
    App_Message.prototype.info_style_class = "alert-info";
    App_Message.prototype.warning_style_class = "alert-warning";
    
    App_Message.prototype.errorMsgSuffix = "_error_msg";
    App_Message.prototype.errorMsgIconSuffix = "_span";

    /**
 * =============================================================================
 * Propiedades del msg container
 * =============================================================================
 */           
    Object.defineProperty(this, "msg_container_id", {
        get: function() {
            return this._msg_container_id;
        },
        set: function(msg_container_id) {
            this._msg_container_id = msg_container_id;
            this.msg_container_obj = $("#" + msg_container_id);
        }
    });  
    
    if (msg_container_id) this.msg_container_id=msg_container_id;

    this.Hide = function(time) {
        if (typeof(time) === "undefined" || time === null) time="slow";                
        this.msg_container_obj.slideUp(time);
    };

    this.Display_Ok_Msg = function(msg) {
        this.status_code = this.ok_status_code;        
        if (msg !== null && typeof(msg)!=="undefined") 
            this.status_msg = msg;
        else
        	if (this.status_msg === "")
        		this.status_msg = this.ok_msg;
        this.status_detail = "";
        this.style_class = this.success_style_class;
        this.Display();
    };
    
    this.Display_Error_Msg = function (msg) {
        if (msg !== null) this.status_msg = msg;
        this.status_detail = "";
        this.style_class = this.error_style_class;
        this.msg_type = "error";
        this.is_error = true;        
        this.Display();
    };
    
    this.Display_Info_Msg = function (msg) {                  
        if (msg !== null) this.status_msg = msg;
        this.status_detail = "";
        this.style_class = this.info_style_class;
        this.msg_type = "info";
        this.is_error = false;        
        this.Display();
    };
    
    this.Display_Warning_Msg = function (msg) {            
        if (msg !== null) this.status_msg = msg;
        this.status_detail = "";
        this.style_class = this.warning_style_class;
        this.msg_type = "warning";
        this.is_error = false;        
        this.Display();
    };
    
    
    this.Display_Response = function (responseObj) {
    	
    	this.status_msg = "";
    	this.status_code = "";

        if (typeof(responseObj) !== "undefined" && responseObj !== null) {
            this.status_code = responseObj.statusCode;
            this.status_msg = responseObj.statusMsg;
            this.status_detail = responseObj.statusDetail;
            this.response_obj = responseObj;

            if (responseObj.statusCode === this.ok_status_code) {
            
                this.Display_Ok_Msg(null);
            } else {
                this.Display_Error_Msg(null);
            }
        } else {
            this.response_obj_null = true;
            this.Display();
        }
    };
    
    
    this.Display = function() {
         
        if (! this.response_obj_null) {
            var msg = this.status_msg ;
            if (this.status_code !== "") msg += " (" + this.status_code + ")." ;
            if (this.status_detail !== "") msg += " " + this.status_detail + "" ;
                
            this.msg_container_obj.empty().hide().removeClass(this.error_style_class 
                    + " " + this.success_style_class
                    + " " + this.info_style_class
                    + " " + this.warning_style_class
                    ).html(msg);

            this.msg_container_obj.addClass(this.style_class);

            if (this.is_error) {
                // implementa lista de errores, para validacion multiple
                if (this.status_code === 600) {

                    if (typeof(this.response_obj) !== "undefined") {                       
                        this.addErrorMsg(this.response_obj.statusDetail);
                    }
                }
            }

            this.msg_container_obj.removeClass("hide");
            if (! this.is_error)
                this.msg_container_obj.slideDown().delay(3000).slideUp();
            else
                this.msg_container_obj.slideDown();

            $('html, body').animate({scrollTop: 0}, 'slow');

            if (typeof(this.response_obj) !== "undefined" 
                &&   typeof(this.response_obj.attributes) !== "undefined" 
                && this.response_obj.attributes !== null
            ) {
                var attributes = this.response_obj.attributes;
                if (attributes.length >= 2) {
                    var elemId = attributes[0];
                    var value = attributes[1];
                    if (typeof(elemId) !== "undefined"
                        && typeof(value) !== "undefined"
                        && value > 0)
                        $("#" + elemId).val(value);
                }
            }
                                                                         
        } else {
                
            this.msg_container_obj.addClass("error");
            this.msg_container_obj.html("null response");
            this.msg_container_obj.removeClass("hide").slideDown();
                
        }
    };
    
    var firstMsg;    
    
    this.addErrorMsg = function (statusDetail) {        
        for (i in statusDetail) {
            firstMsg = true;    
            var plain_msg = statusDetail[i];
            var inputId = "#" + i;
            var errorMsgId = "#" + i + this.errorMsgSuffix;
            var spanMsgId = "#\\#"+ i + this.errorMsgIconSuffix;

            this.addErrorMark_Input(inputId);
            msg = this.getErrorMsgDescription(plain_msg);
            
            
            if (typeof( $(errorMsgId).attr("id") ) === "undefined") {                
                $(spanMsgId).attr("title", plain_msg);
            } else {
                $(errorMsgId).html(msg).show();
            }
        }
    };
    
    this.getErrorMsgDescription = function(messageArray) {      
        var ret="";
        if (firstMsg) ret = "<ul class='error-msg-list'>";
        for (j in messageArray) {
            ret += "<li class='list-group-item list-group-item-danger'>" + messageArray[j] + "</li>";
        }
        if (firstMsg) ret += "</ul>";
        
        firstMsg = false;        
        return ret;
    };
    
    this.addErrorMark_Input = function(inputId) {
        $(inputId).parent().addClass("has-error has-feedback");
        var spanId = inputId + "_span";
        $(inputId).after("<span id='"+spanId+"' class='glyphicon glyphicon-remove form-control-feedback'></span>");      
    };
    
    this.eraseAllErrorMark_Input = function() {
        $(".form-control-feedback").remove();      
        $(".has-feedback").removeClass("has-feedback has-error");
    };
    
    this.eraseAllErrorMsg = function(inputId) {
        $(".error-msg-list").each(function() {
                   $(this).remove();
        });      
    };
       
}


function app_Alert(callback_obj) {
            
    this.callback_obj= callback_obj;
    this.callback_method;
    
    this.options = [];        
    
    this.titleLabel_id = "myModalLabel";
    this._jtitleLabel_id = $("#"+this.titleLabel_id);
    
    this.alertDiv_id = "alert_modal";
    this._jalertDiv_id = $("#"+this.alertDiv_id);
    
    this.alertDivMsg_id = "alert_modal_msg";
    this._jalertDivMsg_id = $("#"+this.alertDivMsg_id);
    
    this.alertModalOkBtn = "alert_modal_ok_btn";
    this._jalertModalOkBtn = $("#alert_modal_ok_btn");
         
    this.callback_call = function() {
        this.callback_method.call(this.callback_obj);
    };
    
    this.bindOkBtn = function() {        
      var _self = this;
      
      this._jalertModalOkBtn.click(function(e) {          
          _self.callback_call();          
      });
    };
    
    this.Show = function(title, message) {
      this._jtitleLabel_id.html(title);
      this._jalertDivMsg_id.html(message);
      this._jalertDiv_id.modal(this.options);      
    };
};

})();
/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
( function () {

angular.module('msg-table',[])

.factory('MsgTable', function() {
    
    var _self = this;
    var factory = {};
    
    factory.xhr_error = "Error al recuperar datos (xhr)";
    factory.form_validation_incomplete_error = 'Completá todos los datos.';
                
                  
    return factory;
                        
});


})();
(function () {

    angular
    .module('simple-modalpanel', [])

    .service("modalPanelService",[ '$modal', 'SweetAlert', '$q', '$timeout', function ($modal, SweetAlert, $q, $timeout) {

        var defTemplateUrl = 'app/views/common/modal.html';
        var modalDefaults = {
            backdrop: true,
            keyboard: true,
            modalFade: true,
            templateUrl: defTemplateUrl
            // controller: function() {}
        };

        var modalOptions = {
            closeButtonText: 'Cancela',
            actionButtonText: 'OK',
            headerText: 'Confirmá',
            bodyText: 'Realizas esta acción?',
            okButton: true,
            isAlert: false
        };

        this.showModal = function (customModalDefaults, customModalOptions) {

            return $q(function(resolve, reject){
                SweetAlert.swal({
                    title: 'Eliminar',
                    text: customModalOptions.bodyText,
                    type: 'error',
                    showCancelButton: true,
                    confirmButtonColor: '#DD6B55',
                    confirmButtonText: 'Ok',
                    cancelButtonText: 'Cancelar',
                    closeOnConfirm: true,
                    closeOnCancel: true
                }, function(isConfirm){
                    if (isConfirm) {
                        resolve(true);
                    } else {
                        reject();
                    }
                });
            });
            //
            //                                if (!customModalDefaults)
            //                                    customModalDefaults = {};
            //                                customModalDefaults.backdrop = 'static';
            //                                return this.show(customModalDefaults,
            //                                        customModalOptions);
        };

        this.showModalAlert = function (customModalDefaults, customModalOptions) {
            SweetAlert.swal({
                title: 'Atención',
                text: customModalOptions.bodyText,
                type: 'warning',
                showCancelButton: false,
                cancelButtonText: 'Cancela',
                closeOnCancel: true
            });
        };

        this.show = function (customModalDefaults,customModalOptions) {
            // Create temp objects to work with since
            // we're in a
            // singleton service
            var tempModalDefaults = {};
            var tempModalOptions = {};

            // Map angular-ui modal custom defaults to
            // modal
            // defaults defined in service
            angular.extend(tempModalDefaults,modalDefaults, customModalDefaults);

            // Map modal.html $scope custom properties
            // to
            // defaults defined in service
            angular.extend(tempModalOptions,modalOptions, customModalOptions);

            if (!tempModalDefaults.controller) {
                tempModalDefaults.controller = ['$scope','$modalInstance',function ( $scope, $modalInstance) {
                    $scope.modalOptions = tempModalOptions;
                    $scope.modalOptions.ok = function ( result) {
                        $modalInstance.close(true);
                    };
                    $scope.modalOptions.close = function ( result) {
                        $modalInstance.dismiss('cancel');
                    };
                }];
            }

            var modalInstance = $modal.open(tempModalDefaults);
            
            modalInstance.opened.then(function(){
                $timeout(function(){
                    var windowHeight = $(window).height();
                    var windowWidth = $(window).width();
                    var modalDialog = $('.modal-dialog');
                    if(modalDialog[0]){
                        var boxHeight = modalDialog.height();
                        var boxWidth = modalDialog.width();
                        modalDialog.css({'top' : ((windowHeight - boxHeight)/2)});
                    }
                },10)
            });

            return modalInstance.result;
        };
    }])

    .service( "infoModalPanelService",[ '$modal', '$timeout', function ($modal, $timeout) {
        var defTemplateUrl = 'app/views/common/infomodal.html';
        var modalDefaults = {
            backdrop: true,
            keyboard: true,
            modalFade: true,
            templateUrl: defTemplateUrl
            // controller: function() {}
        };

        var modalOptions = {
            closeButtonText: 'Cancela',
            actionButtonText: 'OK',
            headerText: 'Confirmá',
            bodyText: 'Realizas esta acción?'
        };

        this.showModal = function (customModalDefaults, customModalOptions, getInfo) {
                if (!customModalDefaults)
                customModalDefaults = {};

                customModalDefaults.backdrop = 'static';

                return this.show(customModalDefaults, customModalOptions, getInfo);
            };

                this.show = function (customModalDefaults, customModalOptions, getInfo) {
                    // Create temp objects to work with since
                    // we're in a
                    // singleton service
                    var tempModalDefaults = {};
                    var tempModalOptions = {};

                    // Map angular-ui modal custom defaults to
                    // modal
                    // defaults defined in service
                    angular.extend(tempModalDefaults, modalDefaults, customModalDefaults);

                    // Map modal.html $scope custom properties
                    // to
                    // defaults defined in service
                    angular.extend(tempModalOptions, modalOptions, customModalOptions);

                    if (!tempModalDefaults.controller) {
                        tempModalDefaults.controller = ['$scope','$modalInstance',
                        function ( $scope, $modalInstance) {
                            $scope.getInfo = getInfo;
                            $scope.modalOptions = tempModalOptions;

                            $scope.modalOptions.ok = function (result) {
                                var formData = angular
                                .copy($scope.data);
                                if (typeof (formData) == "undefined"
                                || formData == null)
                                formData = true;
                                $modalInstance.close(formData);
                            };

                            $scope.modalOptions.close = function (result) {
                                $modalInstance.dismiss('cancel');
                            };
                        }];
                    }
                    
                    var modalInstance = $modal.open(tempModalDefaults);
                    
                    modalInstance.opened.then(function(){
                        $timeout(function(){
                            var windowHeight = $(window).height();
                            var windowWidth = $(window).width();
                            var modalDialog = $('.modal-dialog');
                            if(modalDialog[0]){
                                var boxHeight = modalDialog.height();
                                var boxWidth = modalDialog.width();
                                modalDialog.css({'left' : ((windowWidth - boxWidth)/2), 'top' : ((windowHeight - boxHeight)/2)});
                            }
                        },10)
                    });

                    return modalInstance.result;
                };
            }]);

        })();

//(function () {
//
//    angular
//            .module('simple-modalpanel', [])
//
//            .service(
//                    "modalPanelService",
//                    [
//                        '$modal', 'SweetAlert',
//                        function ($modal, baseHref, SweetAlert) {
//
//                            var defTemplateUrl = 'app/views/common/modal.html';
//                            var modalDefaults = {
//                                backdrop: true,
//                                keyboard: true,
//                                modalFade: true,
//                                templateUrl: defTemplateUrl
//                                        // controller: function() {}
//                            };
//
//                            var modalOptions = {
//                                closeButtonText: 'Cancela',
//                                actionButtonText: 'OK',
//                                headerText: 'Confirmá',
//                                bodyText: 'Realizas esta acción?',
//                                okButton: true,
//                                isAlert: false
//                            };
//
//                            this.showModal = function (customModalDefaults,
//                                    customModalOptions) {
//                                if (!customModalDefaults)
//                                    customModalDefaults = {};
//                                customModalDefaults.backdrop = 'static';
//                                return this.show(customModalDefaults,
//                                        customModalOptions);
//                            };
//
//                            this.showModalAlert = function (
//                                    customModalDefaults, customModalOptions) {
//
//                                if (!customModalDefaults)
//                                    customModalDefaults = {};
//
//                                if (!customModalOptions)
//                                    customModalOptions = {};
//
//                                customModalDefaults.backdrop = 'static';
//                                customModalOptions.okButton = false;
//                                customModalOptions.isAlert = true;
//
//                                return this.show(customModalDefaults,
//                                        customModalOptions);
//                            };
//
//                            this.show = function (customModalDefaults,
//                                    customModalOptions) {
//                                // Create temp objects to work with since
//                                // we're in a
//                                // singleton service
//                                var tempModalDefaults = {};
//                                var tempModalOptions = {};
//
//                                // Map angular-ui modal custom defaults to
//                                // modal
//                                // defaults defined in service
//                                angular.extend(tempModalDefaults,
//                                        modalDefaults, customModalDefaults);
//
//                                // Map modal.html $scope custom properties
//                                // to
//                                // defaults defined in service
//                                angular.extend(tempModalOptions,
//                                        modalOptions, customModalOptions);
//
//                                if (!tempModalDefaults.controller) {
//                                    tempModalDefaults.controller = function (
//                                            $scope, $modalInstance) {
//                                        $scope.modalOptions = tempModalOptions;
//                                        $scope.modalOptions.ok = function (
//                                                result) {
//                                            $modalInstance.close(true);
//                                        };
//                                        $scope.modalOptions.close = function (
//                                                result) {
//                                            $modalInstance
//                                                    .dismiss('cancel');
//                                        };
//                                    };
//                                }
//
//                                return $modal.open(tempModalDefaults).result;
//                            };
//                        }])
//
//            .service(
//                    "infoModalPanelService",
//                    [
//                        '$modal',
//                        function ($modal, baseHref) {
//
//                            var defTemplateUrl = 'app/views/common/infomodal.html';
//                            var modalDefaults = {
//                                backdrop: true,
//                                keyboard: true,
//                                modalFade: true,
//                                templateUrl: defTemplateUrl
//                                        // controller: function() {}
//                            };
//
//                            var modalOptions = {
//                                closeButtonText: 'Cancela',
//                                actionButtonText: 'OK',
//                                headerText: 'Confirmá',
//                                bodyText: 'Realizas esta acción?'
//                            };
//
//                            this.showModal = function (customModalDefaults,
//                                    customModalOptions, getInfo) {
//                                if (!customModalDefaults)
//                                    customModalDefaults = {};
//                                customModalDefaults.backdrop = 'static';
//                                return this.show(customModalDefaults,
//                                        customModalOptions, getInfo);
//                            };
//
//                            this.show = function (customModalDefaults,
//                                    customModalOptions, getInfo) {
//                                // Create temp objects to work with since
//                                // we're in a
//                                // singleton service
//                                var tempModalDefaults = {};
//                                var tempModalOptions = {};
//
//                                // Map angular-ui modal custom defaults to
//                                // modal
//                                // defaults defined in service
//                                angular.extend(tempModalDefaults,
//                                        modalDefaults, customModalDefaults);
//
//                                // Map modal.html $scope custom properties
//                                // to
//                                // defaults defined in service
//                                angular.extend(tempModalOptions,
//                                        modalOptions, customModalOptions);
//
//                                if (!tempModalDefaults.controller) {
//                                    tempModalDefaults.controller = function (
//                                            $scope, $modalInstance) {
//                                        $scope.getInfo = getInfo;
//                                        $scope.modalOptions = tempModalOptions;
//                                        $scope.modalOptions.ok = function (
//                                                result) {
//                                            var formData = angular
//                                                    .copy($scope.data);
//                                            if (typeof (formData) == "undefined"
//                                                    || formData == null)
//                                                formData = true;
//                                            $modalInstance.close(formData);
//                                        };
//                                        $scope.modalOptions.close = function (
//                                                result) {
//                                            $modalInstance
//                                                    .dismiss('cancel');
//                                        };
//                                    };
//                                }
//
//                                return $modal.open(tempModalDefaults).result;
//                            };
//                        }]);
//
//})();
(function () {
	
	angular.module('app.top-navbar', [])
	
	.directive('navbarMessages', [
            function(){
				
		return {
                        restrict: "AE",
                        replace: 'true',
                        scope:{},
			templateUrl: "app/views/common/topNavbarMsgIcon.html",
			controller: ['XhrEntity', '$scope', '$interval', 'authenticationSvc', 
                            function(XhrEntity, $scope, $interval, authenticationSvc) {
                                var min_freq = 1;
                                
                                var stop, frecuency = min_freq*60*1000;
                                
                                var vm = this;
                                                                                                
                                vm.getData = function() {
                                    XhrEntity.setEntity('BandejaMsg');
                                    XhrEntity.getActionPromise('getQtyMsgUnreaded')
                                    .then(function(response){
                                            if(response.statusCode === 200)
                                                    $scope.msg_qty = response.statusDetail.msgs;
                                    });
                                    
                                }
                                
                                $scope.getFirstThreeUnreadMessages = function() {
                                    XhrEntity.setEntity('BandejaMsg');
                                    XhrEntity.getActionPromise('getFirstNUnreadMessajes&cant=3')
                                    .then(function(response){
                                         if (response.statusCode === 200)
                                            $scope.messages = response.statusDetail.messages;
                                    });                                  
                                }
                                
                                if (authenticationSvc.isLoggedIn()){
                                    //vm.getData();
                                }
                                                                                                        
                                $scope.getFirstThreeUnreadMessages();
                                
                                stop = $interval( function() {
                                    if (authenticationSvc.isLoggedIn()){
                                        //vm.getData();
                                    }
                                }, frecuency);
				
			}]            
		};	
				
	}]);
	
})();
/**=========================================================
 * Module: UIGridController
 =========================================================*/

(function () {

    angular
            .module('ui-grid-base-controller', ['ngStorage','ui-grid-utils', 'miscelaneos'])
           .controller('UiGridBaseController', UiGridController)
           .factory('localStoreData', localStoreData);

    UiGridController.$inject = ['$scope', '$timeout', 'uiGridConstants', '$http', 'urlProvider', '$log', '$location', '$localStorage', 'misc','$q', 'localStoreData'];

    function UiGridController($scope, $timeout, uiGridConstants, $http, urlProvider, $log, $location, $localStorage, misc, $q, localStoreData) {

        var _self = this;

        this.rows_length = 50;           //Cantiad de filas para mostrar
        this.infiniteScrollFromEnd = 10; //Cantidad de filas hasta el final, antes de activar la llamada de más filas

        this.entity = "";               //Entidad
        this.url_base = "app/";
        this.url_data = "";

        this.PK = "";                   //Clave foranea de la entidad

        this.columnDefs = [];           //Columnas definidas para la lista de items.
        this.columnDefs_mobile = [];    //Columnas definidas para cuando la ventana < 500px, no obligatoria.

        this.footer = '<div>'
                            +'<div class="col-md-6"><span class="ng-binding"> Total Items: {{grid.appScope.rows}}/{{grid.appScope.totalItems}} </span></div>'
                            +'<div class="col-md-6 text-right"><span style="margin-right:5px;" ng-click="$parent.$parent.$parent.refreshGridData()"><em class="fa fa-refresh"></em></span><span class="text-warning">{{grid.appScope.dataSource}}</span> <span class="text-danger"> {{grid.appScope.statusCode}} {{grid.appScope.statusMsg}}</span></div> '
                     +'</div>';

        this.filterHeaderTemplate_forDate = '<div ui-grid-filter="">' +
                                            '<div class="ui-grid-filter-container ng-scope" ng-repeat="colFilter in col.filters">' +
                                            '<input type="text" class="ui-grid-filter-input" ng-model="colFilter.term" ng-click="opened = true; $scope.gridApi.core.on.filterChanged;" datepicker-popup="yyyy-MM-dd" is-open="opened" datepicker-options="grid.appScope.dateOptions" datepicker-append-to-body="true" />' +
                                            '<div role="button" class="ui-grid-filter-button ng-scope ng-hide"' +
                                            'ng-click="removeFilter(colFilter, $index)" ng-if="!colFilter.disableCancelFilterButton"' +
                                            'ng-disabled="colFilter.term === undefined || colFilter.term === null" ng-show="colFilter.term !== undefined &amp;&amp; colFilter.term !== null " disabled="disabled"><i class="ui-grid-icon-cancel" ui-grid-one-bind-aria-label="aria.removeFilter" aria-label="Remove Filter">&nbsp;</i></div></div></div></div>';

        var flag_xhr = false;
        var data = [];

        $scope.rows = 0;
        $scope.totalItems = 0;
        $scope.statusMsg="";
        $scope.statusCode="";

        $scope.data_loading = false;
        $scope.data_error = false;
        $scope.data_error_msg = "";

        $scope.dataSource ="";

        $scope.refreshGridData = function(){
            localStoreData.clearForEntity(_self.entity);
            $scope.rows = 0;

            if(_self.url_data){
                _self.getDataXhr(_self.url_data);
            } else {
                var _url = urlProvider.getUrlforList(_self.entity);
                var filter_expression = _self.getFilterExpression($scope.gridApi.grid);
                var sort_expression = _self.getSortExpression($scope.gridApi.grid);
                var length_expression = _self.getLengthExpression();
                var _url_full = _url + length_expression + filter_expression + sort_expression;
                _self.getDataXhr(_url_full);
            }
        }

        this.getDataXhr = function (url) {

            $scope.data_error = false;
            $scope.data_loading = true;
            $scope.dataSource ="";

            localStoreData.setEntity(this.entity);
            var localData = localStoreData.getData(url);
            if (localData) {

                var response = localData;
                response.data.data.forEach(function (row) {
                    _self.ForEachRow_Downloaded(row);
                });
                $scope.gridOptions.data = response.data.data;
                $scope.data_loading = false;
                $scope.gridApi.infiniteScroll.dataLoaded().then(function(){
                    $scope.gridApi.infiniteScroll.resetScroll();
                });

                $scope.totalItems = response.data.recordsTotal;
                $scope.rows += response.data.data.length;
                $scope.dataSource = "local";

            } else {

                // delete data while loading
                // $scope.gridOptions.data = new Array();

                $http.get(url)//$http.get(url, { timeout: 2000})
                    .success(function (response) {
                        if(response.statusCode !== 200) {

                            $scope.gridOptions.data = new Array();
                            $scope.data_loading = false;
                            $scope.data_error_msg = response.statusMsg;
                            $scope.data_error = true;
                            $scope.statusCode = response.statusCode;

                        } else {

                            if (response.data.draw >= 0) {
                                response.data.data.forEach(function (row) {
                                    _self.ForEachRow_Downloaded(row);
                                });

                                localStoreData.setData(url, response);

                                $scope.gridOptions.data = response.data.data;
                                $scope.data_loading = false;
                                $scope.gridApi.infiniteScroll.dataLoaded().then(function(){
                                    $scope.gridApi.infiniteScroll.resetScroll();
                                });

                                $scope.totalItems = response.data.recordsTotal;
                                $scope.rows += response.data.data.length;
                                $scope.dataSource = "remote";

                            } else {
                                $scope.gridOptions.data = [];
                            }
                        }
                    }).error(function(error) {
                        
                        $scope.data_error = true;
                        $scope.data_loading = false;
                        
                        if (error === null || typeof(error) === "undefined") {
                            $scope.data_error_msg = "Error al cargar datos de comprobante (nulo)";
                        } else {
                            $scope.data_error_msg = "Error al cargar datos de comprobante " + error;
                        }

                    });
            }
        };


        this.getDataXhr_forInfiniteScroll = function(url) {
            var _promise;
            $scope.data_loading = true;

            _promise = $q.defer();

            $http.get(url)
                .success(function(response) {
                    if (response.data.draw >= 0) {
                        $scope.gridApi.infiniteScroll.saveScrollPercentage();

                        response.data.data.forEach(function (row) {
                            _self.ForEachRow_Downloaded(row);
                        });
                        $scope.gridOptions.data = $scope.gridOptions.data.concat(response.data.data);
                        $scope.rows += response.data.data.length;

                    }
                    $scope.gridApi.infiniteScroll.dataLoaded()
                        .then(function() {
                            $scope.data_loading = false;
                            _promise.resolve();
                        });
                })
                .error(function(error) {
                    $scope.gridApi.infiniteScroll.dataLoaded();
                    $scope.data_loading = false;
                    _promise.reject();
                });

            return _promise;

        };

        this.ForEachRow_Downloaded = function(row) {
        };

        this.ClickHandler = function (rowEntitySelected,e) {
            var _url = this.url_base + this.entity + '/' + rowEntitySelected[this.PK];
            $location.path(_url);
        };

        this.saveState = function () {
            var state = $scope.gridApi.saveState.save();
            if (typeof($localStorage.gridState) !== "object" ) $localStorage.gridState = {};

            $localStorage.gridState[this.entity] = state;

        };

        this.restoreState = function () {

            $timeout(function () {
                var state=null;

                if (typeof($localStorage.gridState) === "object" ) {
                    if ( typeof($localStorage.gridState[_self.entity]) != "undefined")
                        state = $localStorage.gridState[_self.entity];
                }

                if (state !== null)
                    $scope.gridApi.saveState.restore($scope, state);
            });

        };

        this.getSortExpression = function (grid) {
            var _ret = "";
            if (typeof(grid)!=="undefined" && typeof(grid.columns) !== "undefined") {
                for (var i = 0; i < grid.columns.length; i++) {
                    var col = grid.columns[i];
                    if (typeof (col.sort) === "object" && typeof (col.sort.direction) !== "undefined") {
                        _ret = "&order[0][column]=" + col.field;
                        _ret += "&order[0][dir]=" + col.sort.direction;
                    }
                }
            }

            return _ret;
        };

        this.getFilterExpression = function (grid) {
            var _ret = "", _field = "", _value = "", j = 0;
            if (typeof (grid) !== "undefined") {

                for (var i = 0; i < grid.columns.length; i++) {

                    if (typeof (grid.columns[i].filters[0].term) !== "undefined") {
                        _field = grid.columns[i].field;
                        _value = grid.columns[i].filters[0].term;

                        if (_value === null)
                            _value = "";

                        if (_value !== "") {

                            _ret += "&columns[" + j + "][data]=" + _field;

                            if (this.columnDefs[i].type !== "date")
                                _ret += "&columns[" + j + "][search][value]=" + _value;
                            else
                                _ret += "&columns[" + j + "][search][value]=" + misc.FormatDatetoAMDStr(_value) + "*";
                        }
                        j++;

                    }
                }
            }
            return _ret;
        };

        this.resetFilters = function() {
            $scope.gridApi.grid.clearAllFilters();
        };


        this.getLengthExpression = function (){
            var _ret = "";
            _ret += "&start="+ $scope.rows +"&length=" + this.rows_length;
            return _ret;
        };


        this.activate = function() {

            var flag_xhr = false;
            var timer;
            var _url = "";

            if (this.url_data !== "")
                _url = this.url_data;
            else
                _url = urlProvider.getUrlforList(this.entity);

            _self = this;


            $scope.highlightFilteredHeader = function( row, rowRenderIndex, col, colRenderIndex ) {
                if( col.filters[0].term ){
                    return 'header-filtered';
                } else {
                    return '';
                }
            };

            $scope.gridOptions = {
                showGridFooter: true,
                showColumnFooter: false,
                gridFooterTemplate: this.footer,
                enableFiltering: true,
                useExternalFiltering: true,
                useExternalSorting: true,
                enableRowSelection: true,
                enableRowHeaderSelection: false,
                multiSelect: false,
                infiniteScrollDown: true,
                infiniteScrollRowsFromEnd: this.infiniteScrollFromEnd,
                columnDefs: this.columnDefs,
                data: data
            };

            this.restoreState();


            $scope.gridOptions.onRegisterApi = function (gridApi) {
                //set gridApi on scope
                $scope.gridApi = gridApi;

                // Si la ventana es chica(< 500px), usa las columnas_mobile (si es que están seteadas)
                if (window.innerWidth < 500 && _self.columnDefs_mobile.length !== 0){
                    $scope.gridOptions.columnDefs = _self.columnDefs_mobile;
                }

                // row select, clickhandler
                gridApi.selection.on.rowSelectionChanged($scope, function (row,e) {
                    _self.ClickHandler(row.entity,e);
                });

                // infiniteScroll
                gridApi.infiniteScroll.on.needLoadMoreData($scope, function() {
                    if($scope.rows > _self.infiniteScrollFromEnd){ //Solución para que el infinite scroll no se active con 0 rows (o menor al infiniteScrollFromEnd)
                        if ($scope.rows < $scope.totalItems) {

                            var sort_expression = _self.getSortExpression($scope.gridApi.grid);
                            var filter_expression = _self.getFilterExpression($scope.gridApi.grid);
                            var length_expression = _self.getLengthExpression();

                            var _url_final = _url + length_expression + sort_expression + filter_expression;

                            var _promise = _self.getDataXhr_forInfiniteScroll(_url_final);

                            return _promise.promise;
                            }
                        }
                    }
                );


                // multiple row selection
                // gridApi.selection.on.rowSelectionChangedBatch($scope, function (rows) { var msg = 'rows changed ' + rows.length; });

                // filter process
                gridApi.core.on.filterChanged($scope, function () {

                    var grid = this.grid, _url_filter = "", filter_expression = "", sort_expression = "";

                    filter_expression = _self.getFilterExpression(grid);

                    if (true || filter_expression !== "") {
                        _self.saveState();
                        flag_xhr = true;

                        $scope.rows = 0;
                        sort_expression = _self.getSortExpression(grid);
                        var length_expression = _self.getLengthExpression();
                        _url_filter = _url + length_expression + filter_expression + sort_expression;

                        $timeout.cancel(timer);
                        timer = $timeout(function () {
                            _self.getDataXhr(_url_filter);
                        }, 500);
                    }
                });


                gridApi.core.on.sortChanged($scope, function (grid, sortColumns) {

                    var _flag = false, _url_filter = "", filter_expression = "", sort_expression = "";

                    if (typeof (sortColumns) !== "undefined" && typeof(sortColumns[0]) !== "undefined" && typeof(sortColumns[0].sort) !== "undefined") {
                        sort_expression = "&order[0][dir]=" + sortColumns[0].sort.direction;
                        sort_expression += "&order[0][column]=" + sortColumns[0].field;
                        _flag = true;
                    }

                    if (_flag) {
                        $scope.rows = 0;
                        filter_expression = _self.getFilterExpression(grid);
                        var length_expression = _self.getLengthExpression();
                        _url_filter = _url + length_expression + filter_expression + sort_expression;

                        _self.saveState();

                        $timeout.cancel(timer);
                        flag_xhr = true;

                        timer = $timeout(function () {
                            _self.getDataXhr(_url_filter);
                        }, 500);
                    }
                });


            };

            //Recalcula las columnas depende al tamaño de la ventana
            $(window).resize(function(){
                if (window.innerWidth < 500 && _self.columnDefs_mobile.length !== 0){
                    $scope.gridOptions.columnDefs = _self.columnDefs_mobile;
                } else {
                    $scope.gridOptions.columnDefs = _self.columnDefs;
                }
            });

            timer = $timeout(function () {
                if (! flag_xhr) {
                    var filter_expression = _self.getFilterExpression($scope.gridApi.grid);
                    var sort_expression = _self.getSortExpression($scope.gridApi.grid);
                    var length_expression = _self.getLengthExpression();
                    var _url_full = _url + length_expression + filter_expression + sort_expression;
                    _self.getDataXhr(_url_full);
                }
            }, 100);
        };

    };


    localStoreData.$inject = ['$localStorage'];

    function localStoreData ($localStorage) {

        var _self = this;
        this.entity;
        var item = new LocalStoreItem();

        this.restore  = function(url) {
            var _ret = false;
            var now = new Date();
            if (typeof($localStorage.localStoreData)!=="undefined") {
                var _obj = $localStorage.localStoreData[_self.entity];

                if (typeof(_obj)!=="undefined" && _obj !== null) {
                    if (url === _obj.url) {
                        if ( _obj.expireTime >= now.getTime()) {
                            console.log("restore", _self.entity);
                            return _obj.data;
                        }

                    } else {
                        console.log("no coincide url " + url + " vs " + _obj.url);
                    }
                }
            }

            return _ret;
        };

        this.save = function(newItem) {
            if (typeof($localStorage.localStoreData)==="undefined")
                $localStorage.localStoreData = {};

            $localStorage.localStoreData[newItem.entity] = newItem;

        };


        this.clearForEntity = function(entity) {
            if (typeof($localStorage.localStoreData) !== "undefined")
                $localStorage.localStoreData[entity] = null;
        };


        return {

            setEntity: function(entity) {
                _self.entity = entity;
            },

            restore: function(url) {
                return this.restore(url);
            },

            getData: function(url) {
                var _ret = _self.restore(url);
                return _ret;
            },

            setData: function(url, data) {
                var now = new Date();
                var newItem = new LocalStoreItem();
                newItem.entity = _self.entity;
                newItem.url = url;
                newItem.data = data;
                newItem.expireTime = now.getTime() + newItem.__lifetime ;
                _self.save(newItem);
            },

            clearForEntity: function(entity){
                return _self.clearForEntity(entity);
            }
        };
    };


    LocalStoreItem = function() {

        this.url;
        this.entity;
        this.expireTime;
        this.data;
        this.__lifetime = 15 * 60 * 1000;

    };


})();

(function () {

    angular.module('miscelaneos')
    /**
     *
     * @param {Array} array
     * @param {string} index indice
     * @returns {void}
     */
    .factory('ArrayOP', function () {

        this.arrayBase = [];
        this.index = "";

        return {
            /**
             * Setea las propiedades del Factory
             */
            new : function (arrayBase, index) {
                this.arrayBase = arrayBase;
                this.index = index;
                this.arrayBase.sort(function (first, second) {
                    if (first[this.index] < second[this.index])
                        return -1;
                    else
                        return 1;
                });
            },
            /**
             *
             * @param {Array} array
             * @returns {Array}
             */
            calculaDif: function (array) {
                var newList = new Array(), arrayRef = new Array();

                for (var i = 0; i < array.length; i++) {
                    arrayRef[array[i][this.index]] = array[i];
                }

                for (var i = 0; i < this.arrayBase.length; i++) {
                    if (arrayRef[this.arrayBase[i][this.index]] === undefined) {
                        var j = newList.length;
                        newList[j] = this.arrayBase[i];
                    }
                }
                return newList;
            },
            /**
             * Mueve los elementos con la propiedad (BOOL) del arrayEntrega al arrayBase.
             * Ordena el arrayBase por el indice.
             *
             * @param {array} arrayEntrega
             * @param {string} propiedad
             * @param {string} valor (opcional) valor al cual se cambia la propiedad
             * @returns {void}
             */
            moverElementosPorPropiedadBool: function (arrayEntrega, propiedad, valor) {
                var long = arrayEntrega.length;
                for (var i = 0; i < long; i++) {
                    if (arrayEntrega[i][propiedad] !== undefined && arrayEntrega[i][propiedad]) {
                        if (valor !== undefined)
                            arrayEntrega[i][propiedad] = valor;
                        var j = this.arrayBase.length;
                        this.arrayBase[j] = arrayEntrega[i];

                        arrayEntrega.splice(i, 1);
                        i = i - 1;
                        long = arrayEntrega.length;
                    }
                }
                this.arrayBase.ordena();
            },
            /**
             * Devuelve un Array de los elementos cuya propiedad y valor son los introducidos
             * en los parámetros.
             *
             * @param {string} propiedad
             * @param {string|bool} valor , valor de la propiedad a buscar
             * @return {Array}
             */
            getElementosPorValordePropiedad: function (propiedad, valor) {
                var ret_array = new Array();

                var long = this.arrayBase.length;
                for (var i = 0; i < long; i++) {
                    if (this.arrayBase[i][propiedad] !== undefined && this.arrayBase[i][propiedad] === valor) {
                        var q = ret_array.length;
                        ret_array[q] = this.arrayBase[i];
                    }
                }
                return ret_array;
            },
            /**
             * Ordena el arrayBase por el indice definido a menos que le pases una
             * propiedad diferente.
             *
             * @param {string} propiedad
             * @returns {void}
             */
            ordena: function (propiedad) {
                if (propiedad !== undefined) {
                    this.arrayBase.sort(function (first, second) {
                        if (first[propiedad] < second[propiedad])
                            return -1;
                        else
                            return 1;
                    });
                } else {
                    this.arrayBase.sort(function (first, second) {
                        if (first[this.index] < second[this.index])
                            return -1;
                        else
                            return 1;
                    });
                }
            },
            /**
             * Genera la propiedad index con el indice del array.
             *
             * @returns {void}
             */
            generarIndex: function () {
                for (var i = 0; i < this.arrayBase.length; i++) {
                    this.arrayBase[i].index = i;
                }
            }

        }//return
    })
    ;

})();
(function () {

    angular.module('miscelaneos')
    /**
     * Array asociativo
     */
    .provider('CustomArrayProvider', function CustomArrayProvider() {
        this.$get = function () {
            return {
                getInstance: function (array, indexProperty) {
                    return new CustomArray(array, indexProperty);
                }
            }
        }
    })// END CustomArrayProvider

    //TEST
    .factory('CustomArray', function () {
        return new CustomArray();
    })
    ;

    function CustomArray(newArrayBase, newIndexProperty) {
        var _self = this;
        this.arrayBase = {}
        this.indexProperty = "";


        /**
         * Setea las propiedades del Factory
         */
        this.new = function (newArray, newIndexProp) {
            _self.arrayBase = {}
            _self.indexProperty = newIndexProp;
            newArray.forEach(function (element) {
                var i = element[newIndexProp];
                _self.arrayBase[i] = element;
            });
        };

        if (typeof (newArrayBase) !== 'undefined' && typeof (newIndexProperty) !== 'undefined')
            this.new(newArrayBase, newIndexProperty);

        /**
         *
         * @return {integer}
         */
        this.getSize = function () {
            var long = 0;
            for (i in _self.arrayBase) {
                long++;
            }
            return long;
        }

        /**
         *
         * @param {string}
         * @returns {element}
         */
        this.get = function (index) {
            var ret = null;
            if (_self.arrayBase[index])
                ret = _self.arrayBase[index];
            return ret;
        };

        /**
         *
         * @returns {array}
         */
        this.getList = function () {
            var ret = new Array();
            var l = 0;
            for (i in _self.arrayBase) {
                ret[l] = _self.arrayBase[i];
                l++
            }
            return ret;
        };

        /**
         *
         * @param {function} element,index,poss
         */
        this.forEach = function (callback) {
            var poss = 0;
            for (i in _self.arrayBase) {
                callback(_self.arrayBase[i], i, poss);
                poss++;
            }
        },
                /**
                 *
                 * @param {function} element,index
                 */
                this.addItem = function (elemento) {
                    _self.arrayBase[elemento[_self.indexProperty]] = elemento;
                };

        /**
         *
         * @param {index}
         */
        this.deleteItem = function (indice) {
            if (_self.arrayBase[indice])
                delete _self.arrayBase[indice];
        };

        /**
         * Calcula la diferencia de items que hay con CustomArray
         * OBS: El array de entrega debe tener la misma propiedad con la que se
         * formo el indice del CustomArray
         *
         * @param {Array} array
         * @returns {Array}
         */
        this.calculateDif = function (array) {
            var newList = new Array(), arrayRef = {};

            for (i in array) {
                var p = array[i][_self.indexProperty];
                arrayRef[p] = array;
            }

            for (i in _self.arrayBase) {
                if (arrayRef[i] === undefined) {
                    var j = newList.length;
                    newList[j] = _self.arrayBase[i];
                }
            }
            return newList;
        };

        /**
         * Mueve los elementos con la propiedad (boleana, a menos que no se ingrese el 3er parametro)
         * del arrayEntrega al arrayBase.
         * OBS: El array de entrega debe tener la misma propiedad con la que se
         * formo el indice del CustomArray
         *
         * @param {array} arrayEntrega
         * @param {string} propiedad
         * @param {string} valor (opcional) valor al cual se cambia la propiedad
         * @returns {void}
         */
        this.moverElementosPorPropiedadBool = function (arrayEntrega, propiedad, valor) {
            for (i in arrayEntrega) {
                if (arrayEntrega[i][propiedad] !== undefined) {
                    var consulta = arrayEntrega[i][propiedad];
                    if (typeof (valor) == 'undefined')
                        consulta = (consulta == valor)

                    if (consulta) {
                        var indice = arrayEntrega[i][_self.indexProperty];
                        _self.arrayBase[indice] = arrayEntrega[i];

                        delete arrayEntrega[i];
                    }
                }
            }
        };

        /**
         * Devuelve un Array de los elementos cuya propiedad y valor son los introducidos
         * en los parámetros.
         *
         * @param {string} propiedad
         * @param {string|bool} valor , valor de la propiedad a buscar
         * @return {Array}
         */
        this.getItemsFromPropertyValue = function (propiedad, valor) {
            var ret_array = new Array();

            var l = 0;
            for (i in _self.arrayBase) {
                if (_self.arrayBase[i][propiedad] !== undefined && _self.arrayBase[i][propiedad] === valor) {
                    ret_array[l] = _self.arrayBase[i];
                    l++
                }
            }

            return ret_array;
        };

    }

})();
(function () {

    angular.module('miscelaneos')
    /**
     * Operaciones entre conjuntos
     * Primer parametro array de referencia
     * Segundo parametro array a realizar la operacion
     * Tercer parametro indice (propiedad) que tienen los 2 arrays para realizar la operacion
     */
    .service('SetOperations', function () {

        var arrayToObj = function (array, indexProperty) {
            var ret = {}
            for (i in array) {
                var prop = array[i][indexProperty];
                ret[prop] = array[i];
            }
            return ret;
        }

        /**
         * Calcula la union del primer array con el segundo.
         * @param {array|object}
         * @param {array|object}
         * @returns {array}
         */
        this.Union = function (fstArray, sndArray) {
            var ret = new Array();
            var l = 0;
            for (i in fstArray) {
                ret[l] = fstArray[i];
                l++
            }
            for (i in sndArray) {
                ret[l] = sndArray[i];
                l++
            }

            return ret;
        }

        /**
         * Calcula la intersección del primer array con el segundo, usando
         * indexProperty como factor común
         * @param {array|object}
         * @param {array|object}
         . @param {string} Propiedad usada como indice
         * @returns {array}
         */
        this.Intersection = function (fstArray, sndArray, indexProperty) {
            var newList = new Array();
            var fstArrayRef = arrayToObj(fstArray, indexProperty);
            var sndArrayRef = arrayToObj(sndArray, indexProperty);

            for (i in fstArrayRef) {
                if (typeof (sndArrayRef[i]) !== 'undefined') {
                    var j = newList.length;
                    newList[j] = fstArrayRef[i];
                }
            }
            return newList
        }


        /**
         * Calcula la direrencia del primer array con el segundo.
         * (todos los obj que están en el primer array y NO en el segundo)
         * @param {array|object}
         * @param {array|object}
         . @param {string} Propiedad usada como indice
         * @returns {array}
         */
        this.Difference = function (fstArray, sndArray, indexProperty) {
            var newList = new Array();
            var fstArrayRef = arrayToObj(fstArray, indexProperty);
            var sndArrayRef = arrayToObj(sndArray, indexProperty);

            for (i in fstArrayRef) {
                if (sndArrayRef[i] === undefined) {
                    var j = newList.length;
                    newList[j] = fstArrayRef[i];
                }
            }
            return newList
        }

        this.CartesianProduct = function (fstArray, sndArray, indexProperty) {
        }
        
    });


    function SetOperations(newArray, newIndexProperty) {
        var _self = this;
        this.arrayBase = {};
        this.indexProperty = newIndexProperty;
        for (i in newArray) {
            var p = newArray[i][_self.indexProperty];
            this.arrayBase[p] = array;
        }

        this.Union = function (sndArray) {
            var ret = new Array();
            var l = 0;
            for (i in _self.arrayBase) {
                ret[l] = _self.arrayBase[i];
                l++
            }
            for (i in sndArray) {
                ret[l] = sndArray[i];
                l++
            }

            return ret;
        }

        this.Intersection = function (sndArray) {
            var newList = new Array(), arrayRef = {};

            for (i in sndArray) {
                var p = sndArray[i][_self.indexProperty];
                arrayRef[p] = sndArray;
            }

            for (i in _self.arrayBase) {
                if (typeof (arrayRef[i]) !== 'undefined') {
                    var j = newList.length;
                    newList[j] = _self.arrayBase[i];
                }
            }
            return newList
        }

        this.Difference = function (sndArray) {
            var newList = new Array(), arrayRef = {};

            for (i in sndArray) {
                var p = sndArray[i][_self.indexProperty];
                arrayRef[p] = sndArray;
            }

            for (i in _self.arrayBase) {
                if (arrayRef[i] === undefined) {
                    var j = newList.length;
                    newList[j] = _self.arrayBase[i];
                }
            }
            return newList
        }

        this.CartesianProduct = function (sndArray) {
        }

    }

})();
(function () {


    angular.module('miscelaneos')

        /**
         * Se utiliza para buscar entre las propiedades de un objeto.
         * Ej:
         * Sea 'GoupList' un array de objetos {id:'', nombre: '', grupo: ''} y '$search' la variable
         * por la cual se quiere filtrar los objetos. Entonces queda
         *  ng-repeat='grupo in GoupList | propsFilter: {nombre: $search, grupo: $search}
         * dando por resultado los grupos que en nombre ó grupo contengan la variable $search.
         */
        .filter('propsFilter', function () {
            return function (items, props) {
                var out = [];
                if (angular.isArray(items)) {
                    items.forEach(function (item) {
                        var itemMatches = false;

                        var keys = Object.keys(props);
                        for (var i = 0; i < keys.length; i++) {
                            var prop = keys[i];
                            var text = props[prop].toLowerCase();
                            if (item[prop].toString().toLowerCase().indexOf(text) !== -1) {
                                itemMatches = true;
                                break;
                            }
                        }

                        if (itemMatches) {
                            out.push(item);
                        }
                    });
                } else {
                    // Let the output be the input untouched
                    out = items;
                }

                return out;
            };
        })

        /**
         * Se utiliza para que los números tengan formato local.
         */
        .filter('numberToLocale', function () {
            return function (input) {
                if (input)
                    return Number(input).toLocaleString('es');
            };
        })
        ;

})();
(function () {

    angular.module('miscelaneos')
            .service('misc', function () {

                Date.prototype.es_Ar_dateFormat = "dd/MM/yyyy";
                Date.prototype.es_Ar_dateTimeFormat = "dd/MM/yyyy HH:mm";


                this.sleep = function (milliseconds) {
                    var start = new Date().getTime();
                    for (var i = 0; i < 1e7; i++) {
                        if ((new Date().getTime() - start) > milliseconds) {
                            break;
                        }
                    }
                }

                Date.prototype.formatDate = function (format) {

                    var date = this,
                            day = date.getDate(),
                            month = date.getMonth() + 1,
                            year = date.getFullYear(),
                            hours = date.getHours(),
                            minutes = date.getMinutes(),
                            seconds = date.getSeconds();

                    if (!format) {
                        format = Date.es_Ar_dateFormat;
                    }

                    format = format.replace("MM", month.toString().replace(/^(\d)$/, '0$1'));

                    if (format.indexOf("yyyy") > -1) {
                        format = format.replace("yyyy", year.toString());
                    } else if (format.indexOf("yy") > -1) {
                        format = format.replace("yy", year.toString().substr(2, 2));
                    }

                    format = format.replace("dd", day.toString().replace(/^(\d)$/, '0$1'));

                    if (format.indexOf("t") > -1) {
                        if (hours > 11) {
                            format = format.replace("t", "pm");
                        } else {
                            format = format.replace("t", "am");
                        }
                    }

                    if (format.indexOf("HH") > -1) {
                        format = format.replace("HH", hours.toString().replace(/^(\d)$/, '0$1'));
                    }

                    if (format.indexOf("hh") > -1) {
                        if (hours > 12) {
                            hours -= 12;
                        }

                        if (hours === 0) {
                            hours = 12;
                        }
                        format = format.replace("hh", hours.toString().replace(/^(\d)$/, '0$1'));
                    }

                    if (format.indexOf("mm") > -1) {
                        format = format.replace("mm", minutes.toString().replace(/^(\d)$/, '0$1'));
                    }

                    if (format.indexOf("ss") > -1) {
                        format = format.replace("ss", seconds.toString().replace(/^(\d)$/, '0$1'));
                    }

                    return format;
                };

                this.getSufijoEnMasculino = function (numero) {
                    var _ret;
                    numero = numero.toString();
                    var l = numero.length - 1;
                    if (numero[l] === '0')
                        _ret = numero + "mo";
                    else if (numero[l] === '1')
                        _ret = numero + "ro";
                    else if (numero[l] === '2')
                        _ret = numero + "do";
                    else if (numero[l] === '3')
                        _ret = numero + "ro";
                    else if (numero[l] === '4')
                        _ret = numero + "to";
                    else if (numero[l] === '5')
                        _ret = numero + "to";
                    else if (numero[l] === '6')
                        _ret = numero + "to";
                    else if (numero[l] === '7')
                        _ret = numero + "mo";
                    else if (numero[l] === '8')
                        _ret = numero + "vo";
                    else if (numero[l] === '9')
                        _ret = numero + "no";

                    return _ret;
                }

                this.Dias_a_text = function (cantDias) {
                    var _ret = cantDias + " días";

                    if (cantDias === 0)
                        _ret = "hoy";
                    else if (cantDias === 1)
                        _ret = "mañana";
                    else if (cantDias === 2)
                        _ret = "pasado mañana";
                    else if (cantDias === -1)
                        _ret = "ayer";
                    else if (cantDias === -2)
                        _ret = "anteayer";
                    return _ret;
                };

                this.Dias_a_text_notifications = function (cantDias) {
                    var _ret = cantDias + " días";

                    if (cantDias === 0)
                        _ret = "Hoy";
                    else if (cantDias === 1)
                        _ret = "Mañana";
                    else if (cantDias === 2)
                        _ret = "Pasado mañana";
                    else if (cantDias > 2)
                        _ret = "En " + _ret;
                    else if (cantDias === -1)
                        _ret = "Ayer";
                    else if (cantDias === -2)
                        _ret = "Anteayer";
                    else if (cantDias <= -3)
                        _ret = _ret.replace("-", "Hace ");

                    return _ret;
                };

                this.Date_fromNow = function(days) {
                     var _date = moment().add(days,'days');
                     return _date.toDate();
                }

                this.DatetimeToDays_fromNow = function (datetime) {
                    var now = moment().startOf('day');
                    var _ret = "";
                    var dateref = null;

                    if (typeof (datetime) === "string") {
                        dateref = moment(datetime, "DD/MM/YYYY HH:mm").startOf('day');
                    } else {
                        if (typeof (datetime) === "object")
                            if (datetime._isAMomentObject)
                                dateref = datetime;
                            else
                                dateref = moment(datetime);
                    }
                    _ret = dateref.diff(now, "days");

                    return _ret;
                };

                /**
                 * Calcula la diferencia de días entre las 2 fechas enviadas como
                 * parámetro.
                 * 
                 * @param datetime1
                 * @param datetime1
                 * @param dateFormat [OPCIONAL], formato de datetime
                 */
                this.DatetimeDaysDiff = function (datetime1, datetime2, dateFormat) {
                    var _ret, dateref1, dateref2 = null;

                    var _format = "DD/MM/YYYY HH:mm";
                    if(dateFormat) _format = dateFormat;

                    if (typeof (datetime1) === "string") {
                        dateref1 = moment(datetime1, _format).startOf('day');
                    } else {
                        if (typeof (datetime1) === "object")
                            if (datetime1._isAMomentObject)
                                dateref1 = datetime1;
                            else
                                dateref1 = moment(datetime1);
                    }

                    if (typeof (datetime2) === "string") {
                        dateref2 = moment(datetime2, _format).startOf('day');
                    } else {
                        if (typeof (datetime2) === "object")
                            if (datetime2._isAMomentObject)
                                dateref2 = datetime2;
                            else
                                dateref2 = moment(datetime2);
                    }

                    _ret = dateref1.diff(dateref2, "days");

                    return _ret;
                };

                this.ParseDate = function (datetime) {
                    return moment(datetime, "YYYY-MM-DD HH:mm");
                };

                this.ParseDateFormat = function (datetime, format) {
                    return moment(datetime, format);
                };

                this.DateObjectToDMAStr = function (dateObj) {
                    return moment(dateObj).format('DD/MM/YYYY');
                };

                this.DateObjectToDMA_HMStr = function (dateObj) {
                    return moment(dateObj).format('DD/MM/YYYY HH:mm');
                };

                this.FormatDatetoAMDStr = function (date) {
                    if (typeof (date) === "object" && date._isAMomentObject)
                        return date.format("YYYY/MM/DD");
                    else {
                        var _datex = moment(date);
                        return _datex.format("YYYY-MM-DD");
                    }

                };

                this.SecondsToHoursMinutesSec = function (duration) {
                    var _ret = moment().startOf("day").seconds(duration).format("hh:mm:ss");
                    return _ret;
                }

            })
            ;

})();



            
/**=========================================================
 * Module: datepicker-ctrl
 * Controller: DatepickerCtrl
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('datepicker-ctrl')
        .controller('DatepickerCtrl', DatepickerCtrl);

    function DatepickerCtrl() {
        var vm = this;

        vm.minDate = new Date("1900-01-01");

        activate();

        ////////////////

        function activate() {
            vm.today = function() {
                vm.dt = new Date();
            };
            vm.today();

            vm.clear = function () {
                vm.dt = null;
            };

            // Disable weekend selection
            vm.disabled = function(date, mode) {
                return ( mode === 'day' && ( date.getDay() === 0 || date.getDay() === 6 ) );
            };

            vm.toggleMin = function() {
                vm.minDate = vm.minDate ? null : new Date();
            };
            vm.toggleMin();

            vm.open = function($event) {
                $event.preventDefault();
                $event.stopPropagation();

                vm.opened = true;
            };

            vm.dateOptions = {
                formatYear: 'yy',
                startingDay: 1,
                dateFormat:'DD/MM/YYYY'
                //initDate: new Date()
            };

            vm.initDate = new Date('2019-10-20');

            vm.formats = ['dd/MM/yyyy', 'yyyy/MM/dd', 'dd.MM.yyyy', 'shortDate'];
            vm.format = 'dd/MM/yyyy';

        }
    }


})();

/**=========================================================
 * Module: datepicker-ctrl
 * Directive: datepickerPopup
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('datepicker-ctrl')
        .directive('datepickerPopup', ["dateFilter", "datepickerPopupConfig", function (dateFilter, datepickerPopupConfig) {
            return {
                restrict: 'A',
                priority: 1,
                require: 'ngModel',
                link: function(scope, element, attr, ngModel) {
                    var dateFormat = attr.datepickerPopup || datepickerPopupConfig.datepickerPopup;
                    ngModel.$formatters.push(function (value) {
                        var ret = dateFilter(value, dateFormat);
                        return ret;
                    });
                    attr.clearText = "Limpiar";
                    attr.todayText = "Hoy";
                    attr.closeText = "Cerrar";
                    attr.nowText = "Ahora";
                    attr.dateText = "Fecha";
                    attr.timeText = "Hora";
                }
            };
        }]);

})();

/**=========================================================
 * Module: datepicker
 * Directive: inputDatepicker
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('datepicker-ctrl')
        .directive('inputDatepicker', inputDatepicker);

    inputDatepicker.$inject = ["$compile"];

    function inputDatepicker ($compile) {

        function link(scope, element, attr, ngModel) {
            scope.datepickerFormat = attr.format;
            element[0].removeAttribute('ng-model');

            scope.datepickerRequired = false;
            if(angular.isDefined(attr.isRequired)) {
                scope.datepickerRequired = true;
            }

            scope.datepickerInputName = "datepicker";
            if(attr.name) {
                scope.datepickerInputName = attr.name;
                element[0].removeAttribute('name'); //Para que haya un solo elemento con el attr name
            }

            if(attr.tooltipText) {
                scope.datepickerTooltipText = attr.tooltipText;
                element[0].removeAttribute('tooltip-text');
            }

        }


        return {
            restrict: 'E',
            scope: { ngModel: '=' },
            replace: true,
            require: 'ngModel',
            templateUrl: "app/views/common/inputDatepicker.html",
            link: link,
            controller: 'DatepickerCtrl',
            controllerAs: 'ctrl'
        };
    }


})();

/**=========================================================
 * Module: datetimepicker-ctrl
 * Controller: DatetimepickerCtrl
 =========================================================*/


(function () {
    'use strict';

    angular
        .module('datetimepicker-ctrl')
        .controller('DatetimepickerCtrl', DatetimepickerCtrl);

    function DatetimepickerCtrl() {
        var vm = this;
        activate();

        /** Activate function */
        function activate() {
            var isOpen = false;

            vm.dateOptions = {
                showWeeks: false,
                startingDay: 1,
                dateFormat: 'DD/MM/YYYY HH:mm',
                initDate: new Date()
            };

            vm.timeOptions = {
                readonlyInput: false,
                showMeridian: false
            };

            vm.todayAndNow = new Date();


            vm.openCalendar = function (e) {
                e.preventDefault();
                e.stopPropagation();

                vm.isOpen = true;
            };
        }
    }

})();

/**=========================================================
 * Module: datetimepicker-ctrl
 * Directive: datetimepickerPopup
 =========================================================*/


(function () {
    'use strict';

    angular
        .module('datetimepicker-ctrl')
        .directive('datetimepickerPopup', function () {
            return {
                restrict: 'A',
                priority: 1,
                require: 'ngModel',
                link: function (scope, element, attr, ngModel) {
                    attr.clearText = "Limpiar";
                    attr.todayText = "Hoy";
                    attr.nowText = "Ahora";
                    attr.closeText = "Cerrar";
                    attr.dateText = "Fecha";
                    attr.timeText = "Hora";
                }
            };
        });

})();

/**=========================================================
 * Module: datetimepicker-ctrl
 * Directive: inputDatepicker
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('datetimepicker-ctrl')
        .directive('inputDatetimepicker', inputDatetimepicker);

    inputDatetimepicker.$inject = ['$compile'];

    function inputDatetimepicker ($compile) {

        function link(scope, element, attr, ngModel) {
            scope.datetimepickerFormat = attr.format;
            element[0].removeAttribute('ng-model');

            scope.datetimepickerRequired = false;
            if(angular.isDefined(attr.isRequired)) {
                scope.datetimepickerRequired = true;
            }

            scope.datetimepickerInputName = "datepicker";
            if(attr.name) {
                scope.datetimepickerInputName = attr.name;
                element[0].removeAttribute('name'); //Para que haya un solo elemento con el attr name
            }

            if(attr.tooltipText){
                scope.datetimepickerTooltipText = attr.tooltipText;
                element[0].removeAttribute('tooltip-text');
            }
        }


        return {
            restrict: 'E',
            scope: { ngModel: '=' },
            replace: true,
            require: 'ngModel',
            templateUrl: "app/views/common/inputDatetimepicker.html",
            link: link,
            controller: 'DatetimepickerCtrl',
            controllerAs: 'ctrl'
        };
    }


})();

/**
 * Module: simpleFileUploadMod
 * Directive: angleFileUpload
 * 
 * Required modules:
 *  'angularFileUpload' -> (FileUploader)
 *  'url-provider' -> (urlProvider)
 * 
 * 
 * Lazyload modules:
 *   + angularFileUpload: 
 *      bower) "angular-file-upload": "1.1.5"
 *      vendor) "bower_components/angular-file-upload/angular-file-upload.js"
 *      lazyload constant) {name:'angularFileUpload', files:['vendor/angular-file-upload/angular-file-upload.js'] }
 * 
 */


(function () {

    angular.module('simpleFileUploadMod')
        .directive("angleFileUpload", angleFileUpload);

    angleFileUpload.$inject = ['FileUploader', 'urlProvider', '$parse'];

    function angleFileUpload(FileUploader, urlProvider, $parse) {
        var vm = this;
        vm.uploadUrl = urlProvider.getDefaultUploadUrl();

        var formatos = {
            jpg: ['image/jpeg', 'jpg', 'JPG'],
            png: ['image/png', 'png', 'PNG'],
            gif: ['image/gif', 'gif', 'GIF'],
            swf: ['application/x-shockwave-flash', 'swf']
        }

        function link(scope, element, attrs, ctrl) {
            //Resetea la default url por si se cambió en la aplicación
            vm.uploadUrl = urlProvider.getDefaultUploadUrl();
            var uploadList = null;
            var _limit = 1;
            var fileModel;
            var tipoArchivosPermitidos = [];
            var uploadFileCallback = null;
            var uploadAllFilesCallback = null;
            var filterFunction = null;

            if (angular.isDefined(attrs.uploadUrlConstant) && urlProvider.getUrlforUpload(attrs.uploadUrlConstant))
                vm.uploadUrl = urlProvider.getUrlforUpload(attrs.uploadUrlConstant);
            if (angular.isDefined(attrs.label))
                ctrl.label = attrs.label;
            if (angular.isDefined(attrs.colLabel))
                ctrl.colLabel = attrs.colLabel;
            if (angular.isDefined(attrs.colInput))
                ctrl.colInput = attrs.colInput;
            if (angular.isDefined(attrs.uploadUrl))
                vm.uploadUrl = attrs.uploadUrl;
            if (angular.isDefined(attrs.multiple)) {
                _limit = 10;
                uploadList = [];
                ctrl.btn_upload_label += " todos";
                ctrl.btn_delete_label += " todos";
            }
            if (angular.isDefined(attrs.autoupload))
                scope.fileCtrl.uploader.autoUpload = true;
            if (angular.isDefined(attrs.uploadfilelistmodel)) {
                fileModel = attrs.uploadfilelistmodel;
            } else {
                fileModel = attrs.uploadfilemodel;
            }
            if (angular.isDefined(attrs.onCompleteItem)) {
                uploadFileCallback = $parse(attrs.onCompleteItem)(scope);
            }
            if (angular.isDefined(attrs.onCompleteAll)) {
                uploadAllFilesCallback = $parse(attrs.onCompleteAll)(scope);
            }
            if (angular.isDefined(attrs.filterFunction)) {
                var filtro = $parse(attrs.filterFunction)(scope);
                scope.fileCtrl.uploader.filters.push({
                    name: 'customFilter',
                    fn: filtro
                });
            }
            if (angular.isDefined(attrs.tipoArchivos)) {
                var tipos = $parse(attrs.tipoArchivos)(scope);
                if(tipos){
                    for (var i = 0; i < tipos.length; i++) {
                        var formato = formatos[tipos[i]];
                        if (formato) {
                            if (Array.isArray(formato)) {
                                for (var l = 0; l < formato.length; l++) {
                                    tipoArchivosPermitidos.push(formato[l]);
                                }
                            } else
                                tipoArchivosPermitidos.push(formato);
                        }
                    }
                }else{
                    console.log("Tipo de Archivos permitidos no definidos");
                }
            }

            scope.fileCtrl.uploader.removeAfterUpload = true;
            scope.fileCtrl.uploader.queueLimit = _limit;
            scope.fileCtrl.uploader.url = vm.uploadUrl;
            scope.fileCtrl.uploader.alias = "files";
            scope.fileCtrl.uploader.filters.push({
                name: 'tipoDeArchivos',
                fn: function (item, options) {
                    var type = item.type;
                    if (type === '') {
                        type_arr = item.name.split(".")
                        type = type_arr[type_arr.length - 1];
                    }
                    if (tipoArchivosPermitidos.indexOf(type) >= 0)
                        return true;
                    else
                        return false;
                }
            });

            scope.fileCtrl.uploader.onCompleteItem = function (fileItem, response, status, headers) {
                
                if(uploadList && angular.isArray(uploadList)){
                    uploadList.push(response);
                    setAttrToScopeValue(fileModel, uploadList);
                }else
                    setAttrToScopeValue(fileModel, response);
                
                if (uploadFileCallback)
                    uploadFileCallback(fileItem, response, status, headers);
            };
            
            scope.fileCtrl.uploader.onCompleteAll = function () {
                
                if(uploadList && angular.isArray(uploadList))
                    uploadList = [];

                if (uploadAllFilesCallback)
                    uploadAllFilesCallback();
            };


            var setAttrToScopeValue = function (attr, value) {
                var model = $parse(attr)(scope);

                if(model && angular.isArray(value)){
                    var l = model.length;
                    for(var i=0; i<value.length; i++){
                        model[l] = value[i];
                        l++;
                    }
                }else if (model && angular.isArray(model)) {
                    var l = model.length;
                    model[l] = value;
                } else {
                    model = value;
                }

                var getter = $parse(attr);
                getter.assign(scope, model);

                //if (Array.isArray(model))
                //    attr += '[' + model.length + ']';
                //var getter = $parse(attr);
                //getter.assign(scope, value);
            };
        };

        function fileUploadCtrl() {
            this.btn_upload_label = "Subir";
            this.btn_delete_label = "Eliminar";
            this.label = "Adjuntos";
            this.colLabel = 'col-sm-3';
            this.colInput = 'col-sm-9';
            this.uploader = new FileUploader();
        }

        return {
            restrict: 'E',
            templateUrl: function (elem, attrs) {
                return 'app/views/common/angleFileUpload.html';
            },
            replace: true,
            controller: fileUploadCtrl,
            controllerAs: "fileCtrl",
            link: link
        };
    };

})();
(function () {

    angular.module('simpleFileUploadMod')
        .directive("fileUploadList", fileUploadList)

    fileUploadList.$inject = ['ngDialog', '$modal'];

    function fileUploadList(ngDialog, $modal) {

        var _scope;

        function link(scope, element, attrs) {
            _scope = scope;
            var _updatedList = [];
            if (typeof (attrs.modellist) !== "undefined") {
                var xmodel_arr = attrs.modellist.split(".");
                if (xmodel_arr.length > 1) {
                    if (xmodel_arr.length > 2)
                        scope.$watch(attrs.modellist, function () {
                            scope.fileListCtrl.attachmentList = scope[xmodel_arr[0]][xmodel_arr[1]][xmodel_arr[2]];
                        });
                    else {
                        scope.$watch(attrs.modellist, function () {
                            scope.fileListCtrl.attachmentList = scope[xmodel_arr[0]][xmodel_arr[1]];
                        });
                    }
                } else {
                    scope.$watch(attrs.modellist, function () {
                        scope.fileListCtrl.attachmentList = scope[attrs.xmodel];
                    });
                }
            }

        }

        function fileUploadListCtrl($scope) {
            var vm = this;
            vm.attachmentList = [];

            vm.showCarousel = function (atta, index) {
                $scope.modalInstance = $modal.open({
                    templateUrl: "app/views/common/fileUploadList_modal.html",
                    //size:'lg',                            
                    scope: $scope,
                    animation: true
                });
                vm.attachmentList[index].active = true;
            };

            vm.borrarAttachment = function (attach) {
                attach.__delete = true;
            };

            vm.selectImg = function (attach) {
                var url = attach.url;
                var fotos = ["jpg", "png", "gif"];
                var extencion = attach.name.split('.')[attach.name.split('.').length - 1].toLowerCase();
                if ($.inArray(extencion, fotos) === -1) {
                    url = "app/img/documentoGenerico.png";
                    if (extencion === "txt" || extencion === "doc") url = "app/img/documentoTexto.png";
                    if (extencion === "xls") url = "app/img/documentoXls.png";
                }
                return url;
            };

            vm.openAttach = function (url) {
                window.open(url, '_blank');
            }

        }
        fileUploadListCtrl.$inject = ["$scope"];

        return {
            restrict: 'E',
            templateUrl: function () { return 'app/views/common/fileUploadList.html'; },
            link: link,
            controller: fileUploadListCtrl,
            controllerAs: "fileListCtrl"
        };
    }

})();
/**
 * Module: simpleFileUploadMod
 * Directive: filestyle
 * 
 * Required modules:
 * 
 * 
 * Lazyload modules:
 *   + filestyle: 
 *      bower) "bootstrap-filestyle": "1.1.2"
 *      vendor) "bower_components/bootstrap-filestyle/src/bootstrap-filestyle.js"
 *      lazyload constant) {name:'filestyle', files: ['vendor/bootstrap-filestyle/src/bootstrap-filestyle.js']},
 * 
 */

(function(){

angular.module('simpleFileUploadMod')
    .directive('filestyle', function() {

        var directive = {
            link: link,
            restrict: 'A'
        };

        return directive;

        function link(scope, element) {
            var options = element.data();

            // old usage support
            options.classInput = element.data('classinput') || options.classInput;

            element.filestyle(options);
        }
        
    });

})();
(function () {

    angular.module('simpleFileUploadMod')
        .directive('simpleFileUploadDragdrop', simpleFileUploadDragdrop);

    simpleFileUploadDragdrop.$inject = ['Upload', '$timeout', 'urlProvider'];

    function simpleFileUploadDragdrop(Upload, $timeout, urlProvider) {


        function link(scope, element, attrs) {
            var fileupload;

            var url = urlProvider.getDefaultUploadUrl();

            scope.progress = false;
            scope.thumnail = false;
            scope.showfilename = false;

            if (attrs.uploadurl)
                url = attrs.uploadurl;

            if (typeof (attrs.showfilename) !== "undefined")
                scope.showfilename = true;

            scope.$watch('files', function () {
                if (typeof (scope.files) !== "undefined") {
                    if (angular.isObject(scope.files))
                        var files = [scope.files];
                    else if (angular.isArray(scope.files))
                        var files = scope.files;
                    scope.upload(files);
                }
            });
            scope.$watch('file', function () {
                if (scope.file != null) {
                    scope.upload([scope.file]);
                }
            });
            scope.log = '';

            scope.upload = function (files) {
                if (files && files.length) {
                    for (var i = 0; i < files.length; i++) {
                        var file = files[i];
                        if (!file.$error) {

                            Upload.upload({
                                url: url,
                                fields: {
                                    // 'username': $scope.username
                                },
                                file: file
                            }).progress(function (evt) {
                                file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
                            }).success(function (data, status, headers, config) {
                                $timeout(function () {
                                    scope[attrs.xmodel] = data.files[0].url;
                                    scope.log = 'file: ' + config.file.name + ', Response: ' + JSON.stringify(data) + '\n' + scope.log;
                                });
                            }).error(function (err) {
                                console.log("Upload File Error: ", err);
                            });


                        }
                    }
                }
            };
        }

        return {
            restrict: 'E',
            templateUrl: function (elem, attrs) {
                return 'simpleFileUploadDragdrop.html';
            },
            link: link
        };
    }

})();
(function(){

    angular.module('simpleFileUploadMod')
    .directive('simpleFileUpload', simpleFileUpload);

    simpleFileUpload.$inject = ["Upload", "$timeout", 'urlProvider'];

    function simpleFileUpload (Upload, $timeout, urlProvider) {

                var multiple = false;

                return {
                    restrict: 'E',
                    templateUrl: function (elem, attrs) {
                        return 'app/views/common/simpleFileUpload.html';
                    },
                    link: link										
                };


                function link(scope, element, attrs) {
                    if (typeof (attrs.multiple) !== "undefined")
                        scope.multiple = true;
                    var fileupload;

                    scope.uploadFiles = function (file) {
                        var url = urlProvider.getDefaultUploadUrl();

                        scope.f = file;
                        scope.progress = false;
                        scope.thumnail = false;
                        scope.showfilename = false;

                        if (attrs.uploadurl)
                            url = attrs.uploadurl;
                            
                        if (typeof (attrs.showfilename) !== "undefined")
                            scope.showfilename = true;

                        if (file && !file.$error) {
                            file.upload = Upload.upload({
                                url: url,
                                file: file
                            });

                            file.upload.then(function (response) {
                                $timeout(function () {
                                    file.result = response.data;

                                    // por si es un objecto con una propiedad
                                    if (!scope.multiple)
                                        setAttrToScopeValue(attrs.uploadfilemodel, response.data.files[0].url);

                                    if (typeof (attrs.thumbnail) !== "undefined")
                                        scope.thumbnail = true;

                                    if (typeof (attrs.progressx) !== "undefined")
                                        scope.progress = true;

                                    file.thumbUrl = file.result.files[0].thumbnailUrl;

                                });
                            }, function (response) {
                                if (response.status > 0)
                                    scope.errorMsg = response.status + ': ' + response.data;
                            });

                            file.upload.progress(function (evt) {
                                file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
                            });
                        }
                    };

                    scope.agregarAttachment = function (file) {
                        setAttrToScopeValue(attrs.uploadfilelistmodel, file);
                        //Reseteo la variable file
                        scope.f = {};
                    };

                    scope.borrarAttachment = function (attach) {
                        attach.__delete = true;
                    };

                    this.setAttrToScopeValue = function (attr, value) {
                        var ret = {};

                        xmodel_arr = attr.split(".");
                        if (xmodel_arr.length > 1) {
                            if (xmodel_arr.length > 2)
                                ret = scope[xmodel_arr[0]][xmodel_arr[1]][xmodel_arr[2]];
                            else
                                ret = scope[xmodel_arr[0]][xmodel_arr[1]];
                        } else {
                            ret = scope[attrs.xmodel];
                        }

                        if (Array.isArray(ret)) {
                            var long = ret.length;
                            ret[long] = value;
                        } else {
                            if (xmodel_arr.length > 1) {
                                if (xmodel_arr.length > 2)
                                    scope[xmodel_arr[0]][xmodel_arr[1]][xmodel_arr[2]] = value;
                                else
                                    scope[xmodel_arr[0]][xmodel_arr[1]] = value;
                            } else {
                                scope[attrs.xmodel] = value;
                            }
                        }
                    };
                }

            }

})();
/*
( function() {
	

angular.module('simpleFileUploadMod', ['ngAnimate', 'ui.bootstrap'])        
        .directive('simpleFileUpload', ["Upload", "$timeout", 'APPLICATION_CONFIG_DATA', function (Upload, $timeout, APPLICATION_CONFIG_DATA) {

                var multiple = false;

                return {
                    restrict: 'E',
                    templateUrl: function (elem, attrs) {
                        return 'app/views/common/simpleFileUpload.html';
                    },
                    link: link
                    // controller:"fileUploadCtrl" 												
                };


                function link(scope, element, attrs) {
                    if (typeof (attrs.multiple) !== "undefined")
                        scope.multiple = true;
                    var fileupload;

                    scope.uploadFiles = function (file) {
                        var url = APPLICATION_CONFIG_DATA.defaultUploadUrl;

                        scope.f = file;
                        scope.progress = false;
                        scope.thumnail = false;
                        scope.showfilename = false;

                        if (attrs.uploadurl)
                            url = attrs.uploadurl;
                            
                        if (typeof (attrs.showfilename) !== "undefined")
                            scope.showfilename = true;

                        if (file && !file.$error) {
                            file.upload = Upload.upload({
                                //url : 'https://angular-file-upload-cors-srv.appspot.com/upload',
                                url: url,
                                file: file
                            });

                            file.upload.then(function (response) {
                                $timeout(function () {
                                    file.result = response.data;

                                    // por si es un objecto con una propiedad
                                    if (!scope.multiple)
                                        setAttrToScopeValue(attrs.uploadfilemodel, response.data.files[0].url);

                                    if (typeof (attrs.thumbnail) !== "undefined")
                                        scope.thumbnail = true;

                                    if (typeof (attrs.progressx) !== "undefined")
                                        scope.progress = true;

                                    file.thumbUrl = file.result.files[0].thumbnailUrl;

                                });
                            }, function (response) {
                                if (response.status > 0)
                                    scope.errorMsg = response.status + ': ' + response.data;
                            });

                            file.upload.progress(function (evt) {
                                file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
                            });
                        }
                    };

                    scope.agregarAttachment = function (file) {
                        setAttrToScopeValue(attrs.uploadfilelistmodel, file);
                        //Reseteo la variable file
                        scope.f = {};
                    };

                    scope.borrarAttachment = function (attach) {
                        attach.__delete = true;
                    };

                    this.setAttrToScopeValue = function (attr, value) {
                        var ret = {};

                        xmodel_arr = attr.split(".");
                        if (xmodel_arr.length > 1) {
                            if (xmodel_arr.length > 2)
                                ret = scope[xmodel_arr[0]][xmodel_arr[1]][xmodel_arr[2]];
                            else
                                ret = scope[xmodel_arr[0]][xmodel_arr[1]];
                        } else {
                            ret = scope[attrs.xmodel];
                        }

                        if (Array.isArray(ret)) {
                            var long = ret.length;
                            ret[long] = value;
                        } else {
                            if (xmodel_arr.length > 1) {
                                if (xmodel_arr.length > 2)
                                    scope[xmodel_arr[0]][xmodel_arr[1]][xmodel_arr[2]] = value;
                                else
                                    scope[xmodel_arr[0]][xmodel_arr[1]] = value;
                            } else {
                                scope[attrs.xmodel] = value;
                            }
                        }
                    };
                }

            }]) 
        .directive('simpleFileUploadDragdrop', ['Upload', '$timeout', 'APPLICATION_CONFIG_DATA', function (Upload, $timeout, APPLICATION_CONFIG_DATA) {


                function link(scope, element, attrs) {
                    var fileupload;

                    var url = APPLICATION_CONFIG_DATA.defaultUploadUrl;

                    scope.progress = false;
                    scope.thumnail = false;
                    scope.showfilename = false;

                    if (attrs.uploadurl)
                        url = attrs.uploadurl;

                    if (typeof (attrs.showfilename) !== "undefined")
                        scope.showfilename = true;

                    scope.$watch('files', function () {
                        if (typeof (scope.files) !== "undefined") {
                            if (angular.isObject(scope.files))
                                var files = [scope.files];
                            else if (angular.isArray(scope.files))
                                var files = scope.files;
                            scope.upload(files);
                        }
                    });
                    scope.$watch('file', function () {
                        if (scope.file != null) {
                            scope.upload([scope.file]);
                        }
                    });
                    scope.log = '';

                    scope.upload = function (files) {
                        if (files && files.length) {
                            for (var i = 0; i < files.length; i++) {
                                var file = files[i];
                                if (!file.$error) {

                                    console.log(file);

                                    Upload.upload({
                                        url: url,
                                        fields: {
                                            // 'username': $scope.username
                                        },
                                        file: file
                                    }).progress(function (evt) {
                                        file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
                                    }).success(function (data, status, headers, config) {

                                        $timeout(function () {
                                            scope[attrs.xmodel] = data.files[0].url;
                                            scope.log = 'file: ' + config.file.name + ', Response: ' + JSON.stringify(data) + '\n' + scope.log;
                                        });
                                    }).error(function (err) {
                                        console.log("Errror**************");
                                        console.log(err);
                                    });


                                }
                            }
                        }
                    };
                }

                return {
                    restrict: 'E',
                    templateUrl: function (elem, attrs) {
                        return 'simpleFileUploadDragdrop.html';
                    },
                    link: link
                    // controller:"fileUploadCtrl"
                };
            }])
        .directive("angleFileUpload",['FileUploader','APPLICATION_CONFIG_DATA',function(FileUploader, APPLICATION_CONFIG_DATA){
                var vm = this;
                vm.uploadUrl = APPLICATION_CONFIG_DATA.defaultUploadUrl;
                
                function link (scope, element, attrs){
                    var _limit = 1;
                    var fileModel;
                    
                    if (typeof (attrs.uploadUrl) !== "undefined")
                        vm.uploadUrl = attrs.uploadUrl;
                    if (typeof (attrs.multiple) !== "undefined")
                        _limit = 10;
                    if(typeof(attrs.autoupload) !== "undefined")
                        scope.fileCtrl.uploader.autoUpload = true;
                    if (typeof(attrs.uploadfilelistmodel) !== "undefined"){
                            fileModel = attrs.uploadfilelistmodel;
                    }else{
                         fileModel = attrs.uploadfilemodel;
                    }
                    
                    scope.fileCtrl.uploader.removeAfterUpload = true;
                    scope.fileCtrl.uploader.queueLimit = _limit;
                    scope.fileCtrl.uploader.url = vm.uploadUrl;
                    scope.fileCtrl.uploader.alias = "files";
                    scope.fileCtrl.uploader.filters.push({
                        name: 'tipoDeArchivos',
                        fn: function(item, options) {
                            //console.log( item.type == "image/jpeg");
                            return true;//this.queue.length < _limit;
                        }
                    });
                    
                    scope.fileCtrl.uploader.onCompleteItem = function(fileItem, response, status, headers) {
                        setAttrToScopeValue(fileModel, response.files[0]);
                    };
                    scope.fileCtrl.uploader.onCompleteAll = function() {
                        console.info('Complete all files upload');
                    };
                    
                    
                    //Puede setear hasta 3 niveles de scope.
                    var setAttrToScopeValue = function (attr, value) {
                        
                        var ret = {};

                        xmodel_arr = attr.split(".");
                        if (xmodel_arr.length > 1) {
                            if (xmodel_arr.length > 2)
                                ret = scope[xmodel_arr[0]][xmodel_arr[1]][xmodel_arr[2]];
                            else
                                ret = scope[xmodel_arr[0]][xmodel_arr[1]];
                        } else {
                            ret = scope[attrs.xmodel];
                        }

                        if (Array.isArray(ret)) {
                            var long = ret.length;
                            ret[long] = value;
                        } else {
                            if (xmodel_arr.length > 1) {
                                if (xmodel_arr.length > 2)
                                    scope[xmodel_arr[0]][xmodel_arr[1]][xmodel_arr[2]] = value;
                                else
                                    scope[xmodel_arr[0]][xmodel_arr[1]] = value;
                            } else {
                                scope[attrs.xmodel] = value;
                            }
                        }
                    };
                };
                
                function fileUploadCtrl (){
                    this.uploader = new FileUploader();
                }
                
                return {
                    restrict: 'E',
                    templateUrl: function (elem, attrs) {
                        return 'app/views/common/angleFileUpload.html';
                    },
                    controller: fileUploadCtrl,
                    controllerAs: "fileCtrl",
                    link: link
                };
        }])
        .directive('filestyle', function  () {
            var directive = {
                link: link,
                restrict: 'A'
            };
            return directive;

            function link(scope, element) {
              var options = element.data();

              // old usage support
              options.classInput = element.data('classinput') || options.classInput;

              element.filestyle(options);
            }
        })
        .directive("fileUploadList",['ngDialog','$modal', function (ngDialog, $modal){
                
                var _scope; 
        
                function link (scope, element, attrs){   
                    _scope = scope;
                    var _updatedList = [];
                    if (typeof (attrs.modellist) !== "undefined"){
                        var xmodel_arr = attrs.modellist.split(".");
                        if (xmodel_arr.length > 1) {
                            if (xmodel_arr.length > 2)
                                scope.$watch(attrs.modellist, function() {
                                    scope.fileListCtrl.attachmentList = scope[xmodel_arr[0]][xmodel_arr[1]][xmodel_arr[2]];
                                });                           
                            else{
                                scope.$watch(attrs.modellist, function() {
                                    scope.fileListCtrl.attachmentList = scope[xmodel_arr[0]][xmodel_arr[1]];
                                });
                            }
                        } else {
                            scope.$watch(attrs.modellist, function() {
                                scope.fileListCtrl.attachmentList= scope[attrs.xmodel] ;
                            });
                        }
                    }
                    
                }
                
                function fileUploadListCtrl ($scope){
                    var vm = this;
                    vm.attachmentList = [];
                    
                    vm.showCarousel = function(atta, index){
                        $scope.modalInstance = $modal.open({
                            templateUrl: "app/views/common/fileUploadList_modal.html",
                            //size:'lg',                            
                            scope: $scope,
                            animation: true
                        });
                        vm.attachmentList[index].active = true;
                    };
                    
                    vm.borrarAttachment = function (attach) {
                        attach.__delete = true;
                    };
                    
                    vm.selectImg = function(attach){
                        var url = attach.url;
                        var fotos = ["jpg", "png", "gif"];
                        var extencion = attach.name.split('.')[attach.name.split('.').length - 1].toLowerCase();    
                        if($.inArray(extencion, fotos) === -1){
                            url = "app/img/documentoGenerico.png";
                            if(extencion === "txt" || extencion === "doc") url = "app/img/documentoTexto.png";
                            if(extencion === "xls") url = "app/img/documentoXls.png";
                        }
                        return url;
                    };
                    
                    vm.openAttach = function(url){
                        window.open(url, '_blank');
                    }
                    
                }
                
                return {
                    restrict: 'E',
                    templateUrl: function(){return 'app/views/common/fileUploadList.html';},
                    link: link,                    
                    controller: fileUploadListCtrl,
                    controllerAs: "fileListCtrl"
                };
        }])
        ;
        


})();
*/
(function () {

    angular.module('simple-form')
    .directive('checkboxList',["$parse",function($parse){
        
        function checkboxCtrl(){
        }

        return{
            restrict: 'E',
            templateUrl: function (elem, attrs) {
            return 'app/views/common/checkboxList.html';
            },
            controller: checkboxCtrl,
            controllerAs:'checkboxCtrl',
            link: function(scope, element, attrs, ctrl){
                ctrl.buttonList = $parse(attrs.buttonlist)(scope);
            }
        };
    }]);

})();
(function () {

    angular.module('simple-form')
    .directive('focus', ["$timeout", function ($timeout) {
        return {
            scope: {trigger: '@focus'},
            link: function (scope, element) {
                var elem = element[0];
                scope.$watch('trigger', function (value) {
                    if (value === "focus") {
                        $timeout(function () {
                            elem.focus();
                        });
                    }
                });
            }
        };
    }]);

})();
(function () {

    angular.module('simple-form')
    .directive('selectOnClick', ['$window', function ($window) {
        return {
            restrict: 'A',
            link: function (scope, element, attrs) {
                element.on('click', function () {
                    if (!$window.getSelection().toString()) {
                        // Required for mobile Safari
                        this.setSelectionRange(0, this.value.length);
                    }
                });
            }
        };
    }]);

})();
(function () {

    angular.module('simple-form')
    .directive('selectTextOnfocus',[function(){
        return{
            restrict: 'A',
            require: 'ngModel',
            link: function(scope, element, attrs, ngModel){
                element[0].onfocus = function(e){
                    var input = $(this);
                    setTimeout(function () { input.select(); });
                }
            }
        };
    }]);

})();
(function () {

    angular.module('simple-form')
    .directive('serverValidation',["$compile",function($compile){
        return {
            restrict: 'A',
            require: 'ngModel',
            link: function(scope, element, attrs, ngModel){
                var form = element[0].form;
                var form_name = $(form)[0].name;
                var input_name = ngModel.$name;

                var elem = angular.element('<small ng-show="'+form_name+'.$submitted && '+form_name+'.'+input_name+'.$untouched" class="text-danger">{{ '+form_name+'.'+input_name+'.$error.serverError }}</small>');
                elem.insertAfter(element);
                $compile(elem)(scope);
            }
        };
    }]);

})();
(function () {

    angular.module('simple-form')
        .factory('SimpleForm', ['$location', function ($location) {

            var _form = new Form($location);

            this.serverValidation = function(entity){

            }

            return {
                setEntity: function (entityName) {
                    _form.entity = entityName;
                },
                setEntityId: function (entityId) {
                    _form.entityId = entityId;
                },
                getForm: function () {
                    return _form;
                },
                getEntity: function () {
                    return _form.entity;
                },
                setGrantedOperations: function (array) {
                    _form.grantedOperations = array;
                }
            };

        }]);

    Form = function (location) {

        this.base_url = $("base").attr("href");
        this._entity;
        this.entityLocationKey;
        this.listUrl;
        this.listPath;

        this._entityId;
        this.relativeformPath;
        this.newform = false;

        this._grantedOperations;
        this.showBtnSave = true;
        this.showBtnDelete = true;
        this.showBtnCancel = true;

        Object.defineProperty(this, "grantedOperations", {
            get: function () {
                return this._grantedOperations;
            },
            set: function (array) {
                if (typeof (array) !== "undefined") {
                    this._grantedOperations = array;
                    this.showBtnSave = true;
                    this.showBtnDelete = true;
                    this.showBtnCancel = true;

                    if (this._grantedOperations.indexOf("update") === -1)
                        this.showBtnSave = false;
                    if (this._grantedOperations.indexOf("delete") === -1)
                        this.showBtnDelete = false;
                    if (this._grantedOperations.indexOf("cancel") === -1)
                        this.showBtnCancel = false;
                }
            }
        });

        Object.defineProperty(this, "entity", {
            get: function () {
                return this._entity;
            },
            set: function (entity) {
                this._entity = entity;
                this.entityLocationKey = entity;// + "Ext";
                // this.listUrl = this.base_url + "/" + this._entity;
                this.listUrl = this.base_url + "/#/app/" + this._entity + "List";
                this.listPath = "app/" + this._entity + "List";

                var path_arr = location.path().split("/");
                if (path_arr.length > 1)
                    this._entityId = path_arr[path_arr.length - 1];
                // this._entityId = routeParams.id;

                this.newform = false;
                if (this._entityId === "new")
                    this.newform = true;

                  this.showBtnSave = true;
                  this.showBtnDelete = true;
                  this.showBtnCancel = true;

            }
        });


        Object.defineProperty(this, "entityId", {
            get: function () {
                return this._entityId;
            },
            set: function (entityId) {
                this._entityId = entityId;
                this.relativeformPath = this.entityLocationKey + "/" + this._entityId;
                this.newform = false;
                if (this._entityId === "new")
                    this.newform = true;

            }
        });

    };

})();
/**=========================================================
 * Module: UIGridUtils
 =========================================================*/

(function () {

    angular.module('ui-grid-utils')
    .directive('showEmptyMsg', showEmptyMsg);

    showEmptyMsg.$inject = ['$compile','$timeout'];

    function showEmptyMsg ($compile, $timeout) {
        return {
            restrict: 'A',
            link: function (scope, element, attrs) {
                var msg = (attrs.showEmptyMsg) ? attrs.showEmptyMsg : 'sin datos';
                var _showCondition_noData = "'" + attrs.uiGrid + ".data.length==0 && !data_loading && !data_error '";
                var template = "<div ng class='grid-feedback-msg grid-feedback-nodata-msg' ng-show=" + _showCondition_noData + ">" +
                               "<p class='watermark' >" + msg + "</p>"+
                               "</div>";
                var tmpl = angular.element(template);
                $compile(tmpl)(scope);
                $timeout(function () {
                    element.find('.ui-grid-viewport').append(tmpl);
                });
            }
        };
    };

})();
/**=========================================================
 * Module: UIGridUtils
 =========================================================*/

(function () {

    angular.module('ui-grid-utils')
    .directive('showErrorMsg',showErrorMsg);

    showErrorMsg.$inject = ['$compile','$timeout', '$parse'];
    
    function showErrorMsg ($compile, $timeout, $parse){
        return {
            restrict: 'A',   
            link: function (scope,element,attrs) {
                if (! attrs.errorMsgVarname)
                    attrs.errorMsgVarname = "data_error_msg";
                var template = "<div ng-show='data_error' class='grid-feedback-msg grid-feedback-error-msg'>"
					+ "<p class='watermark' >{{" + attrs.errorMsgVarname + "}} </p>"
					+ "</div>";
                                
                var error_txt = $parse(attrs.errorMsgVarname);

                scope.$watch(attrs.errorMsgVarname, function(newValue, oldValue) {
                    if (typeof(newValue) !== 'undefined' && newValue.length === 0)
                        error_txt.assign(scope, "Error");
                });

                var tmpl = angular.element(template);
                $compile(tmpl)(scope);
                $timeout(function () {
                    element.find('.ui-grid-viewport').append(tmpl);
                });
            }
        };
    }

/** function showErrorMsg ($compile, $timeout, $parse){
        return {
            restrict: 'A',
            link: function (scope,element,attrs) {
                if (! attrs.errorMsgVarname)
                    attrs.errorMsgVarname = "data_error_msg";
                var template = "<div ng-show='data_error' class='prueba'>"
					+ "<p class='watermark' >{{" + attrs.errorMsgVarname + "}} </p>"
					+ "</div>";
                var error_txt = $parse(attrs.errorMsgVarname);

                scope.$watch(attrs.errorMsgVarname, function(newValue, oldValue) {
                    if (typeof(newValue) !== 'undefined' && newValue.length === 0)
                        error_txt.assign(scope, "Error");
                });

                var tmpl = angular.element(template);
                $compile(tmpl)(scope);
                $timeout(function () {
                    element.find('.ui-grid-viewport').append(tmpl);
                });
            }
        };
    } */

})();
/**=========================================================
 * Module: UIGridUtils
 =========================================================*/

(function () {

    angular.module('ui-grid-utils')
    .directive('showLoadingMsg',showLoadingMsg);

    showLoadingMsg.$inject = ['$compile','$timeout'];

    function showLoadingMsg ($compile, $timeout){
        return {
            restrict: 'A',
            link: function (scope,element,attrs) {
                var sk_circle_div = "";
                for(var i=1;i<=12;i++){
                    sk_circle_div += "<div class='sk-circle"+i+" sk-circle'></div>";
                }
                var template = "<div ng-show='data_loading' class='grid-feedback-msg grid-feedback-loading-msg'>"
                                    +"<p class='watermark' >cargando </p>"
                                    +"<div class='sk-spinner sk-spinner-fading-circle'>"+sk_circle_div+"</div>"
				+"</div>";
                        
                var tmpl = angular.element(template);
                $compile(tmpl)(scope);
                $timeout(function () {
                    element.find('.ui-grid-viewport').append(tmpl);
                });
            }
        };
    };

})();